=== modified file 'client/drizzle.cc'
--- client/drizzle.cc	2008-10-06 05:57:49 +0000
+++ client/drizzle.cc	2008-10-07 04:51:08 +0000
@@ -2867,6 +2867,7 @@
     case DRIZZLE_TYPE_TIME:        return "TIME";
     case DRIZZLE_TYPE_TIMESTAMP:   return "TIMESTAMP";
     case DRIZZLE_TYPE_TINY:        return "TINY";
+    case DRIZZLE_TYPE_VIRTUAL:     return "VIRTUAL";
     default:                     return "?-unknown-?";
   }
 }

=== modified file 'client/drizzletest.cc'
--- client/drizzletest.cc	2008-10-06 22:46:47 +0000
+++ client/drizzletest.cc	2008-10-07 04:51:08 +0000
@@ -227,7 +227,7 @@
   Q_DISPLAY_VERTICAL_RESULTS, Q_DISPLAY_HORIZONTAL_RESULTS,
   Q_QUERY_VERTICAL, Q_QUERY_HORIZONTAL, Q_SORTED_RESULT,
   Q_START_TIMER, Q_END_TIMER,
-  Q_CHARACTER_SET, Q_DISABLE_PS_PROTOCOL, Q_ENABLE_PS_PROTOCOL,
+  Q_CHARACTER_SET, 
   Q_DISABLE_RECONNECT, Q_ENABLE_RECONNECT,
   Q_IF,
   Q_DISABLE_PARSING, Q_ENABLE_PARSING,

=== modified file 'client/errname.h'
--- client/errname.h	2008-07-30 18:03:54 +0000
+++ client/errname.h	2008-09-19 11:49:17 +0000
@@ -703,6 +703,15 @@
   { "ER_BACKUP_LOG_WRITE_ERROR", 1670 },
   { "ER_TABLESPACE_NOT_EMPTY", 1671 },
   { "ER_BACKUP_TS_CHANGE", 1672 },
+  { "ER_VCOL_BASED_ON_VCOL", 1673 },
+  { "ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED", 1674 },
+  { "ER_DATA_CONVERSION_ERROR_FOR_VIRTUAL_COLUMN", 1675 },
+  { "ER_PRIMARY_KEY_BASED_ON_VIRTUAL_COLUMN", 1676 },
+  { "ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN", 1677 },
+  { "ER_WRONG_FK_OPTION_FOR_VIRTUAL_COLUMN", 1678 },
+  { "ER_WARNING_NON_DEFAULT_VALUE_FOR_VIRTUAL_COLUMN", 1679 },
+  { "ER_UNSUPPORTED_ACTION_ON_VIRTUAL_COLUMN", 1680 },
+  { "ER_CONST_EXPR_IN_VCOL", 1681 },
   { 0, 0 }
 };
 

=== modified file 'drizzled/drizzled_error_messages.h'
--- drizzled/drizzled_error_messages.h	2008-09-16 00:00:48 +0000
+++ drizzled/drizzled_error_messages.h	2008-10-07 04:51:08 +0000
@@ -1372,7 +1372,25 @@
 /* ER_TABLESPACE_NOT_EMPTY */
 N_("Tablespace '%-.192s' not empty"),
 /* ER_BACKUP_TS_CHANGE */
-N_("Tablespace `%-.64s` needed by tables being restored has changed on the server. The original definition of the required tablespace is '%-.256s' while the same tablespace is defined on the server as '%-.256s'")
+N_("Tablespace `%-.64s` needed by tables being restored has changed on the server. The original definition of the required tablespace is '%-.256s' while the same tablespace is defined on the server as '%-.256s'"),
+/* ER_VCOL_BASED_ON_VCOL */
+N_("A virtual column cannot be based on a virtual column"),
+/* ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED */
+N_("Non-deterministic expression for virtual column '%s'."),
+/* ER_DATA_CONVERSION_ERROR_FOR_VIRTUAL_COLUMN */
+N_("Generated value for virtual column '%s' cannot be converted to type '%s'."),
+/* ER_PRIMARY_KEY_BASED_ON_VIRTUAL_COLUMN */
+N_("Primary key cannot be defined upon a virtual column."),
+/* ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN */
+N_("Key/Index cannot be defined on a non-stored virtual column."),
+/* ER_WRONG_FK_OPTION_FOR_VIRTUAL_COLUMN */
+N_("Cannot define foreign key with %s clause on a virtual column."),
+/* ER_WARNING_NON_DEFAULT_VALUE_FOR_VIRTUAL_COLUMN */
+N_("The value specified for virtual column '%s' in table '%s' ignored."),
+/* ER_UNSUPPORTED_ACTION_ON_VIRTUAL_COLUMN */
+N_("'%s' is not yet supported for virtual columns."),
+/* ER_CONST_EXPR_IN_VCOL */
+N_("Constant expression in virtual column function is not allowed.")
 };
 
 #endif

=== modified file 'drizzled/error.h'
--- drizzled/error.h	2008-09-22 23:10:45 +0000
+++ drizzled/error.h	2008-10-07 04:51:08 +0000
@@ -697,7 +697,16 @@
   ER_BACKUP_LOG_WRITE_ERROR,
   ER_TABLESPACE_NOT_EMPTY,
   ER_BACKUP_TS_CHANGE,
-  ER_ERROR_LAST= ER_BACKUP_TS_CHANGE
+  ER_VCOL_BASED_ON_VCOL,
+  ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED,
+  ER_DATA_CONVERSION_ERROR_FOR_VIRTUAL_COLUMN,
+  ER_PRIMARY_KEY_BASED_ON_VIRTUAL_COLUMN,
+  ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN,
+  ER_WRONG_FK_OPTION_FOR_VIRTUAL_COLUMN,
+  ER_WARNING_NON_DEFAULT_VALUE_FOR_VIRTUAL_COLUMN,
+  ER_UNSUPPORTED_ACTION_ON_VIRTUAL_COLUMN,
+  ER_CONST_EXPR_IN_VCOL,
+  ER_ERROR_LAST= ER_CONST_EXPR_IN_VCOL
 };
 
 #endif

=== modified file 'drizzled/field.cc'
--- drizzled/field.cc	2008-10-06 05:57:49 +0000
+++ drizzled/field.cc	2008-10-07 04:51:08 +0000
@@ -46,7 +46,7 @@
   and index of field in thia array.
 */
 #define FIELDTYPE_TEAR_FROM (DRIZZLE_TYPE_VARCHAR + 1)
-#define FIELDTYPE_TEAR_TO   (DRIZZLE_TYPE_NEWDECIMAL - 1)
+#define FIELDTYPE_TEAR_TO   (DRIZZLE_TYPE_VIRTUAL - 1)
 #define FIELDTYPE_NUM (FIELDTYPE_TEAR_FROM + (255 - FIELDTYPE_TEAR_TO))
 inline int field_type2index (enum_field_types field_type)
 {
@@ -76,6 +76,8 @@
     DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
     DRIZZLE_TYPE_VARCHAR,     DRIZZLE_TYPE_VARCHAR,
+  // DRIZZLE_TYPE_VIRTUAL
+    DRIZZLE_TYPE_VIRTUAL,
   //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
     DRIZZLE_TYPE_NEWDECIMAL,  DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_BLOB
@@ -99,6 +101,8 @@
     DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
     DRIZZLE_TYPE_VARCHAR,     DRIZZLE_TYPE_VARCHAR,
+  // DRIZZLE_TYPE_VIRTUAL
+    DRIZZLE_TYPE_VIRTUAL,
   //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
     DRIZZLE_TYPE_NEWDECIMAL,  DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_BLOB
@@ -122,6 +126,8 @@
     DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
     DRIZZLE_TYPE_VARCHAR,     DRIZZLE_TYPE_VARCHAR,
+  // DRIZZLE_TYPE_VIRTUAL
+    DRIZZLE_TYPE_VIRTUAL,
   //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
     DRIZZLE_TYPE_NEWDECIMAL,  DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_BLOB
@@ -145,6 +151,8 @@
     DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
     DRIZZLE_TYPE_VARCHAR,     DRIZZLE_TYPE_VARCHAR,
+  // DRIZZLE_TYPE_VIRTUAL
+    DRIZZLE_TYPE_VIRTUAL,
   //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
     DRIZZLE_TYPE_DOUBLE,      DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_BLOB
@@ -168,6 +176,8 @@
     DRIZZLE_TYPE_DATETIME,
   //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
     DRIZZLE_TYPE_NEWDATE,     DRIZZLE_TYPE_VARCHAR,
+  // DRIZZLE_TYPE_VIRTUAL
+    DRIZZLE_TYPE_VIRTUAL,
   //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
     DRIZZLE_TYPE_NEWDECIMAL,  DRIZZLE_TYPE_ENUM,
   //DRIZZLE_TYPE_BLOB
@@ -191,6 +201,8 @@
     DRIZZLE_TYPE_DATETIME,
   //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
     DRIZZLE_TYPE_NEWDATE,     DRIZZLE_TYPE_VARCHAR,
+  // DRIZZLE_TYPE_VIRTUAL
+    DRIZZLE_TYPE_VIRTUAL,
   //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
     DRIZZLE_TYPE_VARCHAR,     DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_BLOB
@@ -214,6 +226,8 @@
     DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
     DRIZZLE_TYPE_NEWDATE,     DRIZZLE_TYPE_VARCHAR,
+  // DRIZZLE_TYPE_VIRTUAL
+    DRIZZLE_TYPE_VIRTUAL,
   //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
     DRIZZLE_TYPE_NEWDECIMAL,  DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_BLOB
@@ -237,6 +251,8 @@
     DRIZZLE_TYPE_DATETIME,
   //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
     DRIZZLE_TYPE_NEWDATE,     DRIZZLE_TYPE_VARCHAR,
+  // DRIZZLE_TYPE_VIRTUAL
+    DRIZZLE_TYPE_VIRTUAL,
   //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
     DRIZZLE_TYPE_VARCHAR,     DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_BLOB
@@ -260,6 +276,8 @@
     DRIZZLE_TYPE_DATETIME,
   //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
     DRIZZLE_TYPE_NEWDATE,     DRIZZLE_TYPE_VARCHAR,
+  // DRIZZLE_TYPE_VIRTUAL
+    DRIZZLE_TYPE_VIRTUAL,
   //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
     DRIZZLE_TYPE_VARCHAR,     DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_BLOB
@@ -283,6 +301,8 @@
     DRIZZLE_TYPE_DATETIME,
   //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
     DRIZZLE_TYPE_NEWDATE,     DRIZZLE_TYPE_VARCHAR,
+  // DRIZZLE_TYPE_VIRTUAL
+    DRIZZLE_TYPE_VIRTUAL,
   //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
     DRIZZLE_TYPE_VARCHAR,     DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_BLOB
@@ -306,11 +326,38 @@
     DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
     DRIZZLE_TYPE_VARCHAR,     DRIZZLE_TYPE_VARCHAR,
+  // DRIZZLE_TYPE_VIRTUAL
+    DRIZZLE_TYPE_VIRTUAL,
   //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
     DRIZZLE_TYPE_VARCHAR,     DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_BLOB
     DRIZZLE_TYPE_BLOB,
   },
+  /* DRIZZLE_TYPE_VIRTUAL -> */
+  {
+  //DRIZZLE_TYPE_DECIMAL      DRIZZLE_TYPE_TINY
+    DRIZZLE_TYPE_VIRTUAL,  DRIZZLE_TYPE_VIRTUAL,
+  //DRIZZLE_TYPE_LONG
+    DRIZZLE_TYPE_VIRTUAL,
+  //DRIZZLE_TYPE_DOUBLE
+    DRIZZLE_TYPE_VIRTUAL,
+  //DRIZZLE_TYPE_NULL         DRIZZLE_TYPE_TIMESTAMP
+    DRIZZLE_TYPE_VIRTUAL,  DRIZZLE_TYPE_VIRTUAL,
+  //DRIZZLE_TYPE_LONGLONG
+    DRIZZLE_TYPE_VIRTUAL,
+  //DRIZZLE_TYPE_TIME
+    DRIZZLE_TYPE_VIRTUAL,
+  //DRIZZLE_TYPE_DATETIME
+    DRIZZLE_TYPE_VIRTUAL,
+  //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
+    DRIZZLE_TYPE_VIRTUAL,     DRIZZLE_TYPE_VIRTUAL,
+  // DRIZZLE_TYPE_VIRTUAL
+    DRIZZLE_TYPE_VIRTUAL,
+  //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
+    DRIZZLE_TYPE_VIRTUAL,  DRIZZLE_TYPE_VIRTUAL,
+  //DRIZZLE_TYPE_BLOB
+    DRIZZLE_TYPE_VIRTUAL,
+  },
   /* DRIZZLE_TYPE_NEWDECIMAL -> */
   {
   //DRIZZLE_TYPE_DECIMAL      DRIZZLE_TYPE_TINY
@@ -329,6 +376,8 @@
     DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
     DRIZZLE_TYPE_VARCHAR,     DRIZZLE_TYPE_VARCHAR,
+  // DRIZZLE_TYPE_VIRTUAL
+    DRIZZLE_TYPE_VIRTUAL,
   //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
     DRIZZLE_TYPE_NEWDECIMAL,  DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_BLOB
@@ -352,6 +401,8 @@
     DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
     DRIZZLE_TYPE_VARCHAR,     DRIZZLE_TYPE_VARCHAR,
+  // DRIZZLE_TYPE_VIRTUAL
+    DRIZZLE_TYPE_VIRTUAL,
   //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
     DRIZZLE_TYPE_VARCHAR,     DRIZZLE_TYPE_VARCHAR,
   //DRIZZLE_TYPE_BLOB
@@ -375,6 +426,8 @@
     DRIZZLE_TYPE_BLOB,
   //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
     DRIZZLE_TYPE_BLOB,        DRIZZLE_TYPE_BLOB,
+  // DRIZZLE_TYPE_VIRTUAL
+    DRIZZLE_TYPE_VIRTUAL,
   //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
     DRIZZLE_TYPE_BLOB,        DRIZZLE_TYPE_BLOB,
   //DRIZZLE_TYPE_BLOB
@@ -420,6 +473,8 @@
   STRING_RESULT,
   //DRIZZLE_TYPE_NEWDATE      DRIZZLE_TYPE_VARCHAR
   STRING_RESULT,            STRING_RESULT,
+  //DRIZZLE_TYPE_VIRTUAL
+  STRING_RESULT,
   //DRIZZLE_TYPE_NEWDECIMAL   DRIZZLE_TYPE_ENUM
   DECIMAL_RESULT,           STRING_RESULT,
   //DRIZZLE_TYPE_BLOB
@@ -745,7 +800,8 @@
    key_start(0), part_of_key(0), part_of_key_not_clustered(0),
    part_of_sortkey(0), unireg_check(unireg_check_arg),
    field_length(length_arg), null_bit(null_bit_arg), 
-   is_created_from_null_item(false)
+   is_created_from_null_item(false),
+   vcol_info(NULL), is_stored(true)
 {
   flags=null_ptr ? 0: NOT_NULL_FLAG;
   comment.str= (char*) "";
@@ -1723,6 +1779,8 @@
               ((decimals_arg & FIELDFLAG_MAX_DEC) << FIELDFLAG_DEC_SHIFT) |
               (maybe_null ? FIELDFLAG_MAYBE_NULL : 0) |
               (is_unsigned ? 0 : FIELDFLAG_DECIMAL));
+  vcol_info= NULL;
+  is_stored= true;
 }
 
 
@@ -1741,6 +1799,7 @@
   @param fld_change            Field change
   @param fld_interval_list     Interval list (if any)
   @param fld_charset           Field charset
+  @param fld_vcol_info         Virtual column data
 
   @retval
     false on success
@@ -1755,7 +1814,8 @@
                         char *fld_change, List<String> *fld_interval_list,
                         const CHARSET_INFO * const fld_charset,
                         uint32_t fld_geom_type __attribute__((unused)),
-                        enum column_format_type column_format)
+                        enum column_format_type column_format,
+                        virtual_column_info *fld_vcol_info)
 {
   uint32_t sign_len, allowed_type_modifier= 0;
   uint32_t max_field_charlength= MAX_FIELD_CHARLENGTH;
@@ -1784,6 +1844,56 @@
   interval_list.empty();
 
   comment= *fld_comment;
+  vcol_info= fld_vcol_info;
+  is_stored= true;
+
+  /* Initialize data for a virtual field */
+  if (fld_type == DRIZZLE_TYPE_VIRTUAL)
+  {
+    assert(vcol_info && vcol_info->expr_item);
+    is_stored= vcol_info->get_field_stored();
+    /*
+      Perform per item-type checks to determine if the expression is 
+      allowed for a virtual column.
+      Note that validation of the specific function is done later in
+      procedures open_table_from_share and fix_fields_vcol_func
+    */
+    switch (vcol_info->expr_item->type()) {
+    case Item::FUNC_ITEM:
+         if (((Item_func *)vcol_info->expr_item)->functype() == Item_func::FUNC_SP)
+         {
+           my_error(ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED, MYF(0), field_name);
+           return(true);
+         }
+         break;
+    case Item::COPY_STR_ITEM:
+    case Item::FIELD_AVG_ITEM:
+    case Item::PROC_ITEM:
+    case Item::REF_ITEM:
+    case Item::FIELD_STD_ITEM:
+    case Item::FIELD_VARIANCE_ITEM:
+    case Item::INSERT_VALUE_ITEM:
+    case Item::SUBSELECT_ITEM:
+    case Item::CACHE_ITEM:
+    case Item::TYPE_HOLDER:
+    case Item::PARAM_ITEM:
+    case Item::VIEW_FIXER_ITEM: 
+         my_error(ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED, MYF(0), field_name);
+         return true;
+         break;
+    default: 
+      // Continue with the field creation
+      break;
+    }
+    /*
+      Make a field created for the real type.
+      Note that "real" and virtual fields differ from each other
+      only by Field::vcol_info, which is always 0 for normal columns.
+      vcol_info is updated for fields later in procedure open_binary_frm.
+    */
+    sql_type= fld_type= vcol_info->get_real_type();
+  }
+
   /*
     Set NO_DEFAULT_VALUE_FLAG if this field doesn't have a default value and
     it is NOT NULL, not an AUTO_INCREMENT field and not a TIMESTAMP.
@@ -1938,6 +2048,8 @@
       length= 1; /* See comment for DRIZZLE_TYPE_SET above. */
       break;
    }
+  case DRIZZLE_TYPE_VIRTUAL: // Must not happen
+    assert(0);
   }
   /* Remember the value of length */
   char_length= length;
@@ -2117,6 +2229,8 @@
   case DRIZZLE_TYPE_NULL:
     return new Field_null(ptr, field_length, unireg_check, field_name,
                           field_charset);
+  case DRIZZLE_TYPE_VIRTUAL:                    // Must not happen
+    assert(0);
   default:					// Impossible (Wrong version)
     break;
   }
@@ -2139,6 +2253,8 @@
   charset=    old_field->charset();		// May be NULL ptr
   comment=    old_field->comment;
   decimals=   old_field->decimals();
+  vcol_info=  old_field->vcol_info;
+  is_stored= old_field->is_stored;
 
   /* Fix if the original table had 4 byte pointer blobs */
   if (flags & BLOB_FLAG)

=== modified file 'drizzled/field.h'
--- drizzled/field.h	2008-10-06 22:06:09 +0000
+++ drizzled/field.h	2008-10-07 04:51:08 +0000
@@ -48,6 +48,57 @@
   return len > 4 ? 8 : len;
 }
 
+class virtual_column_info: public Sql_alloc
+{
+public:
+  Item *expr_item;
+  LEX_STRING expr_str;
+  Item *item_free_list;
+  virtual_column_info() 
+  : expr_item(0), item_free_list(0),
+    field_type(DRIZZLE_TYPE_VIRTUAL),
+    is_stored(false), data_inited(false)
+  {
+    expr_str.str= NULL;
+    expr_str.length= 0;
+  };
+  ~virtual_column_info() {}
+  enum_field_types get_real_type()
+  {
+    assert(data_inited);
+    return data_inited ? field_type : DRIZZLE_TYPE_VIRTUAL;
+  }
+  void set_field_type(enum_field_types fld_type)
+  {
+    /* Calling this function can only be done once. */
+    assert(not data_inited);
+    data_inited= true;
+    field_type= fld_type;
+  }
+  bool get_field_stored()
+  {
+    assert(data_inited);
+    return data_inited ? is_stored : true;
+  }
+  void set_field_stored(bool stored)
+  {
+    is_stored= stored;
+  }
+private:
+  /*
+    The following data is only updated by the parser and read
+    when a Create_field object is created/initialized.
+  */
+  enum_field_types field_type;   /* Real field type*/
+  bool is_stored;             /* Indication that the field is 
+                                    phisically stored in the database*/
+  /*
+    This flag is used to prevent other applications from
+    reading and using incorrect data.
+  */
+  bool data_inited; 
+};
+
 class Field
 {
   Field(const Item &);				/* Prevent use of these */
@@ -101,6 +152,15 @@
    */
   bool is_created_from_null_item;
 
+  /* Virtual column data */
+  virtual_column_info *vcol_info;
+  /*
+    Indication that the field is phycically stored in tables 
+    rather than just generated on SQL queries.
+    As of now, false can only be set for generated-only virtual columns.
+  */
+  bool is_stored;
+
   Field(unsigned char *ptr_arg,uint32_t length_arg,unsigned char *null_ptr_arg,
         unsigned char null_bit_arg, utype unireg_check_arg,
         const char *field_name_arg);
@@ -699,6 +759,16 @@
 
   uint8_t row,col,sc_length,interval_id;	// For rea_create_table
   uint32_t	offset,pack_flag;
+
+  /* Virtual column expression statement */
+  virtual_column_info *vcol_info;
+  /*
+    Indication that the field is phycically stored in tables 
+    rather than just generated on SQL queries.
+    As of now, FALSE can only be set for generated-only virtual columns.
+  */
+  bool is_stored;
+
   Create_field() :after(0) {}
   Create_field(Field *field, Field *orig_field);
   /* Used to make a clone of this object for ALTER/CREATE TABLE */
@@ -722,7 +792,8 @@
             Item *on_update_value, LEX_STRING *comment, char *change,
             List<String> *interval_list, const CHARSET_INFO * const cs,
             uint32_t uint_geom_type,
-            enum column_format_type column_format);
+            enum column_format_type column_format,
+            virtual_column_info *vcol_info);
 };
 
 

=== modified file 'drizzled/filesort.cc'
--- drizzled/filesort.cc	2008-10-06 08:07:52 +0000
+++ drizzled/filesort.cc	2008-10-07 04:51:08 +0000
@@ -517,6 +517,9 @@
       else
       {
 	error=file->rnd_next(sort_form->record[0]);
+        if (!error)
+          update_virtual_fields_marked_for_write(sort_form);
+
 	if (!flag)
 	{
 	  my_store_ptr(ref_pos,ref_length,record); // Position to row

=== modified file 'drizzled/handler.h'
--- drizzled/handler.h	2008-10-06 06:47:29 +0000
+++ drizzled/handler.h	2008-10-07 04:51:08 +0000
@@ -51,7 +51,7 @@
 /* Bits to show what an alter table will do */
 #include <drizzled/sql_bitmap.h>
 
-#define HA_MAX_ALTER_FLAGS 39
+#define HA_MAX_ALTER_FLAGS 40
 typedef Bitmap<HA_MAX_ALTER_FLAGS> HA_ALTER_FLAGS;
 
 #define HA_ADD_INDEX                  (0)
@@ -88,6 +88,7 @@
 #define HA_RENAME_TABLE               (36)
 #define HA_ALTER_STORAGE_ENGINE       (37)
 #define HA_RECREATE                   (38)
+#define HA_ALTER_STORED_VCOL          (39)
 /* Remember to increase HA_MAX_ALTER_FLAGS when adding more flags! */
 
 /* Return values for check_if_supported_alter */
@@ -1804,6 +1805,8 @@
    if (this->check_if_incompatible_data(create_info, table_changes)
        == COMPATIBLE_DATA_NO)
      return(HA_ALTER_NOT_SUPPORTED);
+   else if ((*alter_flags & HA_ALTER_STORED_VCOL).is_set())
+     return(HA_ALTER_NOT_SUPPORTED);
    else
      return(HA_ALTER_SUPPORTED_WAIT_LOCK);
  }
@@ -1904,6 +1907,12 @@
   {
     return HA_ERR_WRONG_COMMAND;
   }
+  /*
+    This procedure defines if the storage engine supports virtual columns.
+    Default false means "not supported".
+  */
+  virtual bool check_if_supported_virtual_columns(void) 
+  { return false; }
 
 protected:
   /* Service methods for use by storage engines. */

=== modified file 'drizzled/item.cc'
--- drizzled/item.cc	2008-10-06 06:47:29 +0000
+++ drizzled/item.cc	2008-10-07 04:51:08 +0000
@@ -666,9 +666,25 @@
   Table *table= (Table *) arg;
   if (field->table == table || !table)
     bitmap_set_bit(field->table->read_set, field->field_index);
+  if (field->vcol_info && field->vcol_info->expr_item)
+    return field->vcol_info->expr_item->walk(&Item::register_field_in_read_map, 
+                                             1, arg);
   return 0;
 }
 
+/*
+  Mark field in bitmap supplied as *arg
+
+*/
+
+bool Item_field::register_field_in_bitmap(unsigned char *arg)
+{
+  MY_BITMAP *bitmap= (MY_BITMAP *) arg;
+  assert(bitmap);
+  bitmap_set_bit(bitmap, field->field_index);
+  return false;
+}
+
 
 bool Item::check_cols(uint32_t c)
 {

=== modified file 'drizzled/item.h'
--- drizzled/item.h	2008-10-06 06:47:29 +0000
+++ drizzled/item.h	2008-10-07 04:51:08 +0000
@@ -887,6 +887,12 @@
   { return 0; }
   virtual bool register_field_in_read_map(unsigned char *arg __attribute__((unused)))
   { return 0; }
+  /*
+    The next function differs from the previous one that a bitmap to be updated
+    is passed as unsigned char *arg.
+  */
+  virtual bool register_field_in_bitmap(unsigned char *arg __attribute__((unused)))
+  { return 0; }
   virtual bool subst_argument_checker(unsigned char **arg)
   {
     if (*arg)
@@ -894,10 +900,23 @@
     return true;
   }
 
+  /*
+    Check if an expression/function is allowed for a virtual column
+    SYNOPSIS
+      check_vcol_func_processor()
+      arg is just ignored
+    RETURN VALUE
+      TRUE                           Function not accepted
+      FALSE                          Function accepted
+  */
+  virtual bool check_vcol_func_processor(unsigned char *arg __attribute__((unused))) 
+  { return true; }
+
   virtual Item *equal_fields_propagator(unsigned char * arg __attribute__((unused))) { return this; }
   virtual bool set_no_const_sub(unsigned char *arg __attribute__((unused))) { return false; }
   virtual Item *replace_equal_field(unsigned char * arg __attribute__((unused))) { return this; }
 
+
   /*
     For SP local variable returns pointer to Item representing its
     current value and pointer to current Item otherwise.
@@ -1154,6 +1173,9 @@
   bool collect_item_field_processor(unsigned char * arg);
   bool find_item_in_field_list_processor(unsigned char *arg);
   bool register_field_in_read_map(unsigned char *arg);
+  bool register_field_in_bitmap(unsigned char *arg);
+  bool check_vcol_func_processor(unsigned char *arg __attribute__((unused)))
+  { return false; }
   void cleanup();
   bool result_as_int64_t()
   {
@@ -1209,6 +1231,8 @@
   }
 
   Item *safe_charset_converter(const CHARSET_INFO * const tocs);
+  bool check_vcol_func_processor(unsigned char *arg __attribute__((unused)))
+  { return false; }
 };
 
 class Item_null_result :public Item_null
@@ -1221,6 +1245,8 @@
   {
     save_in_field(result_field, no_conversions);
   }
+  bool check_vcol_func_processor(unsigned char *arg __attribute__((unused)))
+  { return true; }
 };  
 
 /* Item represents one placeholder ('?') of prepared statement */
@@ -1396,6 +1422,8 @@
   uint32_t decimal_precision() const
   { return (uint)(max_length - test(value < 0)); }
   bool eq(const Item *, bool binary_cmp) const;
+  bool check_vcol_func_processor(unsigned char *arg __attribute__((unused)))
+  { return false; }
 };
 
 
@@ -1413,6 +1441,8 @@
   virtual void print(String *str, enum_query_type query_type);
   Item_num *neg ();
   uint32_t decimal_precision() const { return max_length; }
+  bool check_vcol_func_processor(unsigned char *arg __attribute__((unused)))
+  { return false; }
 };
 
 
@@ -1454,6 +1484,8 @@
   uint32_t decimal_precision() const { return decimal_value.precision(); }
   bool eq(const Item *, bool binary_cmp) const;
   void set_decimal_value(my_decimal *value_par);
+  bool check_vcol_func_processor(unsigned char *arg __attribute__((unused)))
+  { return false; }
 };
 
 
@@ -1521,6 +1553,8 @@
   }
 
   Item *safe_charset_converter(const CHARSET_INFO * const tocs);
+  bool check_vcol_func_processor(unsigned char *arg __attribute__((unused)))
+  { return false; }
 };
 
 
@@ -1650,6 +1684,8 @@
   {
     m_cs_specified= cs_specified;
   }
+  bool check_vcol_func_processor(unsigned char *arg __attribute__((unused)))
+  { return false; }
 
 private:
   bool m_cs_specified;
@@ -1672,6 +1708,8 @@
   {
     str->append(func_name);
   }
+  bool check_vcol_func_processor(unsigned char *arg __attribute__((unused)))
+  { return true; }
 };
 
 
@@ -1751,6 +1789,8 @@
   virtual void print(String *str, enum_query_type query_type);
   bool eq(const Item *item, bool binary_cmp) const;
   virtual Item *safe_charset_converter(const CHARSET_INFO * const tocs);
+  bool check_vcol_func_processor(unsigned char *arg __attribute__((unused)))
+  { return false; }
 };
 
 
@@ -1782,6 +1822,8 @@
     save_in_field(result_field, no_conversions);
   }
   void cleanup();
+  bool check_vcol_func_processor(unsigned char *arg __attribute__((unused)))
+  { return false; }
 };
 
 
@@ -2269,6 +2311,8 @@
     return arg->walk(processor, walk_subquery, args) ||
 	    (this->*processor)(args);
   }
+  bool check_vcol_func_processor(unsigned char *arg __attribute__((unused)))
+  { return true; }
 };
 
 

=== modified file 'drizzled/item_func.cc'
--- drizzled/item_func.cc	2008-10-06 17:35:06 +0000
+++ drizzled/item_func.cc	2008-10-07 04:51:08 +0000
@@ -3040,6 +3040,26 @@
     Table *table= (Table *) arg;
     if (result_field->table == table || !table)
       bitmap_set_bit(result_field->table->read_set, result_field->field_index);
+    if (result_field->vcol_info && result_field->vcol_info->expr_item)
+      return result_field->vcol_info->
+               expr_item->walk(&Item::register_field_in_read_map, 1, arg);
+  }
+  return 0;
+}
+
+
+/*
+  Mark field in bitmap supplied as *arg
+
+*/
+
+bool Item_func_set_user_var::register_field_in_bitmap(unsigned char *arg)
+{
+  MY_BITMAP *bitmap = (MY_BITMAP *) arg;
+  assert(bitmap);
+  if (result_field)
+  {
+    bitmap_set_bit(bitmap, result_field->field_index);
   }
   return 0;
 }

=== modified file 'drizzled/item_func.h'
--- drizzled/item_func.h	2008-10-07 02:53:46 +0000
+++ drizzled/item_func.h	2008-10-07 04:51:08 +0000
@@ -341,6 +341,8 @@
   void fix_length_and_dec();
   bool fix_fields(THD *thd, Item **ref);
   int64_t val_int() { assert(fixed == 1); return value; }
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
 };
 
 
@@ -396,6 +398,8 @@
 public:
   Item_func_additive_op(Item *a,Item *b) :Item_num_op(a,b) {}
   void result_precision();
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return false; }
 };
 
 
@@ -430,6 +434,8 @@
   double real_op();
   my_decimal *decimal_op(my_decimal *);
   void result_precision();
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return false; }
 };
 
 
@@ -460,7 +466,8 @@
   {
     print_op(str, query_type);
   }
-
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return false; }
 };
 
 
@@ -474,6 +481,8 @@
   const char *func_name() const { return "%"; }
   void result_precision();
   void fix_length_and_dec();
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return false; }
 };
 
 
@@ -489,6 +498,8 @@
   void fix_length_and_dec();
   void fix_num_length_and_dec();
   uint32_t decimal_precision() const { return args[0]->decimal_precision(); }
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return false; }
 };
 
 
@@ -501,6 +512,8 @@
   my_decimal *decimal_op(my_decimal *);
   const char *func_name() const { return "abs"; }
   void fix_length_and_dec();
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return false; }
 };
 
 // A class to handle logarithmic and trigonometric functions
@@ -655,6 +668,8 @@
   int64_t int_op();
   double real_op();
   my_decimal *decimal_op(my_decimal *);
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return false; }
 };
 
 
@@ -666,6 +681,8 @@
   int64_t int_op();
   double real_op();
   my_decimal *decimal_op(my_decimal *);
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return false; }
 };
 
 /* This handles round and truncate */
@@ -695,6 +712,8 @@
   bool const_item() const { return 0; }
   void update_used_tables();
   bool fix_fields(THD *thd, Item **ref);
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
 private:
   void seed_random (Item * val);  
 };
@@ -977,6 +996,8 @@
       max_length= args[0]->max_length;
   }
   bool fix_fields(THD *thd, Item **ref);
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
 };
 
 
@@ -990,6 +1011,8 @@
   const char *func_name() const { return "benchmark"; }
   void fix_length_and_dec() { max_length=1; maybe_null=0; }
   virtual void print(String *str, enum_query_type query_type);
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
 };
 
 /* replication functions */
@@ -1003,6 +1026,8 @@
   int64_t val_int();
   const char *func_name() const { return "master_pos_wait"; }
   void fix_length_and_dec() { max_length=21; maybe_null=1;}
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
 };
 
 
@@ -1060,6 +1085,7 @@
   }
   void save_org_in_field(Field *field) { (void)save_in_field(field, 1, 0); }
   bool register_field_in_read_map(unsigned char *arg);
+  bool register_field_in_bitmap(unsigned char *arg);
 };
 
 
@@ -1171,6 +1197,8 @@
   int64_t val_int();
   const char *func_name() const { return "is_free_lock"; }
   void fix_length_and_dec() { decimals=0; max_length=1; maybe_null=1;}
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
 };
 
 class Item_func_is_used_lock :public Item_int_func
@@ -1181,6 +1209,8 @@
   int64_t val_int();
   const char *func_name() const { return "is_used_lock"; }
   void fix_length_and_dec() { decimals=0; max_length=10; maybe_null=1;}
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
 };
 
 /* For type casts */
@@ -1200,6 +1230,8 @@
   int64_t val_int();
   const char *func_name() const { return "row_count"; }
   void fix_length_and_dec() { decimals= 0; maybe_null=0; }
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
 };
 
 
@@ -1218,6 +1250,8 @@
   int64_t val_int();
   const char *func_name() const { return "found_rows"; }
   void fix_length_and_dec() { decimals= 0; maybe_null=0; }
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
 };
 
 #endif /* DRIZZLE_SERVER_ITEM_FUNC_H */

=== modified file 'drizzled/item_row.h'
--- drizzled/item_row.h	2008-10-06 06:47:29 +0000
+++ drizzled/item_row.h	2008-10-07 04:51:08 +0000
@@ -81,4 +81,6 @@
   bool check_cols(uint32_t c);
   bool null_inside() { return with_null; };
   void bring_value();
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return false; }
 };

=== modified file 'drizzled/item_strfunc.h'
--- drizzled/item_strfunc.h	2008-10-06 06:47:29 +0000
+++ drizzled/item_strfunc.h	2008-10-07 04:51:08 +0000
@@ -224,6 +224,8 @@
     call
   */
   virtual const char *fully_qualified_func_name() const = 0;
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
 };
 
 
@@ -488,6 +490,8 @@
     maybe_null=1;
     max_length=MAX_BLOB_WIDTH;
   }
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
 };
 
 
@@ -618,6 +622,12 @@
   const char *func_name() const { return "weight_string"; }
   String *val_str(String *);
   void fix_length_and_dec();
+  /*
+    TODO: Currently this Item is not allowed for virtual columns
+    only due to a bug in generating virtual column value.
+  */
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
 };
 
 #define UUID_LENGTH (8+1+4+1+4+1+4+1+12)
@@ -636,5 +646,7 @@
   }
   const char *func_name() const{ return "uuid"; }
   String *val_str(String *);
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
 };
 

=== modified file 'drizzled/item_timefunc.h'
--- drizzled/item_timefunc.h	2008-10-06 06:47:29 +0000
+++ drizzled/item_timefunc.h	2008-10-07 04:51:08 +0000
@@ -73,6 +73,8 @@
   }
   enum_monotonicity_info get_monotonicity_info() const;
   int64_t val_int_endpoint(bool left_endp, bool *incl_endp);
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return false; }
 };
 
 
@@ -88,6 +90,8 @@
     max_length=2*MY_CHARSET_BIN_MB_MAXLEN;
     maybe_null=1; 
   }
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return false; }
 };
 
 
@@ -112,6 +116,8 @@
     max_length=2*MY_CHARSET_BIN_MB_MAXLEN;
     maybe_null=1; 
   }
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return false; }
 };
 
 
@@ -311,6 +317,8 @@
     decimals=0;
     max_length=10*MY_CHARSET_BIN_MB_MAXLEN;
   }
+  bool check_vcol_func_processor(unsigned char *int_arg  __attribute__((unused)))
+  { return true; }
 };
 
 
@@ -446,6 +454,8 @@
   */
   virtual void store_now_in_TIME(DRIZZLE_TIME *now_time)=0;
   bool result_as_int64_t() { return true; }
+  bool check_vcol_func_processor(unsigned char *int_arg  __attribute__((unused)))
+  { return true; }
 };
 
 
@@ -482,6 +492,8 @@
   void fix_length_and_dec();
   bool get_date(DRIZZLE_TIME *res, uint32_t fuzzy_date);
   virtual void store_now_in_TIME(DRIZZLE_TIME *now_time)=0;
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
 };
 
 
@@ -522,6 +534,8 @@
   void fix_length_and_dec();
   bool get_date(DRIZZLE_TIME *res, uint32_t fuzzy_date);
   virtual void store_now_in_TIME(DRIZZLE_TIME *now_time)=0;
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
 };
 
 
@@ -578,6 +592,8 @@
   Item_func_from_days(Item *a) :Item_date(a) {}
   const char *func_name() const { return "from_days"; }
   bool get_date(DRIZZLE_TIME *res, uint32_t fuzzy_date);
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return false; }
 };
 
 

=== modified file 'drizzled/lex.h'
--- drizzled/lex.h	2008-10-02 19:18:43 +0000
+++ drizzled/lex.h	2008-10-07 04:51:08 +0000
@@ -333,6 +333,7 @@
   { "PACK_KEYS",	SYM(PACK_KEYS_SYM)},
   { "PAGE",	        SYM(PAGE_SYM)},
   { "PAGE_CHECKSUM",        SYM(PAGE_CHECKSUM_SYM)},
+  { "PARSE_VCOL_EXPR",  SYM(PARSE_VCOL_EXPR_SYM)},
   { "PARTIAL",		SYM(PARTIAL)},
   { "PHASE",            SYM(PHASE_SYM)},
   { "PLUGIN",           SYM(PLUGIN_SYM)},
@@ -436,6 +437,7 @@
   { "STATUS",		SYM(STATUS_SYM)},
   { "STOP",		SYM(STOP_SYM)},
   { "STORAGE",		SYM(STORAGE_SYM)},
+  { "STORED",           SYM(STORED_SYM)},
   { "STRAIGHT_JOIN",	SYM(STRAIGHT_JOIN)},
   { "STRING",		SYM(STRING_SYM)},
   { "SUBJECT",		SYM(SUBJECT_SYM)},
@@ -503,6 +505,7 @@
   { "WITH",		SYM(WITH)},
   { "WORK",		SYM(WORK_SYM)},
   { "WRITE",		SYM(WRITE_SYM)},
+  { "VIRTUAL",          SYM(VIRTUAL_SYM)},
   { "XOR",		SYM(XOR)},
   { "YEAR",		SYM(YEAR_SYM)},
   { "YEAR_MONTH",	SYM(YEAR_MONTH_SYM)},

=== modified file 'drizzled/records.cc'
--- drizzled/records.cc	2008-10-06 06:47:29 +0000
+++ drizzled/records.cc	2008-10-07 04:51:08 +0000
@@ -301,6 +301,7 @@
       break;
     }
   }
+  update_virtual_fields_marked_for_write(info->table);
   return tmp;
 }
 
@@ -373,6 +374,8 @@
       break;
     }
   }
+  if (!tmp)
+    update_virtual_fields_marked_for_write(info->table);
   return tmp;
 }
 

=== modified file 'drizzled/server_includes.h'
--- drizzled/server_includes.h	2008-10-06 19:59:47 +0000
+++ drizzled/server_includes.h	2008-10-07 04:51:08 +0000
@@ -281,6 +281,8 @@
                     bool allow_rowid, uint32_t *cached_field_index_ptr);
 Field *
 find_field_in_table_sef(Table *table, const char *name);
+int update_virtual_fields_marked_for_write(Table *table,
+                                           bool ignore_stored=true);
 
 /* sql_do.cc */
 bool mysql_do(THD *thd, List<Item> &values);
@@ -331,13 +333,15 @@
 		       Item *default_value, Item *on_update_value,
 		       LEX_STRING *comment,
 		       char *change, List<String> *interval_list,
-		       const CHARSET_INFO * const cs);
+		       const CHARSET_INFO * const cs,
+		       virtual_column_info *vcol_info);
 Create_field * new_create_field(THD *thd, char *field_name, enum_field_types type,
 				char *length, char *decimals,
 				uint32_t type_modifier, 
 				Item *default_value, Item *on_update_value,
 				LEX_STRING *comment, char *change, 
-				List<String> *interval_list, CHARSET_INFO *cs);
+				List<String> *interval_list, CHARSET_INFO *cs,
+				virtual_column_info *vcol_info);
 void store_position_for_column(const char *name);
 bool add_to_list(THD *thd, SQL_LIST &list,Item *group,bool asc);
 bool push_new_name_resolution_context(THD *thd,

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2008-10-07 02:24:59 +0000
+++ drizzled/sql_base.cc	2008-10-07 04:51:08 +0000
@@ -4141,6 +4141,23 @@
 
   if (field_ptr && *field_ptr)
   {
+    if ((*field_ptr)->vcol_info)
+    {
+      if (thd->mark_used_columns != MARK_COLUMNS_NONE)
+      {
+        Item *vcol_item= (*field_ptr)->vcol_info->expr_item;
+        assert(vcol_item);
+        vcol_item->walk(&Item::register_field_in_read_map, 1, (unsigned char *) 0);
+        /* 
+          Set the virtual field for write here if 
+          1) this procedure is called for a read-only operation (SELECT), and
+          2) the virtual column is not phycically stored in the table
+        */
+        if ((thd->mark_used_columns != MARK_COLUMNS_WRITE) && 
+            (not (*field_ptr)->is_stored))
+          bitmap_set_bit((*field_ptr)->table->write_set, (*field_ptr)->field_index);
+      }
+    }
     *cached_field_index_ptr= field_ptr - table->field;
     field= *field_ptr;
   }
@@ -5898,6 +5915,17 @@
       {
         /* Mark fields as used to allow storage engine to optimze access */
         bitmap_set_bit(field->table->read_set, field->field_index);
+        /*
+          Mark virtual fields for write and others that the virtual fields
+          depend on for read.
+        */
+        if (field->vcol_info)
+        {
+          Item *vcol_item= field->vcol_info->expr_item;
+          assert(vcol_item);
+          vcol_item->walk(&Item::register_field_in_read_map, 1, (unsigned char *) 0);
+          bitmap_set_bit(field->table->write_set, field->field_index);
+        }
         if (table)
         {
           table->covering_keys.intersect(field->part_of_key);
@@ -6076,6 +6104,9 @@
   Item *value, *fld;
   Item_field *field;
   Table *table= 0;
+  List<Table> tbl_list;
+  bool abort_on_warning_saved= thd->abort_on_warning;
+  tbl_list.empty();
 
   /*
     Reset the table->auto_increment_field_not_null as it is valid for
@@ -6109,14 +6140,52 @@
     table= rfield->table;
     if (rfield == table->next_number_field)
       table->auto_increment_field_not_null= true;
+    if (rfield->vcol_info && 
+        value->type() != Item::DEFAULT_VALUE_ITEM && 
+        value->type() != Item::NULL_ITEM &&
+        table->s->table_category != TABLE_CATEGORY_TEMPORARY)
+    {
+      thd->abort_on_warning= false;
+      push_warning_printf(thd, DRIZZLE_ERROR::WARN_LEVEL_WARN,
+                          ER_WARNING_NON_DEFAULT_VALUE_FOR_VIRTUAL_COLUMN,
+                          ER(ER_WARNING_NON_DEFAULT_VALUE_FOR_VIRTUAL_COLUMN),
+                          rfield->field_name, table->s->table_name.str);
+      thd->abort_on_warning= abort_on_warning_saved;
+    }
     if ((value->save_in_field(rfield, 0) < 0) && !ignore_errors)
     {
       my_message(ER_UNKNOWN_ERROR, ER(ER_UNKNOWN_ERROR), MYF(0));
       goto err;
     }
-  }
+    tbl_list.push_back(table);
+  }
+  /* Update virtual fields*/
+  thd->abort_on_warning= false;
+  if (tbl_list.head())
+  {
+    List_iterator_fast<Table> t(tbl_list);
+    Table *prev_table= 0;
+    while ((table= t++))
+    {
+      /*
+        Do simple optimization to prevent unnecessary re-generating 
+        values for virtual fields
+      */
+      if (table != prev_table)
+      {
+        prev_table= table;
+        if (table->vfield)
+        {
+          if (update_virtual_fields_marked_for_write(table, false))
+            goto err;
+        }
+      }
+    }
+  }
+  thd->abort_on_warning= abort_on_warning_saved;
   return(thd->is_error());
 err:
+  thd->abort_on_warning= abort_on_warning_saved;
   if (table)
     table->auto_increment_field_not_null= false;
   return(true);
@@ -6150,8 +6219,11 @@
   List_iterator_fast<Item> v(values);
   Item *value;
   Table *table= 0;
-
   Field *field;
+  List<Table> tbl_list;
+  bool abort_on_warning_saved= thd->abort_on_warning;
+  
+  tbl_list.empty();
   /*
     Reset the table->auto_increment_field_not_null as it is valid for
     only one row.
@@ -6171,12 +6243,52 @@
     table= field->table;
     if (field == table->next_number_field)
       table->auto_increment_field_not_null= true;
+    if (field->vcol_info && 
+        value->type() != Item::DEFAULT_VALUE_ITEM && 
+        value->type() != Item::NULL_ITEM &&
+        table->s->table_category != TABLE_CATEGORY_TEMPORARY)
+    {
+      thd->abort_on_warning= false;
+      push_warning_printf(thd, DRIZZLE_ERROR::WARN_LEVEL_WARN,
+                          ER_WARNING_NON_DEFAULT_VALUE_FOR_VIRTUAL_COLUMN,
+                          ER(ER_WARNING_NON_DEFAULT_VALUE_FOR_VIRTUAL_COLUMN),
+                          field->field_name, table->s->table_name.str);
+      thd->abort_on_warning= abort_on_warning_saved;
+    }
     if (value->save_in_field(field, 0) < 0)
       goto err;
-  }
+    tbl_list.push_back(table);
+  }
+  /* Update virtual fields*/
+  thd->abort_on_warning= false;
+  if (tbl_list.head())
+  {
+    List_iterator_fast<Table> t(tbl_list);
+    Table *prev_table= 0;
+    while ((table= t++))
+    {
+      /*
+        Do simple optimization to prevent unnecessary re-generating 
+        values for virtual fields
+      */
+      if (table != prev_table)
+      {
+        prev_table= table;
+        if (table->vfield)
+        {
+          if (update_virtual_fields_marked_for_write(table, false))
+          {
+            goto err;
+          }
+        }
+      }
+    }
+  }
+  thd->abort_on_warning= abort_on_warning_saved;
   return(thd->is_error());
 
 err:
+  thd->abort_on_warning= abort_on_warning_saved;
   if (table)
     table->auto_increment_field_not_null= false;
   return(true);

=== modified file 'drizzled/sql_class.cc'
--- drizzled/sql_class.cc	2008-10-06 17:35:06 +0000
+++ drizzled/sql_class.cc	2008-10-07 04:51:08 +0000
@@ -183,6 +183,58 @@
 }
 
 
+/*
+  Check if the foreign key options are compatible with columns
+  on which the FK is created.
+
+  RETURN
+    0   Key valid
+    1   Key invalid
+*/
+bool Foreign_key::validate(List<Create_field> &table_fields)
+{
+  Create_field  *sql_field;
+  Key_part_spec *column;
+  List_iterator<Key_part_spec> cols(columns);
+  List_iterator<Create_field> it(table_fields);
+  while ((column= cols++))
+  {
+    it.rewind();
+    while ((sql_field= it++) &&
+           my_strcasecmp(system_charset_info,
+                         column->field_name.str,
+                         sql_field->field_name)) {}
+    if (!sql_field)
+    {
+      my_error(ER_KEY_COLUMN_DOES_NOT_EXITS, MYF(0), column->field_name.str);
+      return true;
+    }
+    if (type == Key::FOREIGN_KEY && sql_field->vcol_info)
+    {
+      if (delete_opt == FK_OPTION_SET_NULL)
+      {
+        my_error(ER_WRONG_FK_OPTION_FOR_VIRTUAL_COLUMN, MYF(0), 
+                 "ON DELETE SET NULL");
+        return true;
+      }
+      if (update_opt == FK_OPTION_SET_NULL)
+      {
+        my_error(ER_WRONG_FK_OPTION_FOR_VIRTUAL_COLUMN, MYF(0), 
+                 "ON UPDATE SET NULL");
+        return true;
+      }
+      if (update_opt == FK_OPTION_CASCADE)
+      {
+        my_error(ER_WRONG_FK_OPTION_FOR_VIRTUAL_COLUMN, MYF(0), 
+                 "ON UPDATE CASCADE");
+        return true;
+      }
+    }
+  }
+  return false;
+}
+
+
 /****************************************************************************
 ** Thread specific functions
 ****************************************************************************/

=== modified file 'drizzled/sql_class.h'
--- drizzled/sql_class.h	2008-10-06 17:35:06 +0000
+++ drizzled/sql_class.h	2008-10-07 04:51:08 +0000
@@ -214,6 +214,8 @@
   */
   virtual Key *clone(MEM_ROOT *mem_root) const
   { return new (mem_root) Foreign_key(*this, mem_root); }
+  /* Used to validate foreign key options */
+  bool validate(List<Create_field> &table_fields);
 };
 
 typedef struct st_mysql_lock

=== modified file 'drizzled/sql_insert.cc'
--- drizzled/sql_insert.cc	2008-10-06 06:47:29 +0000
+++ drizzled/sql_insert.cc	2008-10-07 04:51:08 +0000
@@ -132,6 +132,9 @@
                        table->timestamp_field->field_index);
       }
     }
+    /* Mark all virtual columns for write*/
+    if (table->vfield)
+      table->mark_virtual_columns();
   }
 
   return 0;

=== modified file 'drizzled/sql_lex.cc'
--- drizzled/sql_lex.cc	2008-10-06 07:55:10 +0000
+++ drizzled/sql_lex.cc	2008-10-07 04:51:08 +0000
@@ -331,6 +331,7 @@
   lex->reset_query_tables_list(false);
   lex->expr_allows_subselect= true;
   lex->use_only_table_context= false;
+  lex->parse_vcol_expr= false;
 
   lex->name.str= 0;
   lex->name.length= 0;

=== modified file 'drizzled/sql_lex.h'
--- drizzled/sql_lex.h	2008-10-06 21:06:15 +0000
+++ drizzled/sql_lex.h	2008-10-07 04:51:08 +0000
@@ -1382,6 +1382,7 @@
   XID *xid;
   unsigned char* yacc_yyss, *yacc_yyvs;
   THD *thd;
+  virtual_column_info *vcol_info;
 
   /* maintain a list of used plugins for this LEX */
   DYNAMIC_ARRAY plugins;
@@ -1444,6 +1445,14 @@
     syntax error back.
   */
   bool expr_allows_subselect;
+  /*
+    A special command "PARSE_VCOL_EXPR" is defined for the parser 
+    to translate an expression statement of a virtual column \
+    (stored in the *.frm file as a string) into an Item object.
+    The following flag is used to prevent other applications to use 
+    this command.
+  */
+  bool parse_vcol_expr;
 
   thr_lock_type lock_option;
   enum enum_duplicates duplicates;

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2008-10-06 21:06:15 +0000
+++ drizzled/sql_parse.cc	2008-10-07 04:51:08 +0000
@@ -2878,7 +2878,8 @@
 		       Item *default_value, Item *on_update_value,
                        LEX_STRING *comment,
 		       char *change,
-                       List<String> *interval_list, const CHARSET_INFO * const cs)
+                       List<String> *interval_list, const CHARSET_INFO * const cs,
+                       virtual_column_info *vcol_info)
 {
   register Create_field *new_field;
   LEX  *lex= thd->lex;
@@ -2949,7 +2950,8 @@
   if (!(new_field= new Create_field()) ||
       new_field->init(thd, field_name->str, type, length, decimals, type_modifier,
                       default_value, on_update_value, comment, change,
-                      interval_list, cs, 0, column_format))
+                      interval_list, cs, 0, column_format,
+                      vcol_info))
     return(1);
 
   lex->alter_info.create_list.push_back(new_field);

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2008-10-06 06:47:29 +0000
+++ drizzled/sql_select.cc	2008-10-07 04:51:08 +0000
@@ -11391,6 +11391,7 @@
       empty_record(table);			// Make empty record
       return -1;
     }
+    update_virtual_fields_marked_for_write(table);
     store_record(table,record[1]);
   }
   else if (!table->status)			// Only happens with left join
@@ -11439,6 +11440,7 @@
 	return table->report_error(error);
       return -1;
     }
+    update_virtual_fields_marked_for_write(table);
     store_record(table,record[1]);
   }
   else if (!(table->status & ~STATUS_NULL_ROW))	// Only happens with left join
@@ -11547,6 +11549,7 @@
       return table->report_error(error);
     return -1; /* purecov: inspected */
   }
+  update_virtual_fields_marked_for_write(table);
   return 0;
 }
 
@@ -11633,6 +11636,7 @@
     table->status= STATUS_GARBAGE;
     return -1;
   }
+  update_virtual_fields_marked_for_write(table);
   return 0;
 }
 
@@ -11652,6 +11656,7 @@
     table->status=STATUS_NOT_FOUND;
     error= -1;
   }
+  update_virtual_fields_marked_for_write(table);
   return error;
 }
 
@@ -11732,6 +11737,8 @@
       table->report_error(error);
     return -1;
   }
+  if (not error)
+    update_virtual_fields_marked_for_write(tab->table);
   return 0;
 }
 
@@ -11751,7 +11758,8 @@
 
       if ((error=info->file->index_next(info->record)))
         return info->table->report_error(error);
-      
+      if (not error)
+        update_virtual_fields_marked_for_write(tab->table);
     } while (!key_cmp(tab->table->key_info[tab->index].key_part, 
                       tab->insideout_buf, key->key_length));
     tab->insideout_match_tab->found_match= 0;
@@ -11768,6 +11776,8 @@
   int error;
   if ((error=info->file->index_next(info->record)))
     return info->table->report_error(error);
+  if (not error)
+    update_virtual_fields_marked_for_write(info->table);
   return 0;
 }
 
@@ -11793,6 +11803,8 @@
     table->file->ha_index_init(tab->index, 1);
   if ((error= tab->table->file->index_last(tab->table->record[0])))
     return table->report_error(error);
+  if (not error)
+    update_virtual_fields_marked_for_write(tab->table);
   return 0;
 }
 
@@ -11803,6 +11815,8 @@
   int error;
   if ((error= info->file->index_prev(info->record)))
     return info->table->report_error(error);
+  if (not error)
+    update_virtual_fields_marked_for_write(info->table);
   return 0;
 }
 

=== modified file 'drizzled/sql_show.cc'
--- drizzled/sql_show.cc	2008-10-06 21:06:15 +0000
+++ drizzled/sql_show.cc	2008-10-07 04:51:08 +0000
@@ -712,9 +712,25 @@
     else
       type.set_charset(system_charset_info);
 
+    if (field->vcol_info)
+    {
+      packet->append(STRING_WITH_LEN("VIRTUAL "));
+    }
+
     field->sql_type(type);
     packet->append(type.ptr(), type.length(), system_charset_info);
 
+    if (field->vcol_info)
+    {
+      packet->append(STRING_WITH_LEN(" AS ("));
+      packet->append(field->vcol_info->expr_str.str,
+                     field->vcol_info->expr_str.length,
+                     system_charset_info);
+      packet->append(STRING_WITH_LEN(")"));
+      if (field->is_stored)
+        packet->append(STRING_WITH_LEN(" STORED"));
+    }
+    
     if (field->has_charset())
     {
       if (field->charset() != share->table_charset)
@@ -761,7 +777,8 @@
           packet->append(STRING_WITH_LEN(" DYNAMIC */"));
       }
     }
-    if (get_field_default_value(thd, table->timestamp_field,
+    if (!field->vcol_info &&
+        get_field_default_value(thd, table->timestamp_field,
                                 field, &def_value, 1))
     {
       packet->append(STRING_WITH_LEN(" DEFAULT "));
@@ -3175,7 +3192,8 @@
         field->unireg_check != Field::TIMESTAMP_DN_FIELD)
       table->field[16]->store(STRING_WITH_LEN("on update CURRENT_TIMESTAMP"),
                               cs);
-
+    if (field->vcol_info)
+          table->field[16]->store(STRING_WITH_LEN("VIRTUAL"), cs);
     table->field[18]->store(field->comment.str, field->comment.length, cs);
     {
       enum column_format_type column_format= (enum column_format_type)

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2008-10-06 17:35:06 +0000
+++ drizzled/sql_table.cc	2008-10-07 04:51:08 +0000
@@ -839,7 +839,8 @@
                           (sql_field->decimals << FIELDFLAG_DEC_SHIFT));
     break;
   }
-  if (!(sql_field->flags & NOT_NULL_FLAG))
+  if (!(sql_field->flags & NOT_NULL_FLAG) ||
+      (sql_field->vcol_info)) /* Make virtual columns always allow NULL values */
     sql_field->pack_flag|= FIELDFLAG_MAYBE_NULL;
   if (sql_field->flags & NO_DEFAULT_VALUE_FLAG)
     sql_field->pack_flag|= FIELDFLAG_NO_DEFAULT;
@@ -1093,6 +1094,8 @@
             null_fields--;
 	  sql_field->flags=		dup_field->flags;
           sql_field->interval=          dup_field->interval;
+          sql_field->vcol_info=         dup_field->vcol_info;
+          sql_field->is_stored=      dup_field->is_stored;
 	  it2.remove();			// Remove first (create) definition
 	  select_field_pos--;
 	  break;
@@ -1124,7 +1127,23 @@
     sql_field->offset= record_offset;
     if (MTYP_TYPENR(sql_field->unireg_check) == Field::NEXT_NUMBER)
       auto_increment++;
-    record_offset+= sql_field->pack_length;
+    /*
+          For now skip fields that are not physically stored in the database
+          (virtual fields) and update their offset later 
+          (see the next loop).
+        */
+    if (sql_field->is_stored)
+      record_offset+= sql_field->pack_length;
+  }
+  /* Update virtual fields' offset */
+  it.rewind();
+  while ((sql_field=it++))
+  {
+    if (not sql_field->is_stored)
+    {
+      sql_field->offset= record_offset;
+      record_offset+= sql_field->pack_length;
+    }
   }
   if (timestamps_with_niladic > 1)
   {
@@ -1171,6 +1190,8 @@
     if (key->type == Key::FOREIGN_KEY)
     {
       fk_key_count++;
+      if (((Foreign_key *)key)->validate(alter_info->create_list))
+        return true;
       Foreign_key *fk_key= (Foreign_key*) key;
       if (fk_key->ref_columns.elements &&
 	  fk_key->ref_columns.elements != fk_key->columns.elements)
@@ -1360,6 +1381,17 @@
 	    return(true);
 	  }
 	}
+        if (not sql_field->is_stored)
+        {
+          /* Key fields must always be physically stored. */
+          my_error(ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN, MYF(0));
+          return(true);
+        }
+        if (key->type == Key::PRIMARY && sql_field->vcol_info)
+        {
+          my_error(ER_PRIMARY_KEY_BASED_ON_VIRTUAL_COLUMN, MYF(0));
+          return(true);
+        }
 	if (!(sql_field->flags & NOT_NULL_FLAG))
 	{
 	  if (key->type == Key::PRIMARY)
@@ -3406,6 +3438,14 @@
       if (!(table_changes_local= field->is_equal(new_field)))
         *alter_flags|= HA_ALTER_COLUMN_TYPE;
 
+      /*
+        Check if the altered column is a stored virtual field.
+        TODO: Mark such a column with an alter flag only if
+        the expression functions are not equal. 
+      */
+      if (field->is_stored && field->vcol_info)
+        *alter_flags|= HA_ALTER_STORED_VCOL;
+
       /* Check if field was renamed */
       field->flags&= ~FIELD_IS_RENAMED;
       if (my_strcasecmp(system_charset_info,
@@ -4043,6 +4083,13 @@
     if (def)
     {						// Field is changed
       def->field=field;
+      if (field->is_stored != def->is_stored)
+      {
+        my_error(ER_UNSUPPORTED_ACTION_ON_VIRTUAL_COLUMN,
+                 MYF(0),
+                 "Changing the STORED status");
+        goto err;
+      }
       if (!def->after)
 	{
 	new_create_list.push_back(def);
@@ -4260,6 +4307,9 @@
     Key *key;
     while ((key=key_it++))			// Add new keys
     {
+      if (key->type == Key::FOREIGN_KEY &&
+          ((Foreign_key *)key)->validate(new_create_list))
+        goto err;
       if (key->type != Key::FOREIGN_KEY)
         new_key_list.push_back(key);
       if (key->name.str &&
@@ -5212,6 +5262,7 @@
       copy_ptr->do_copy(copy_ptr);
     }
     prev_insert_id= to->file->next_insert_id;
+    update_virtual_fields_marked_for_write(to, false);
     error=to->file->ha_write_row(to->record[0]);
     to->auto_increment_field_not_null= false;
     if (error)

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2008-10-06 21:06:15 +0000
+++ drizzled/sql_yacc.yy	2008-10-07 04:51:08 +0000
@@ -679,6 +679,7 @@
 %token  PAGE_SYM
 %token  PAGE_CHECKSUM_SYM
 %token  PARAM_MARKER
+%token  PARSE_VCOL_EXPR_SYM
 %token  PARTIAL                       /* SQL-2003-N */
 %token  PHASE_SYM
 %token  PLUGINS_SYM
@@ -777,6 +778,7 @@
 %token  STD_SYM
 %token  STOP_SYM
 %token  STORAGE_SYM
+%token  STORED_SYM
 %token  STRAIGHT_JOIN
 %token  STRING_SYM
 %token  SUBDATE_SYM
@@ -842,6 +844,7 @@
 %token  VARIANCE_SYM
 %token  VARYING                       /* SQL-2003-R */
 %token  VAR_SAMP_SYM
+%token  VIRTUAL_SYM
 %token  WAIT_SYM
 %token  WARNINGS
 %token  WEEK_SYM
@@ -893,7 +896,7 @@
         text_string opt_gconcat_separator
 
 %type <num>
-        type int_type real_type order_dir
+        type int_type real_type order_dir field_def
         if_exists opt_local opt_table_options table_options
         table_option opt_if_not_exists
         opt_temporary all_or_any opt_distinct
@@ -1033,6 +1036,8 @@
         opt_field_or_var_spec fields_or_vars opt_load_data_set_spec
         binlog_base64_event
         init_key_options key_options key_opts key_opt key_using_alg
+        parse_vcol_expr vcol_opt_attribute vcol_opt_attribute_list
+        vcol_attribute
 END_OF_INPUT
 
 %type <index_hint> index_hint_type
@@ -1109,6 +1114,7 @@
         | lock
         | optimize
         | keycache
+        | parse_vcol_expr
         | purge
         | release
         | rename
@@ -1710,8 +1716,9 @@
             lex->comment=null_lex_str;
             lex->charset=NULL;
             lex->column_format= COLUMN_FORMAT_TYPE_DEFAULT;
+            lex->vcol_info= NULL;
           }
-          type opt_attribute
+          field_def
           {
             LEX *lex=Lex;
             if (add_field_to_list(lex->thd, &$1, (enum enum_field_types) $3,
@@ -1719,8 +1726,79 @@
                                   lex->column_format,
                                   lex->default_value, lex->on_update_value, 
                                   &lex->comment,
-                                  lex->change,&lex->interval_list,lex->charset))
-              DRIZZLE_YYABORT;
+                                  lex->change,&lex->interval_list,lex->charset,
+                                  lex->vcol_info))
+              DRIZZLE_YYABORT;
+          }
+        ;
+field_def:
+          type opt_attribute {}
+        | VIRTUAL_SYM type AS '(' virtual_column_func ')' vcol_opt_attribute
+          {
+            $$=DRIZZLE_TYPE_VIRTUAL;
+            Lex->vcol_info->set_field_type((enum enum_field_types) $2);
+          }
+        ;
+
+vcol_opt_attribute:
+          /* empty */ {}
+        | vcol_opt_attribute_list {}
+        ;
+
+vcol_opt_attribute_list:
+          vcol_opt_attribute_list vcol_attribute {}
+        | vcol_attribute
+        ;
+
+vcol_attribute:
+          UNIQUE_SYM
+          {
+            LEX *lex=Lex;
+            lex->type|= UNIQUE_FLAG; 
+            lex->alter_info.flags|= ALTER_ADD_INDEX;
+          }
+        | UNIQUE_SYM KEY_SYM
+          {
+            LEX *lex=Lex;
+            lex->type|= UNIQUE_KEY_FLAG; 
+            lex->alter_info.flags|= ALTER_ADD_INDEX; 
+          }
+        | COMMENT_SYM TEXT_STRING_sys { Lex->comment= $2; }
+        | STORED_SYM
+          {
+            Lex->vcol_info->set_field_stored(true);
+          }
+        ;
+
+parse_vcol_expr:
+          PARSE_VCOL_EXPR_SYM '(' virtual_column_func ')'
+          {
+            /* 
+              "PARSE_VCOL_EXPR" can only be used by the SQL server
+              when reading a '*.frm' file.
+              Prevent the end user from invoking this command.
+            */
+            if (not Lex->parse_vcol_expr)
+            {
+              my_message(ER_SYNTAX_ERROR, ER(ER_SYNTAX_ERROR), MYF(0));
+              DRIZZLE_YYABORT;
+            }
+          }
+        ;
+
+virtual_column_func:
+          remember_name expr remember_end
+          {
+            Lex->vcol_info= new virtual_column_info();
+            if (not Lex->vcol_info)
+            {
+              my_error(ER_OUTOFMEMORY, MYF(0), sizeof(virtual_column_info));
+              DRIZZLE_YYABORT;
+            }
+            uint expr_len= (uint)($3 - $1) - 1;
+            Lex->vcol_info->expr_str.str= (char* ) sql_memdup($1 + 1, expr_len);
+            Lex->vcol_info->expr_str.length= expr_len;
+            Lex->vcol_info->expr_item= $2;
           }
         ;
 
@@ -2325,8 +2403,9 @@
             lex->charset= NULL;
             lex->alter_info.flags|= ALTER_CHANGE_COLUMN;
             lex->column_format= COLUMN_FORMAT_TYPE_DEFAULT;
+            lex->vcol_info= NULL;
           }
-          type opt_attribute
+          field_def
           {
             LEX *lex=Lex;
             if (add_field_to_list(lex->thd,&$3,
@@ -2335,7 +2414,8 @@
                                   lex->column_format,
                                   lex->default_value, lex->on_update_value,
                                   &lex->comment,
-                                  $3.str, &lex->interval_list, lex->charset))
+                                  $3.str, &lex->interval_list, lex->charset,
+                                  lex->vcol_info))
               DRIZZLE_YYABORT;
           }
           opt_place

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2008-10-06 06:47:29 +0000
+++ drizzled/table.cc	2008-10-07 04:51:08 +0000
@@ -25,6 +25,9 @@
 /* INFORMATION_SCHEMA name */
 LEX_STRING INFORMATION_SCHEMA_NAME= {C_STRING_WITH_LEN("information_schema")};
 
+/* Keyword for parsing virtual column functions */
+LEX_STRING parse_vcol_keyword= { C_STRING_WITH_LEN("PARSE_VCOL_EXPR ") };
+
 /* Functions defined in this file */
 
 void open_table_error(TABLE_SHARE *share, int error, int db_errno,
@@ -415,11 +418,12 @@
   uint32_t interval_count, interval_parts, read_length, int_length;
   uint32_t db_create_options, keys, key_parts, n_length;
   uint32_t key_info_length, com_length, null_bit_pos=0;
+  uint32_t vcol_screen_length;
   uint32_t extra_rec_buf_length;
   uint32_t i,j;
   bool use_hash;
   unsigned char forminfo[288];
-  char *keynames, *names, *comment_pos;
+  char *keynames, *names, *comment_pos, *vcol_screen_pos;
   unsigned char *record;
   unsigned char *disk_buff, *strpos, *null_flags=NULL, *null_pos=NULL;
   ulong pos, record_offset, *rec_per_key, rec_buff_length;
@@ -592,6 +596,7 @@
   }
 
   share->reclength = uint2korr((head+16));
+  share->stored_rec_length= share->reclength;
 
   record_offset= (ulong) (uint2korr(head+6)+
                           ((uint2korr(head+14) == 0xffff ?
@@ -732,6 +737,9 @@
   int_length= uint2korr(forminfo+274);
   share->null_fields= uint2korr(forminfo+282);
   com_length= uint2korr(forminfo+284);
+  vcol_screen_length= uint2korr(forminfo+286);
+  share->vfields= 0;
+  share->stored_fields= share->fields;
   if (forminfo[46] != (unsigned char)255)
   {
     share->comment.length=  (int) (forminfo[46]);
@@ -746,12 +754,14 @@
 			   interval_count*sizeof(TYPELIB)+
 			   (share->fields+interval_parts+
 			    keys+3)*sizeof(char *)+
-			   (n_length+int_length+com_length)))))
+			   (n_length+int_length+com_length+
+			       vcol_screen_length)))))
     goto err;                                   /* purecov: inspected */
 
   share->field= field_ptr;
   read_length=(uint) (share->fields * field_pack_length +
-		      pos+ (uint) (n_length+int_length+com_length));
+		      pos+ (uint) (n_length+int_length+com_length+
+		                   vcol_screen_length));
   if (read_string(file,(unsigned char**) &disk_buff,read_length))
     goto err;                                   /* purecov: inspected */
   strpos= disk_buff+pos;
@@ -764,7 +774,11 @@
   memcpy(names, strpos+(share->fields*field_pack_length),
 	 (uint) (n_length+int_length));
   comment_pos= names+(n_length+int_length);
-  memcpy(comment_pos, disk_buff+read_length-com_length, com_length);
+  memcpy(comment_pos, disk_buff+read_length-com_length-vcol_screen_length, 
+         com_length);
+  vcol_screen_pos= names+(n_length+int_length+com_length);
+  memcpy(vcol_screen_pos, disk_buff+read_length-vcol_screen_length, 
+         vcol_screen_length);
 
   fix_type_pointers(&interval_array, &share->fieldnames, 1, &names);
   if (share->fieldnames.count != share->fields)
@@ -823,10 +837,13 @@
   for (i=0 ; i < share->fields; i++, strpos+=field_pack_length, field_ptr++)
   {
     uint32_t pack_flag, interval_nr, unireg_type, recpos, field_length;
+    uint32_t vcol_info_length=0;
     enum_field_types field_type;
     enum column_format_type column_format= COLUMN_FORMAT_TYPE_DEFAULT;
     const CHARSET_INFO *charset= NULL;
     LEX_STRING comment;
+    virtual_column_info *vcol_info= NULL;
+    bool fld_is_stored= true;
 
     if (field_extra_info)
     {
@@ -855,6 +872,16 @@
           goto err;
         }
       }
+      if (field_type == DRIZZLE_TYPE_VIRTUAL)
+      {
+        assert(interval_nr); // Expect non-null expression
+        /* 
+          The interval_id byte in the .frm file stores the length of the
+          expression statement for a virtual column.
+        */
+        vcol_info_length= interval_nr;
+        interval_nr= 0;
+      }
       if (!comment_length)
       {
 	comment.str= (char*) "";
@@ -866,6 +893,32 @@
 	comment.length= comment_length;
 	comment_pos+=   comment_length;
       }
+      if (vcol_info_length)
+      {
+        /*
+          Get virtual column data stored in the .frm file as follows:
+          byte 1      = 1 (always 1 to allow for future extensions)
+          byte 2      = sql_type
+          byte 3      = flags (as of now, 0 - no flags, 1 - field is physically stored)
+          byte 4-...  = virtual column expression (text data)
+        */
+        vcol_info= new virtual_column_info();
+        if ((uint)vcol_screen_pos[0] != 1)
+        {
+          error= 4;
+          goto err;
+        }
+        field_type= (enum_field_types) (unsigned char) vcol_screen_pos[1];
+        fld_is_stored= (bool) (uint) vcol_screen_pos[2];
+        vcol_info->expr_str.str= (char *)memdup_root(&share->mem_root,
+                                                     vcol_screen_pos+
+                                                       (uint)FRM_VCOL_HEADER_SIZE,
+                                                     vcol_info_length-
+                                                       (uint)FRM_VCOL_HEADER_SIZE);
+        vcol_info->expr_str.length= vcol_info_length-(uint)FRM_VCOL_HEADER_SIZE;
+        vcol_screen_pos+= vcol_info_length;
+        share->vfields++;
+      }
     }
     else
     {
@@ -929,6 +982,8 @@
     reg_field->flags|= ((uint)column_format << COLUMN_FORMAT_FLAGS);
     reg_field->field_index= i;
     reg_field->comment=comment;
+    reg_field->vcol_info= vcol_info;
+    reg_field->is_stored= fld_is_stored;
     if (!(reg_field->flags & NOT_NULL_FLAG))
     {
       if (!(null_bit_pos= (null_bit_pos + 1) & 7))
@@ -945,8 +1000,17 @@
     if (use_hash)
       (void) my_hash_insert(&share->name_hash,
                             (unsigned char*) field_ptr); // never fail
+    if (!reg_field->is_stored)
+    {
+      share->stored_fields--;
+      if (share->stored_rec_length>=recpos)
+        share->stored_rec_length= recpos-1;
+    }
   }
   *field_ptr=0;					// End marker
+  /* Sanity checks: */
+  assert(share->fields>=share->stored_fields);
+  assert(share->reclength>=share->stored_rec_length);
 
   /* Fix key->name and key_part->field */
   if (key_parts)
@@ -1181,6 +1245,259 @@
 
 
 /*
+  Clear flag GET_FIXED_FIELDS_FLAG in all fields of the table.
+  This routine is used for error handling purposes.
+
+  SYNOPSIS
+    clear_field_flag()
+    table                Table object for which virtual columns are set-up
+
+  RETURN VALUE
+    NONE
+*/
+static void clear_field_flag(Table *table)
+{
+  Field **ptr;
+
+  for (ptr= table->field; *ptr; ptr++)
+    (*ptr)->flags&= (~GET_FIXED_FIELDS_FLAG);
+}
+
+/*
+  The function uses the feature in fix_fields where the flag 
+  GET_FIXED_FIELDS_FLAG is set for all fields in the item tree.
+  This field must always be reset before returning from the function
+  since it is used for other purposes as well.
+
+  SYNOPSIS
+    fix_fields_vcol_func()
+    thd                  The thread object
+    func_item            The item tree reference of the virtual columnfunction
+    table                The table object
+    field_name           The name of the processed field
+
+  RETURN VALUE
+    true                 An error occurred, something was wrong with the
+                         function.
+    false                Ok, a partition field array was created
+*/
+
+bool fix_fields_vcol_func(THD *thd,
+                          Item* func_expr,
+                          Table *table,
+                          const char *field_name)
+{
+  uint dir_length, home_dir_length;
+  bool result= true;
+  TableList tables;
+  TableList *save_table_list, *save_first_table, *save_last_table;
+  int error;
+  Name_resolution_context *context;
+  const char *save_where;
+  char* db_name;
+  char db_name_string[FN_REFLEN];
+  bool save_use_only_table_context;
+  Field **ptr, *field;
+  enum_mark_columns save_mark_used_columns= thd->mark_used_columns;
+  assert(func_expr);
+
+  /*
+    Set-up the TABLE_LIST object to be a list with a single table
+    Set the object to zero to create NULL pointers and set alias
+    and real name to table name and get database name from file name.
+  */
+
+  bzero((void*)&tables, sizeof(TableList));
+  tables.alias= tables.table_name= (char*) table->s->table_name.str;
+  tables.table= table;
+  tables.next_local= NULL;
+  tables.next_name_resolution_table= NULL;
+  memcpy(db_name_string,
+         table->s->normalized_path.str,
+         table->s->normalized_path.length);
+  dir_length= dirname_length(db_name_string);
+  db_name_string[dir_length - 1]= 0;
+  home_dir_length= dirname_length(db_name_string);
+  db_name= &db_name_string[home_dir_length];
+  tables.db= db_name;
+
+  thd->mark_used_columns= MARK_COLUMNS_NONE;
+
+  context= thd->lex->current_context();
+  table->map= 1; //To ensure correct calculation of const item
+  table->get_fields_in_item_tree= true;
+  save_table_list= context->table_list;
+  save_first_table= context->first_name_resolution_table;
+  save_last_table= context->last_name_resolution_table;
+  context->table_list= &tables;
+  context->first_name_resolution_table= &tables;
+  context->last_name_resolution_table= NULL;
+  func_expr->walk(&Item::change_context_processor, 0, (unsigned char*) context);
+  save_where= thd->where;
+  thd->where= "virtual column function";
+
+  /* Save the context before fixing the fields*/
+  save_use_only_table_context= thd->lex->use_only_table_context;
+  thd->lex->use_only_table_context= true;
+  /* Fix fields referenced to by the virtual column function */
+  error= func_expr->fix_fields(thd, (Item**)0);
+  /* Restore the original context*/
+  thd->lex->use_only_table_context= save_use_only_table_context;
+  context->table_list= save_table_list;
+  context->first_name_resolution_table= save_first_table;
+  context->last_name_resolution_table= save_last_table;
+
+  if (unlikely(error))
+  {
+    clear_field_flag(table);
+    goto end;
+  }
+  thd->where= save_where;
+  /* 
+    Walk through the Item tree checking if all items are valid 
+   to be part of the virtual column
+ */
+  error= func_expr->walk(&Item::check_vcol_func_processor, 0, NULL);
+  if (error)
+  {
+    my_error(ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED, MYF(0), field_name);
+    clear_field_flag(table);
+    goto end;
+  }
+  if (unlikely(func_expr->const_item()))
+  {
+    my_error(ER_CONST_EXPR_IN_VCOL, MYF(0));
+    clear_field_flag(table);
+    goto end;
+  }
+  /* Ensure that this virtual column is not based on another virtual field. */
+  ptr= table->field;
+  while ((field= *(ptr++))) 
+  {
+    if ((field->flags & GET_FIXED_FIELDS_FLAG) &&
+        (field->vcol_info))
+    {
+      my_error(ER_VCOL_BASED_ON_VCOL, MYF(0));
+      clear_field_flag(table);
+      goto end;
+    }
+  }
+  /*
+    Cleanup the fields marked with flag GET_FIXED_FIELDS_FLAG
+    when calling fix_fields.
+  */
+  clear_field_flag(table);
+  result= false;
+
+end:
+  table->get_fields_in_item_tree= false;
+  thd->mark_used_columns= save_mark_used_columns;
+  table->map= 0; //Restore old value
+  return(result);
+}
+
+/*
+  Unpack the definition of a virtual column
+
+  SYNOPSIS
+    unpack_vcol_info_from_frm()
+    thd                  Thread handler
+    table                Table with the checked field
+    field                Pointer to Field object
+    open_mode            Open table mode needed to determine
+                         which errors need to be generated in a failure
+    error_reported       updated flag for the caller that no other error
+                         messages are to be generated.
+
+  RETURN VALUES
+    true            Failure
+    false           Success
+*/
+bool unpack_vcol_info_from_frm(THD *thd,
+                               Table *table,
+                               Field *field,
+                               LEX_STRING *vcol_expr,
+                               open_table_mode open_mode,
+                               bool *error_reported)
+{
+  assert(vcol_expr);
+
+  /* 
+    Step 1: Construct a statement for the parser.
+    The parsed string needs to take the following format:
+    "PARSE_VCOL_EXPR (<expr_string_from_frm>)"
+  */
+  char *vcol_expr_str;
+  int str_len= 0;
+  
+  if (!(vcol_expr_str= (char*) alloc_root(&table->mem_root,
+                                          vcol_expr->length + 
+                                            parse_vcol_keyword.length + 3)))
+  {
+    return(true);
+  }
+  memcpy(vcol_expr_str,
+         (char*) parse_vcol_keyword.str,
+         parse_vcol_keyword.length);
+  str_len= parse_vcol_keyword.length;
+  memcpy(vcol_expr_str + str_len, "(", 1);
+  str_len++;
+  memcpy(vcol_expr_str + str_len, 
+         (char*) vcol_expr->str, 
+         vcol_expr->length);
+  str_len+= vcol_expr->length;
+  memcpy(vcol_expr_str + str_len, ")", 1);
+  str_len++;
+  memcpy(vcol_expr_str + str_len, "\0", 1);
+  str_len++;
+  Lex_input_stream lip(thd, vcol_expr_str, str_len);
+
+  /* 
+    Step 2: Setup thd for parsing.
+  */
+
+  thd->lex->parse_vcol_expr= true;
+
+  /* 
+    Step 3: Use the parser to build an Item object from.
+  */
+  if (parse_sql(thd, &lip))
+  {
+    goto parse_err;
+  }
+  /* From now on use vcol_info generated by the parser. */
+  field->vcol_info= thd->lex->vcol_info;
+
+  /* Validate the Item tree. */
+  if (fix_fields_vcol_func(thd,
+                           field->vcol_info->expr_item,
+                           table,
+                           field->field_name))
+  {
+    if (open_mode == OTM_CREATE)
+    {
+      /*
+        During CREATE/ALTER TABLE it is ok to receive errors here.
+        It is not ok if it happens during the opening of an frm
+        file as part of a normal query.
+      */
+      *error_reported= true;
+    }
+    field->vcol_info= NULL;
+    goto parse_err;
+  }
+  //field->vcol_info->item_free_list= vcol_arena.free_list;
+
+  return(false);
+
+parse_err:
+  thd->lex->parse_vcol_expr= false;
+  thd->free_items();
+  return(true);
+}
+
+
+/*
   Open a table based on a TABLE_SHARE
 
   SYNOPSIS
@@ -1216,7 +1533,7 @@
   uint32_t records, i, bitmap_size;
   bool error_reported= false;
   unsigned char *record, *bitmaps;
-  Field **field_ptr;
+  Field **field_ptr, **vfield_ptr;
 
   /* Parsing of partitioning information from .frm needs thd->lex set up. */
   assert(thd->lex->is_lex_started);
@@ -1366,6 +1683,45 @@
     }
   }
 
+  /*
+    Process virtual columns, if any.
+  */
+  if (not (vfield_ptr = (Field **) alloc_root(&outparam->mem_root,
+                                              (uint) ((share->vfields+1)*
+                                                      sizeof(Field*)))))
+    goto err;
+
+  outparam->vfield= vfield_ptr;
+  
+  for (field_ptr= outparam->field; *field_ptr; field_ptr++)
+  {
+    if ((*field_ptr)->vcol_info)
+    {
+      if (unpack_vcol_info_from_frm(thd,
+                                    outparam,
+                                    *field_ptr,
+                                    &(*field_ptr)->vcol_info->expr_str,
+                                    open_mode,
+                                    &error_reported))
+      {
+        error= 4; // in case no error is reported
+        goto err;
+      }
+      *(vfield_ptr++)= *field_ptr;
+    }
+  }
+  *vfield_ptr= NULL;                              // End marker
+  /* Check virtual columns against table's storage engine. */
+  if ((share->vfields && outparam->file) && 
+        (not outparam->file->check_if_supported_virtual_columns()))
+  {
+    my_error(ER_UNSUPPORTED_ACTION_ON_VIRTUAL_COLUMN,
+             MYF(0), 
+             "Specified storage engine");
+    error_reported= true;
+    goto err;
+  }
+
   /* Allocate bitmaps */
 
   bitmap_size= share->column_bitmap_size;
@@ -2742,7 +3098,14 @@
   KEY_PART_INFO *key_part_end= (key_part +
                                 key_info[index].key_parts);
   for (;key_part != key_part_end; key_part++)
+  {
     bitmap_set_bit(bitmap, key_part->fieldnr-1);
+    if (key_part->field->vcol_info &&
+        key_part->field->vcol_info->expr_item)
+      key_part->field->vcol_info->
+               expr_item->walk(&Item::register_field_in_bitmap, 
+                               1, (unsigned char *) bitmap);
+  }
 }
 
 
@@ -2868,6 +3231,8 @@
       file->column_bitmaps_signal();
     }
   }
+  /* Mark all virtual columns as writable */
+  mark_virtual_columns();
   return;
 }
 
@@ -2883,7 +3248,42 @@
 {
   if (found_next_number_field)
     mark_auto_increment_column();
-}
+  /* Mark all virtual columns as writable */
+  mark_virtual_columns();
+}
+
+/* 
+  @brief Update the write and read table bitmap to allow
+         using procedure save_in_field for all virtual columns
+         in the table.
+
+  @return       void
+
+  @detail
+    Each virtual field is set in the write column map.
+    All fields that the virtual columns are based on are set in the
+    read bitmap.
+*/
+
+void Table::mark_virtual_columns(void)
+{
+  Field **vfield_ptr, *tmp_vfield;
+  bool bitmap_updated= false;
+
+  for (vfield_ptr= vfield; *vfield_ptr; vfield_ptr++)
+  {
+    tmp_vfield= *vfield_ptr;
+    assert(tmp_vfield->vcol_info && tmp_vfield->vcol_info->expr_item);
+    tmp_vfield->vcol_info->expr_item->walk(&Item::register_field_in_read_map, 
+                                           1, (unsigned char *) 0);
+    bitmap_set_bit(read_set, tmp_vfield->field_index);
+    bitmap_set_bit(write_set, tmp_vfield->field_index);
+    bitmap_updated= true;
+  }
+  if (bitmap_updated)
+    file->column_bitmaps_signal();
+}
+
 
 /*
   Cleanup this table for re-execution.
@@ -4757,6 +5157,53 @@
 }
 
 
+/*
+  Calculate data for each virtual field marked for write in the
+  corresponding column map.
+
+  SYNOPSIS
+    update_virtual_fields_marked_for_write()
+    table                  The Table object
+    ignore_stored          Indication whether physically stored virtual
+                           fields do not need updating.
+                           This value is false when during INSERT and UPDATE
+                           and true in all other cases.
+ 
+  RETURN
+    0  - Success
+    >0 - Error occurred during the generation/calculation of a virtual field value
+
+*/
+
+int update_virtual_fields_marked_for_write(Table *table,
+                                           bool ignore_stored)
+{
+  Field **vfield_ptr, *vfield;
+  int error= 0;
+  if ((not table) or (not table->vfield))
+    return(0);
+
+  /* Iterate over virtual fields in the table */
+  for (vfield_ptr= table->vfield; *vfield_ptr; vfield_ptr++)
+  {
+    vfield= (*vfield_ptr);
+    assert(vfield->vcol_info && vfield->vcol_info->expr_item);
+    /*
+      Only update those fields that are marked in the write_set bitmap
+      and not _already_ physically stored in the database.
+    */
+    if (bitmap_is_set(table->write_set, vfield->field_index) &&
+        (not (ignore_stored && vfield->is_stored))
+       )
+    {
+      /* Generate the actual value of the virtual fields */
+      error= vfield->vcol_info->expr_item->save_in_field(vfield, 0);
+    }
+  }
+  return(0);
+}
+
+
 /*****************************************************************************
 ** Instansiate templates
 *****************************************************************************/

=== modified file 'drizzled/table.h'
--- drizzled/table.h	2008-10-06 06:47:29 +0000
+++ drizzled/table.h	2008-10-07 04:51:08 +0000
@@ -196,6 +196,8 @@
   uint32_t   version, mysql_version;
   uint32_t   timestamp_offset;		/* Set to offset+1 of record */
   uint32_t   reclength;			/* Recordlength */
+  uint32_t   stored_rec_length;         /* Stored record length 
+                                           (no generated-only virtual fields) */
 
   plugin_ref db_plugin;			/* storage engine plugin */
   inline handlerton *db_type() const	/* table_type for handler */
@@ -208,12 +210,14 @@
   enum ha_choice transactional;
   enum ha_choice page_checksum;
 
-  uint32_t ref_count;                       /* How many Table objects uses this */
+  uint32_t ref_count;       /* How many Table objects uses this */
   uint32_t open_count;			/* Number of tables in open list */
   uint32_t blob_ptr_size;			/* 4 or 8 */
   uint32_t key_block_size;			/* create key_block_size, if used */
   uint32_t null_bytes, last_null_bit_pos;
   uint32_t fields;				/* Number of fields */
+  uint32_t stored_fields;                   /* Number of stored fields 
+                                           (i.e. without generated-only ones) */
   uint32_t rec_buff_length;                 /* Size of table->record[] buffer */
   uint32_t keys, key_parts;
   uint32_t max_key_length, max_unique_length, total_key_length;
@@ -234,6 +238,7 @@
   uint32_t error, open_errno, errarg;       /* error from open_table_def() */
   uint32_t column_bitmap_size;
   unsigned char frm_version;
+  uint32_t vfields;                         /* Number of virtual fields */
   bool null_field_first;
   bool db_low_byte_first;		/* Portable row format */
   bool crashed;
@@ -420,6 +425,7 @@
   Field *next_number_field;		/* Set if next_number is activated */
   Field *found_next_number_field;	/* Set on open */
   Field_timestamp *timestamp_field;
+  Field **vfield;                       /* Pointer to virtual fields*/
 
   TableList *pos_in_table_list;/* Element referring to this table */
   order_st *group;
@@ -561,6 +567,7 @@
   void mark_columns_needed_for_update(void);
   void mark_columns_needed_for_delete(void);
   void mark_columns_needed_for_insert(void);
+  void mark_virtual_columns(void);
   inline void column_bitmaps_set(MY_BITMAP *read_set_arg,
                                  MY_BITMAP *write_set_arg)
   {

=== modified file 'drizzled/unireg.cc'
--- drizzled/unireg.cc	2008-10-06 06:47:29 +0000
+++ drizzled/unireg.cc	2008-10-07 04:51:08 +0000
@@ -566,7 +566,7 @@
 {
   uint32_t length,int_count,int_length,no_empty, int_parts;
   uint32_t time_stamp_pos,null_fields;
-  ulong reclength, totlength, n_length, com_length;
+  ulong reclength, totlength, n_length, com_length, vcol_info_length;
 
 
   if (create_fields.elements > MAX_FIELDS)
@@ -578,7 +578,7 @@
   totlength= 0L;
   reclength= data_offset;
   no_empty=int_count=int_parts=int_length=time_stamp_pos=null_fields=
-    com_length=0;
+    com_length=vcol_info_length=0;
   n_length=2L;
 
 	/* Check fields */
@@ -600,6 +600,27 @@
                (uint) COLUMN_COMMENT_MAXLEN);
       return(1);
     }
+    if (field->vcol_info)
+    {
+      tmp_len= system_charset_info->cset->charpos(system_charset_info,
+                                                  field->vcol_info->expr_str.str,
+                                                  field->vcol_info->expr_str.str +
+                                                  field->vcol_info->expr_str.length,
+                                                  VIRTUAL_COLUMN_EXPRESSION_MAXLEN);
+
+      if (tmp_len < field->vcol_info->expr_str.length)
+      {
+        my_error(ER_WRONG_STRING_LENGTH, MYF(0),
+                 field->vcol_info->expr_str.str,"VIRTUAL COLUMN EXPRESSION",
+                 (uint) VIRTUAL_COLUMN_EXPRESSION_MAXLEN);
+        return(1);
+      }
+      /*
+        Sum up the length of the expression string and mandatory header bytes
+        to the total length.
+      */
+      vcol_info_length+= field->vcol_info->expr_str.length+(uint)FRM_VCOL_HEADER_SIZE;
+    }
 
     totlength+= field->length;
     com_length+= field->comment.length;
@@ -619,8 +640,6 @@
 	!time_stamp_pos)
       time_stamp_pos= (uint) field->offset+ (uint) data_offset + 1;
     length=field->pack_length;
-    /* Ensure we don't have any bugs when generating offsets */
-    assert(reclength == field->offset + data_offset);
     if ((uint) field->offset+ (uint) data_offset+ length > reclength)
       reclength=(uint) (field->offset+ data_offset + length);
     n_length+= (ulong) strlen(field->field_name)+1;
@@ -687,7 +706,8 @@
   /* Hack to avoid bugs with small static rows in MySQL */
   reclength=cmax((ulong)file->min_record_length(table_options),reclength);
   if (info_length+(ulong) create_fields.elements*FCOMP+288+
-      n_length+int_length+com_length > 65535L || int_count > 255)
+      n_length+int_length+com_length+vcol_info_length > 65535L || 
+      int_count > 255)
   {
     my_message(ER_TOO_MANY_FIELDS, ER(ER_TOO_MANY_FIELDS), MYF(0));
     return(1);
@@ -695,7 +715,7 @@
 
   memset(forminfo, 0, 288);
   length=(info_length+create_fields.elements*FCOMP+288+n_length+int_length+
-	  com_length);
+	  com_length+vcol_info_length);
   int2store(forminfo,length);
   forminfo[256] = (uint8_t) screens;
   int2store(forminfo+258,create_fields.elements);
@@ -712,7 +732,8 @@
   int2store(forminfo+280,22);			/* Rows needed */
   int2store(forminfo+282,null_fields);
   int2store(forminfo+284,com_length);
-  /* Up to forminfo+288 is free to use for additional information */
+  int2store(forminfo+286,vcol_info_length);
+  /* forminfo+288 is free to use for additional information */
   return(0);
 } /* pack_header */
 
@@ -751,7 +772,7 @@
                         ulong data_offset)
 {
   register uint32_t i;
-  uint32_t int_count, comment_length=0;
+  uint32_t int_count, comment_length=0, vcol_info_length=0;
   unsigned char buff[MAX_FIELD_WIDTH];
   Create_field *field;
   
@@ -764,6 +785,7 @@
   while ((field=it++))
   {
     uint32_t recpos;
+    uint32_t cur_vcol_expr_len= 0;
     buff[0]= (unsigned char) field->row;
     buff[1]= (unsigned char) field->col;
     buff[2]= (unsigned char) field->sc_length;
@@ -779,6 +801,17 @@
       buff[14]= (unsigned char) field->charset->number;
     else
       buff[14]= 0;				// Numerical
+    if (field->vcol_info)
+    {
+      /* 
+        Use the interval_id place in the .frm file to store the length of
+        virtual field's data.
+      */
+      buff[12]= cur_vcol_expr_len= field->vcol_info->expr_str.length +
+                (uint)FRM_VCOL_HEADER_SIZE;
+      vcol_info_length+= cur_vcol_expr_len+(uint)FRM_VCOL_HEADER_SIZE;
+      buff[13]= (unsigned char) DRIZZLE_TYPE_VIRTUAL;
+    }
     int2store(buff+15, field->comment.length);
     comment_length+= field->comment.length;
     set_if_bigger(int_count,field->interval_id);
@@ -873,6 +906,34 @@
 	  return(1);
     }
   }
+  if (vcol_info_length)
+  {
+    it.rewind();
+    int_count=0;
+    while ((field=it++))
+    {
+      /*
+        Pack each virtual field as follows:
+        byte 1      = 1 (always 1 to allow for future extensions)
+        byte 2      = sql_type
+        byte 3      = flags (as of now, 0 - no flags, 1 - field is physically stored)
+        byte 4-...  = virtual column expression (text data)
+      */
+      if (field->vcol_info && field->vcol_info->expr_str.length)
+      {
+        buff[0]= (unsigned char)1;
+        buff[1]= (unsigned char) field->sql_type;
+        buff[2]= (unsigned char) field->is_stored;
+        if (my_write(file, buff, 3, MYF_RW))
+          return(1);
+        if (my_write(file, 
+                     (unsigned char*) field->vcol_info->expr_str.str, 
+                     field->vcol_info->expr_str.length,
+                     MYF_RW))
+          return(1);
+      }
+    }
+  }
   return(0);
 }
 

=== modified file 'libdrizzle/drizzle_com.h'
--- libdrizzle/drizzle_com.h	2008-10-06 04:45:56 +0000
+++ libdrizzle/drizzle_com.h	2008-10-07 04:51:08 +0000
@@ -122,6 +122,12 @@
 #define COLUMN_COMMENT_MAXLEN 1024
 #define INDEX_COMMENT_MAXLEN 1024
 
+/* The length of the header part for each virtual column in the .frm file. */
+#define FRM_VCOL_HEADER_SIZE 3
+/*
+  Maximum length of the expression statement defined for virtual columns.
+*/
+#define VIRTUAL_COLUMN_EXPRESSION_MAXLEN 255 - FRM_VCOL_HEADER_SIZE
 
 /*
   USER_HOST_BUFF_SIZE -- length of string buffer, that is enough to contain
@@ -334,6 +340,7 @@
                         DRIZZLE_TYPE_TIME,
                         DRIZZLE_TYPE_DATETIME,
                         DRIZZLE_TYPE_NEWDATE, DRIZZLE_TYPE_VARCHAR,
+			                  DRIZZLE_TYPE_VIRTUAL=252,
                         DRIZZLE_TYPE_NEWDECIMAL=253,
                         DRIZZLE_TYPE_ENUM=254,
                         DRIZZLE_TYPE_BLOB=255

=== modified file 'storage/innobase/handler/ha_innodb.cc'
--- storage/innobase/handler/ha_innodb.cc	2008-10-06 07:55:10 +0000
+++ storage/innobase/handler/ha_innodb.cc	2008-10-07 04:51:08 +0000
@@ -2227,13 +2227,14 @@
 	}
 
 	/* Create buffers for packing the fields of a record. Why
-	table->reclength did not work here? Obviously, because char
+	table->stored_rec_length did not work here? Obviously, because char
 	fields when packed actually became 1 byte longer, when we also
 	stored the string length as the first byte. */
 
 	upd_and_key_val_buff_len =
-				table->s->reclength + table->s->max_key_length
-							+ MAX_REF_PARTS * 3;
+				table->s->stored_rec_length
+				+ table->s->max_key_length
+				+ MAX_REF_PARTS * 3;
 	if (!(unsigned char*) my_multi_malloc(MYF(MY_WME),
 			&upd_buff, upd_and_key_val_buff_len,
 			&key_val_buff, upd_and_key_val_buff_len,
@@ -2289,7 +2290,7 @@
 
 	prebuilt = row_create_prebuilt(ib_table);
 
-	prebuilt->mysql_row_len = table->s->reclength;
+	prebuilt->mysql_row_len = table->s->stored_rec_length;
         prebuilt->idx_cond_func= NULL;
 
 	/* Looks like MySQL-3.23 sometimes has primary key number != 0 */
@@ -2899,11 +2900,11 @@
 	dict_index_t*	clust_index;
 	mysql_row_templ_t* templ;
 	Field*		field;
-	ulint		n_fields;
+	ulint		n_fields, n_stored_fields;
 	ulint		n_requested_fields	= 0;
 	ibool		fetch_all_in_key	= FALSE;
 	ibool		fetch_primary_key_cols	= FALSE;
-	ulint		i;
+	ulint		i, sql_idx, innodb_idx  = 0;
 	/* byte offset of the end of last requested column */
 	ulint		mysql_prefix_len	= 0;
         ibool           do_idx_cond_push= FALSE;
@@ -2966,11 +2967,12 @@
 	}
 
 	n_fields = (ulint)table->s->fields; /* number of columns */
+	n_stored_fields= (ulint)table->s->stored_fields; /* number of stored columns */
 
 	if (!prebuilt->mysql_template) {
 		prebuilt->mysql_template = (mysql_row_templ_t*)
 						mem_alloc_noninline(
-					n_fields * sizeof(mysql_row_templ_t));
+					n_stored_fields * sizeof(mysql_row_templ_t));
 	}
 
 	prebuilt->template_type = templ_type;
@@ -2992,18 +2994,20 @@
           If index condition pushdown is used, the array is split into two
           parts: first go index fields, then go table fields.
 	  
-          Note that in InnoDB, i is the column number. MySQL calls columns
-	  'fields'.
+          Note that in InnoDB, innodb_idx is the column number. MySQL calls columns
+	  'fields' associated with index sql_idx.
         */
-	for (i = 0; i < n_fields; i++) {
+	for (sql_idx = 0; sql_idx < n_fields; sql_idx++) {
 		templ = prebuilt->mysql_template + n_requested_fields;
-		field = table->field[i];
+		field = table->field[sql_idx];
+		if (!field->is_stored)
+		       goto skip_field;
 
 		if (UNIV_LIKELY(templ_type == ROW_DRIZZLE_REC_FIELDS)) {
 			/* Decide which columns we should fetch
 			and which we can skip. */
 			register const ibool	index_contains_field =
-				dict_index_contains_col_or_prefix(index, i);
+				dict_index_contains_col_or_prefix(index, innodb_idx);
                         register const ibool    index_covers_field = 
                                 field->part_of_key.is_set(file->active_index);
 
@@ -3020,8 +3024,8 @@
 				goto include_field;
 			}
 
-                        if (bitmap_is_set(table->read_set, i) ||
-                            bitmap_is_set(table->write_set, i)) {
+                        if (bitmap_is_set(table->read_set, sql_idx) ||
+                            bitmap_is_set(table->write_set, sql_idx)) {
 				/* This field is needed in the query */
 
 				goto include_field;
@@ -3029,7 +3033,7 @@
 
 			if (fetch_primary_key_cols
 				&& dict_table_col_in_clustered_key(
-					index->table, i)) {
+					index->table, innodb_idx)) {
 				/* This field is needed in the query */
 
 				goto include_field;
@@ -3046,14 +3050,14 @@
 		}
 		n_requested_fields++;
 
-		templ->col_no = i;
+		templ->col_no = innodb_idx;
 
 		if (index == clust_index) {
 			templ->rec_field_no = dict_col_get_clust_pos_noninline(
-				&index->table->cols[i], index);
+				&index->table->cols[innodb_idx], index);
 		} else {
 			templ->rec_field_no = dict_index_get_nth_col_pos(
-								index, i);
+								index, innodb_idx);
 		}
 
 		if (templ->rec_field_no == ULINT_UNDEFINED) {
@@ -3079,7 +3083,7 @@
 			mysql_prefix_len = templ->mysql_col_offset
 				+ templ->mysql_col_len;
 		}
-		templ->type = index->table->cols[i].mtype;
+		templ->type = index->table->cols[innodb_idx].mtype;
 		templ->mysql_type = (ulint)field->type();
 
 		if (templ->mysql_type == DATA_DRIZZLE_TRUE_VARCHAR) {
@@ -3088,20 +3092,25 @@
 		}
 
 		templ->charset = dtype_get_charset_coll_noninline(
-				index->table->cols[i].prtype);
-		templ->mbminlen = index->table->cols[i].mbminlen;
-		templ->mbmaxlen = index->table->cols[i].mbmaxlen;
-		templ->is_unsigned = index->table->cols[i].prtype
+				index->table->cols[innodb_idx].prtype);
+		templ->mbminlen = index->table->cols[innodb_idx].mbminlen;
+		templ->mbmaxlen = index->table->cols[innodb_idx].mbmaxlen;
+		templ->is_unsigned = index->table->cols[innodb_idx].prtype
 							& DATA_UNSIGNED;
 		if (templ->type == DATA_BLOB) {
 			prebuilt->templ_contains_blob = TRUE;
 		}
 skip_field:
-		if (need_second_pass && (i+1 == n_fields))
+                if (field->is_stored)
+                {
+                  innodb_idx++;
+                }
+		if (need_second_pass && (sql_idx+1 == n_fields))
 		{
                   prebuilt->n_index_fields= n_requested_fields;
 		  need_second_pass= FALSE;
-		  i= (~(ulint)0); /* to start from 0 */
+		  sql_idx= (~(ulint)0); /* to start from 0 */
+		  innodb_idx= 0;
 		}
 	}
 
@@ -3484,7 +3493,7 @@
 	ulint		n_changed = 0;
 	dfield_t	dfield;
 	dict_index_t*	clust_index;
-	uint		i;
+	uint		sql_idx, innodb_idx= 0;
 
 	n_fields = table->s->fields;
 	clust_index = dict_table_get_first_index_noninline(prebuilt->table);
@@ -3492,8 +3501,10 @@
 	/* We use upd_buff to convert changed fields */
 	buf = (byte*) upd_buff;
 
-	for (i = 0; i < n_fields; i++) {
-		field = table->field[i];
+	for (sql_idx = 0; sql_idx < n_fields; sql_idx++) {
+		field = table->field[sql_idx];
+		if (!field->is_stored)
+		  continue;
 
 		o_ptr = (byte*) old_row + get_field_offset(table, field);
 		n_ptr = (byte*) new_row + get_field_offset(table, field);
@@ -3511,7 +3522,7 @@
 
 		field_mysql_type = field->type();
 
-		col_type = prebuilt->table->cols[i].mtype;
+		col_type = prebuilt->table->cols[innodb_idx].mtype;
 
 		switch (col_type) {
 
@@ -3566,7 +3577,7 @@
 			/* Let us use a dummy dfield to make the conversion
 			from the MySQL column format to the InnoDB format */
 
-			dict_col_copy_type_noninline(prebuilt->table->cols + i,
+			dict_col_copy_type_noninline(prebuilt->table->cols + innodb_idx,
 						     &dfield.type);
 
 			if (n_len != UNIV_SQL_NULL) {
@@ -3587,9 +3598,11 @@
 
 			ufield->exp = NULL;
 			ufield->field_no = dict_col_get_clust_pos_noninline(
-				&prebuilt->table->cols[i], clust_index);
+				&prebuilt->table->cols[innodb_idx], clust_index);
 			n_changed++;
 		}
+		if (field->is_stored)
+		  innodb_idx++;
 	}
 
 	uvect->n_fields = n_changed;
@@ -4519,7 +4532,7 @@
 	/* We pass 0 as the space id, and determine at a lower level the space
 	id where to store the table */
 
-	table = dict_mem_table_create(table_name, 0, n_cols, flags);
+	table = dict_mem_table_create(table_name, 0, form->s->stored_fields, flags);
 
 	if (path_of_temp_table) {
 		table->dir_path_of_temp_table =
@@ -4528,6 +4541,8 @@
 
 	for (i = 0; i < n_cols; i++) {
 		field = form->field[i];
+		if (!field->is_stored)
+		  continue;
 
 		col_type = get_innobase_type_from_mysql_type(&unsigned_type,
 									field);
@@ -4789,7 +4804,7 @@
 
 	assert(thd != NULL);
 
-	if (form->s->fields > 1000) {
+	if (form->s->stored_fields > 1000) {
 		/* The limit probably should be REC_MAX_N_FIELDS - 3 = 1020,
 		but we play safe here */
 
@@ -5280,10 +5295,10 @@
 	KEY*		key;
 	dict_index_t*	index;
 	unsigned char*		key_val_buff2	= (unsigned char*) my_malloc(
-						  table->s->reclength
+						  table->s->stored_rec_length
 					+ table->s->max_key_length + 100,
 								MYF(MY_FAE));
-	ulint		buff2_len = table->s->reclength
+	ulint		buff2_len = table->s->stored_rec_length
 					+ table->s->max_key_length + 100;
 	dtuple_t*	range_start;
 	dtuple_t*	range_end;

=== modified file 'storage/innobase/handler/ha_innodb.h'
--- storage/innobase/handler/ha_innodb.h	2008-10-06 06:47:29 +0000
+++ storage/innobase/handler/ha_innodb.h	2008-10-07 04:51:08 +0000
@@ -216,6 +216,7 @@
 	int cmp_ref(const unsigned char *ref1, const unsigned char *ref2);
 	bool check_if_incompatible_data(HA_CREATE_INFO *info,
 					uint32_t table_changes);
+	bool check_if_supported_virtual_columns(void) { return true; }
 public:
   /**
    * Multi Range Read interface

=== modified file 'storage/myisam/ha_myisam.cc'
--- storage/myisam/ha_myisam.cc	2008-10-06 06:47:29 +0000
+++ storage/myisam/ha_myisam.cc	2008-10-07 04:51:08 +0000
@@ -212,7 +212,7 @@
   record= table_arg->record[0];
   recpos= 0;
   recinfo_pos= recinfo;
-  while (recpos < (uint) share->reclength)
+  while (recpos < (uint) share->stored_rec_length)
   {
     Field **field, *found= 0;
     minpos= share->reclength;

=== modified file 'storage/myisam/ha_myisam.h'
--- storage/myisam/ha_myisam.h	2008-10-06 06:47:29 +0000
+++ storage/myisam/ha_myisam.h	2008-10-07 04:51:08 +0000
@@ -155,6 +155,7 @@
   
   /* Index condition pushdown implementation */
   Item *idx_cond_push(uint32_t keyno, Item* idx_cond);
+  bool check_if_supported_virtual_columns(void) { return true; }
 private:
   DsMrr_impl ds_mrr;
   key_map keys_with_parts;

=== modified file 'tests/Makefile.am'
--- tests/Makefile.am	2008-09-25 10:04:06 +0000
+++ tests/Makefile.am	2008-10-07 04:51:08 +0000
@@ -194,3 +194,6 @@
         unsafe_binlog_innodb \
         update \
         variables-notembedded
+	  $(PERL) -I$(top_srcdir)/tests/lib \
+		$(top_srcdir)/tests/test-run.pl --fast --reorder --force \
+		--suite=vcol

=== added directory 'tests/suite/vcol'
=== added directory 'tests/suite/vcol/inc'
=== added file 'tests/suite/vcol/inc/vcol_blocked_sql_funcs_main.inc'
--- tests/suite/vcol/inc/vcol_blocked_sql_funcs_main.inc	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/inc/vcol_blocked_sql_funcs_main.inc	2008-09-19 11:49:17 +0000
@@ -0,0 +1,242 @@
+################################################################################
+# inc/vcol_blocked_sql_funcs_main.inc                                          #
+#                                                                              #
+# Purpose:                                                                     #
+#  Tests around sql functions                                                  #
+#                                                                              #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-08-31                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE:  All SQL functions should be rejected, otherwise BUG.
+#
+
+--echo # RAND()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (b virtual double as (rand()));
+
+--echo # LOAD_FILE()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a varchar(64), b virtual varchar(1024) as (load_file(a)));
+
+--echo # CURDATE()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual datetime as (curdate()));
+
+--echo # CURRENT_DATE(), CURRENT_DATE
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual datetime as (current_date));
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual datetime as (current_date()));
+
+--echo # CURRENT_TIME(), CURRENT_TIME
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual datetime as (current_time));
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual datetime as (current_time()));
+
+--echo # CURRENT_TIMESTAMP(), CURRENT_TIMESTAMP
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual datetime as (current_timestamp()));
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual datetime as (current_timestamp));
+
+--echo # CURTIME()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual datetime as (curtime()));
+
+--echo # LOCALTIME(), LOCALTIME
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a datetime, b virtual varchar(10) as (localtime())); 
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a datetime, b virtual varchar(10) as (localtime)); 
+
+--echo # LOCALTIMESTAMP, LOCALTIMESTAMP()(v4.0.6)
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a datetime, b virtual varchar(10) as (localtimestamp()));
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a datetime, b virtual varchar(10) as (localtimestamp));
+
+--echo # NOW()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a datetime, b virtual varchar(10) as (now()));
+
+--echo # SYSDATE()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a int, b virtual varchar(10) as (sysdate()));
+
+--echo # UNIX_TIMESTAMP()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a datetime, b virtual datetime as (unix_timestamp()));
+
+--echo # UTC_DATE()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a datetime, b virtual datetime as (utc_date()));
+
+--echo # UTC_TIME()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a datetime, b virtual datetime as (utc_time()));
+
+--echo # UTC_TIMESTAMP()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a datetime, b virtual datetime as (utc_timestamp()));
+
+--echo # BENCHMARK()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a varchar(1024), b virtual varchar(1024) as (benchmark(a,3)));
+
+--echo # CONNECTION_ID()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual int as (connection_id()));
+
+--echo # CURRENT_USER(), CURRENT_USER
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual varchar(32) as (current_user()));
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual varchar(32) as (current_user));
+
+--echo # DATABASE()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a varchar(1024), b virtual varchar(1024) as (database()));
+
+--echo # FOUND_ROWS()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a varchar(1024), b virtual varchar(1024) as (found_rows()));
+
+--echo # LAST_INSERT_ID()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual int as (last_insert_id()));
+
+--echo # MASTER_POS_WAIT()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a varchar(32), b virtual int as (master_pos_wait(a,0,2)));
+
+--echo # ROW_COUNT()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual int as (row_count()));
+
+--echo # SCHEMA()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual varchar(32) as (schema()));
+
+--echo # SESSION_USER()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual varchar(32) as (session_user()));
+
+--echo # SYSTEM_USER()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual varchar(32) as (system_user()));
+
+--echo # USER()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a varchar(1024), b virtual varchar(1024) as (user()));
+
+--echo # UUID()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a virtual varchar(1024) as (uuid()));
+
+--echo # VALUES()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a varchar(1024), b virtual varchar(1024) as (values(a)));
+
+--echo # VERSION()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a varchar(1024), b virtual varchar(1024) as (version())); 
+
+--echo # Unknown functions
+-- error ER_SP_DOES_NOT_EXIST
+create table t1 (a virtual int as (f1()));
+
+--echo # WEIGHT_STRING()
+-- error ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED
+create table t1 (a varchar(5), b virtual varchar(10) as (weight_string(a as char(4))));
+
+--echo #
+--echo # GROUP BY FUNCTIONS
+--echo #
+
+--echo # AVG()
+-- error 1111
+create table t1 (a int, b virtual int as (avg(a)));
+
+--echo # COUNT(DISTINCT)
+-- error 1111
+create table t1 (a int, b virtual int as (count(distinct a)));
+
+--echo # COUNT()
+-- error 1111
+create table t1 (a int, b virtual int as (count(a)));
+
+--echo # GROUP_CONCAT()
+-- error 1111
+create table t1 (a varchar(32), b virtual int as (group_concat(a,'')));
+
+--echo # MAX()
+-- error 1111
+create table t1 (a int, b virtual int as (max(a)));
+
+--echo # MIN()
+-- error 1111
+create table t1 (a int, b virtual int as (min(a)));
+
+--echo # STD()
+-- error 1111
+create table t1 (a int, b virtual int as (std(a)));
+
+--echo # STDDEV_POP()
+-- error 1111
+create table t1 (a int, b virtual int as (stddev_pop(a)));
+
+--echo # STDDEV_SAMP()
+-- error 1111
+create table t1 (a int, b virtual int as (stddev_samp(a)));
+
+--echo # STDDEV()
+-- error 1111
+create table t1 (a int, b virtual int as (stddev(a)));
+
+--echo # SUM()
+-- error 1111
+create table t1 (a int, b virtual int as (sum(a)));
+
+--echo # VAR_POP()
+-- error 1111
+create table t1 (a int, b virtual int as (var_pop(a)));
+
+--echo # VAR_SAMP()
+-- error 1111
+create table t1 (a int, b virtual int as (var_samp(a)));
+
+--echo # VARIANCE()
+-- error 1111
+create table t1 (a int, b virtual int as (variance(a)));
+
+--echo #
+--echo # Sub-selects
+--echo #
+
+create table t1 (a int);
+-- error 1064
+create table t2 (a int, b virtual int as (select count(*) from t1));
+drop table t1;
+
+--echo #
+--echo # Long expression
+
+let $tmp_long_string = `SELECT repeat('a',240)`;
+eval create table t1 (a int, b virtual varchar(300) as (concat(a,'$tmp_long_string')));
+drop table t1;
+let $tmp_long_string = `SELECT repeat('a',243)`;
+--error 1470
+eval create table t1 (a int, b virtual varchar(300) as (concat(a,'$tmp_long_string')));
+
+--echo #
+--echo # Constant expression
+--error ER_CONST_EXPR_IN_VCOL
+create table t1 (a virtual int as (1));

=== added file 'tests/suite/vcol/inc/vcol_cleanup.inc'
--- tests/suite/vcol/inc/vcol_cleanup.inc	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/inc/vcol_cleanup.inc	2008-09-19 11:49:17 +0000
@@ -0,0 +1,19 @@
+################################################################################
+# inc/vcol_cleanup.inc                                                         #
+#                                                                              #
+# Purpose:                                                                     #
+#   Removal of the objects created by the t/<test_name>.test                   #
+#   scripts.                                                                   #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-08-31                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+--disable_warnings
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+--enable_warnings

=== added file 'tests/suite/vcol/inc/vcol_column_def_options.inc'
--- tests/suite/vcol/inc/vcol_column_def_options.inc	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/inc/vcol_column_def_options.inc	2008-09-19 11:49:17 +0000
@@ -0,0 +1,113 @@
+################################################################################
+# inc/vcol_column_def_options.inc                                              #
+#                                                                              #
+# Purpose:                                                                     #
+#  Testing different optional parameters specified when defining               #
+#  a virtual column.                                                           #
+#                                                                              #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-02                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+--echo #
+--echo # Section 1. Wrong column definition options
+--echo #            - NOT NULL
+--echo #            - NULL
+--echo #            - DEFAULT <value>
+--echo #            - AUTO_INCREMENT
+--echo #            - [PRIMARY] KEY
+
+--echo # NOT NULL
+--error 1064
+create table t1 (a int, b virtual int as (a+1) not null);
+create table t1 (a int);
+--error 1064
+alter table t1 add column b virtual int as (a+1) not null;
+drop table t1;
+
+--echo # NULL  
+--error 1064
+create table t1 (a int, b virtual int as (a+1) null);
+create table t1 (a int);
+--error 1064
+alter table t1 add column b virtual int as (a+1) null;
+drop table t1;
+
+--echo # DEFAULT
+--error 1064
+create table t1 (a int, b virtual int as (a+1) default 0);
+create table t1 (a int);
+--error 1064
+alter table t1 add column b virtual int as (a+1) default 0;
+drop table t1;
+
+--echo # AUTO_INCREMENT
+--error 1064
+create table t1 (a int, b virtual int as (a+1) AUTO_INCREMENT);
+create table t1 (a int);
+--error 1064
+alter table t1 add column b virtual int as (a+1) AUTO_INCREMENT;
+drop table t1;
+
+--echo # [PRIMARY] KEY
+--error 1064
+create table t1 (a int, b virtual int as (a+1) key);
+--error 1064
+create table t1 (a int, b virtual int as (a+1) primary key);
+create table t1 (a int);
+--error 1064
+alter table t1 add column b virtual int as (a+1) key;
+--error 1064
+alter table t1 add column b virtual int as (a+1) primary key;
+drop table t1;
+
+--echo # Section 2. Other column definition options
+--echo #            - COMMENT
+--echo #            - REFERENCES (only syntax testing here)
+--echo #            - STORED (only systax testing here)
+create table t1 (a int, b virtual int as (a % 2) comment 'my comment');
+show create table t1;
+describe t1;
+drop table t1;
+create table t1 (a int, b virtual int as (a % 2));
+alter table t1 modify b virtual int as (a % 2) comment 'my comment';
+show create table t1;
+describe t1;
+insert into t1 (a) values (1);
+select * from t1;
+insert into t1 values (2,default);
+select a,b from t1;
+create table t2 like t1;
+show create table t2;
+describe t2;
+insert into t2 (a) values (1);
+select * from t2;
+insert into t2 values (2,default);
+select a,b from t2;
+drop table t2;
+drop table t1;
+
+create table t1 (a int, b virtual int as (a % 2) stored); 
+show create table t1;
+describe t1;
+insert into t1 (a) values (1);
+select * from t1;
+insert into t1 values (2,default);
+select a,b from t1;
+drop table t1;
+
+
+create table t2 (a int);
+create table t1 (a int, b virtual int as (a % 2) stored references t2(a));
+show create table t1;
+drop table t1;
+create table t1 (a int, b virtual int as (a % 2));
+--error 1064
+alter table t1 modify b virtual int as (a % 2) stored references t2(a);
+show create table t1;
+drop table t1;

=== added file 'tests/suite/vcol/inc/vcol_dependancies_on_vcol.inc'
--- tests/suite/vcol/inc/vcol_dependancies_on_vcol.inc	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/inc/vcol_dependancies_on_vcol.inc	2008-09-19 11:49:17 +0000
@@ -0,0 +1,43 @@
+################################################################################
+# inc/vcol_dependencies_on_vcol.inc                                            #
+#                                                                              #
+# Purpose:                                                                     #
+#  Testing scenarios when columns depend on virtual columns, i.e. such as      #
+#   - a virtual column is based on a virtual column                            #
+#   - a "real" column on which a virtual one is renamed/dropped                #
+#   - a virtual column involved in partitioning is renamed/dropped             #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-02                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+--echo # Can't define a virtual column on another virtual column
+--error ER_VCOL_BASED_ON_VCOL
+create table t1 (a int, b virtual int as (a+1), c virtual int as (b+1));
+create table t1 (a int, b virtual int as (a+1));
+--error ER_VCOL_BASED_ON_VCOL
+alter table t1 add column c virtual int as (b+1);
+drop table t1;
+
+--echo # Can't rename or drop a column used in the function of a virtual column
+create table t1 (a int, b virtual int as (a+1));
+--echo # On renaming/dropping a column on which a virtual field is 
+--echo # defined the following error is displayed: 
+--echo # "Unknown column 'a' in 'virtual column function'"
+--error 1054
+alter table t1 drop column a;
+--error 1054
+alter table t1 change a c int;
+drop table t1;
+
+--echo # Can't rename or drop a virtual column used by the paritition function
+create table t1 (a int, b virtual int as (a+1)) partition by hash(b);  
+--error 1054
+alter table t1 drop b;                                               
+--error 1054
+alter table t1 change b c virtual int as (a+1);
+

=== added file 'tests/suite/vcol/inc/vcol_handler.inc'
--- tests/suite/vcol/inc/vcol_handler.inc	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/inc/vcol_handler.inc	2008-09-19 11:49:17 +0000
@@ -0,0 +1,77 @@
+################################################################################
+# inc/vcol_handler.inc                                                         #
+#                                                                              #
+# Purpose:                                                                     #
+#  Testing HANDLER.                                                            #
+#                                                                              #
+#                                                                              #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-04                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+create table t1 (a int, 
+                 b virtual int as (-a),
+		 c virtual int as (-a) stored,
+		 d char(1),
+		 index (a),
+		 index (c));
+insert into t1 (a,d) values (4,'a'), (2,'b'), (1,'c'), (3,'d');
+select * from t1;
+
+--echo # HANDLER tbl_name OPEN
+handler t1 open;
+
+--echo # HANDLER tbl_name READ non-vcol_index_name > (value1,value2,…)
+handler t1 read a > (2);
+
+--echo # HANDLER tbl_name READ non-vcol_index_name > (value1,value2,…) WHERE non-vcol_field=expr
+handler t1 read a > (2) where d='c';
+
+--echo # HANDLER tbl_name READ vcol_index_name = (value1,value2,…)
+handler t1 read c = (-2);
+
+--echo # HANDLER tbl_name READ vcol_index_name = (value1,value2,…) WHERE non-vcol_field=expr
+handler t1 read c = (-2) where d='c';
+
+--echo # HANDLER tbl_name READ non-vcol_index_name > (value1,value2,…) WHERE vcol_field=expr
+handler t1 read a > (2) where b=-3 && c=-3;
+
+--echo # HANDLER tbl_name READ vcol_index_name <= (value1,value2,…)
+handler t1 read c <= (-2);
+
+--echo # HANDLER tbl_name READ vcol_index_name > (value1,value2,…) WHERE vcol_field=expr
+handler t1 read c <= (-2) where b=-3;
+
+--echo # HANDLER tbl_name READ vcol_index_name FIRST
+handler t1 read c first;
+
+--echo # HANDLER tbl_name READ vcol_index_name NEXT
+handler t1 read c next;
+
+--echo # HANDLER tbl_name READ vcol_index_name PREV
+handler t1 read c prev;
+
+--echo # HANDLER tbl_name READ vcol_index_name LAST
+handler t1 read c last;
+
+--echo # HANDLER tbl_name READ FIRST where non-vcol=expr
+handler t1 read FIRST where a >= 2; 
+
+--echo # HANDLER tbl_name READ FIRST where vcol=expr
+handler t1 read FIRST where b >= -2; 
+
+--echo # HANDLER tbl_name READ NEXT where non-vcol=expr
+handler t1 read NEXT where d='c'; 
+
+--echo # HANDLER tbl_name READ NEXT where vcol=expr
+handler t1 read NEXT where b<=-4; 
+
+--echo # HANDLER tbl_name CLOSE
+handler t1 close;
+
+drop table t1;

=== added file 'tests/suite/vcol/inc/vcol_init_vars.pre'
--- tests/suite/vcol/inc/vcol_init_vars.pre	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/inc/vcol_init_vars.pre	2008-09-19 11:49:17 +0000
@@ -0,0 +1,17 @@
+################################################################################
+# inc/vcol_init_vars.pre                                                       #
+#                                                                              #
+# Purpose:                                                                     #
+#  Initialize variables used in t/<name> test cases.                           #
+#                                                                              #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-08-31                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+let $skip_full_text_check = 0;
+let $skip_spatial_index_check = 0;

=== added file 'tests/suite/vcol/inc/vcol_ins_upd.inc'
--- tests/suite/vcol/inc/vcol_ins_upd.inc	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/inc/vcol_ins_upd.inc	2008-09-19 11:49:17 +0000
@@ -0,0 +1,289 @@
+################################################################################
+# inc/vcol_ins_upd.inc                                                         #
+#                                                                              #
+# Purpose:                                                                     #
+#  Testing DDL operations such as INSERT, UPDATE, REPLACE and DELETE.          #
+#                                                                              #
+#                                                                              #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-04                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+let $create1 = create table t1 (a int, 
+                                b virtual int as (-a),
+				c virtual int as (-a) stored);
+let $create2 = create table t1 (a int unique, 
+                                b virtual int as (-a),
+				c virtual int as (-a) stored);
+let $create3 = create table t1 (a int, 
+                                b virtual int as (-a),
+				c virtual int as (-a) stored unique);
+let $create4 = create table t1 (a int, 
+                                b virtual int as (-a),
+				c virtual int as (-a) stored unique,
+				d varchar(16));
+eval $create1;
+set sql_warnings = 1;
+
+--echo #
+--echo # *** INSERT ***
+--echo #
+
+--echo # INSERT INTO tbl_name VALUES… DEFAULT is specified against vcols
+insert into t1 values (1,default,default);
+select * from t1;
+delete from t1;
+select * from t1;
+
+--echo # INSERT INTO tbl_name VALUES… NULL is specified against vcols
+insert into t1 values (1,null,null);
+select * from t1;
+delete from t1;
+select * from t1;
+
+--echo # INSERT INTO tbl_name VALUES… a non-NULL value is specified against vcols
+insert into t1 values (1,2,3);
+select * from t1;
+delete from t1;
+select * from t1;
+
+--echo # INSERT INTO tbl_name (<non_vcol_list>) VALUES…
+insert into t1 (a) values (1), (2);
+select * from t1;
+delete from t1;
+select * from t1;
+
+--echo # INSERT INTO tbl_name (<normal+vcols>) VALUES… DEFAULT is specified 
+--echo # against vcols
+insert into t1 (a,b) values (1,default), (2,default);
+select * from t1;
+delete from t1;
+select * from t1;
+
+--echo # INSERT INTO tbl_name (<normal+vcols>) VALUES… NULL is specified against vcols
+insert into t1 (a,b) values (1,null), (2,null);
+select * from t1;
+delete from t1;
+select * from t1;
+
+--echo # INSERT INTO tbl_name (<normal+vcols>) VALUES… a non-NULL value is specified 
+--echo # against vcols
+insert into t1 (a,b) values (1,3), (2,4);
+select * from t1;
+delete from t1;
+select * from t1;
+drop table t1;
+
+--echo # Table with UNIQUE non-vcol field. INSERT INTO tbl_name VALUES… ON DUPLICATE 
+--echo # KEY UPDATE <non_vcol>=expr, <vcol>=expr
+eval $create2;
+insert into t1 values (1,default,default);
+insert into t1 values (1,default,default) 
+       on duplicate key update a=2, b=default;
+select a,b,c from t1;
+delete from t1 where b in (1,2);
+select * from t1;
+drop table t1;
+
+--echo # Table with UNIQUE vcol field. INSERT INTO tbl_name VALUES… ON DUPLICATE 
+--echo # KEY UPDATE <non_vcol>=expr, <vcol>=expr
+eval $create3;
+insert into t1 values (1,default,default);
+insert into t1 values (1,default,default) 
+       on duplicate key update a=2, b=default;
+select a,b,c from t1;
+
+--echo # CREATE new_table … LIKE old_table
+--echo # INSERT INTO new_table SELECT * from old_table
+create table t2 like t1;
+insert into t2 select * from t1;
+select * from t1;
+drop table t2;
+
+--echo # CREATE new_table … LIKE old_table INSERT INTO new_table (<non-vcols>, <vcols>) 
+--echo # SELECT <non-vcols>, <vcols> from old_table
+insert into t1 values (1,default,default);
+select * from t1;
+create table t2 like t1;
+insert into t2 (a,b) select a,b from t1;
+select * from t2;
+drop table t2;
+drop table t1;
+
+--echo #
+--echo # *** UPDATE ***
+--echo #
+
+--echo # UPDATE tbl_name SET non-vcol=expr WHERE non-vcol=expr
+eval $create1;
+insert into t1 (a) values (1), (2);
+select * from t1;
+update t1 set a=3 where a=2;
+select * from t1;
+delete from t1;
+select * from t1;
+
+--echo # UPDATE tbl_name SET vcol=expr WHERE non-vcol=expr
+insert into t1 (a) values (1), (2);
+select * from t1;
+update t1 set c=3 where a=2;
+select * from t1;
+delete from t1;
+select * from t1;
+
+--echo # UPDATE tbl_name SET non-vcol=expr WHERE vcol=expr
+insert into t1 (a) values (1), (2);
+select * from t1;
+update t1 set a=3 where b=-2;
+select * from t1;
+delete from t1;
+select * from t1;
+
+--echo # UPDATE tbl_name SET vcol=expr WHERE vcol=expr
+insert into t1 (a) values (1), (2);
+select * from t1;
+update t1 set c=3 where b=-2;
+select * from t1;
+delete from t1;
+select * from t1;
+drop table t1;
+
+--echo # INDEX created on vcol 
+--echo # UPDATE tbl_name SET non-vcol=expr WHERE vcol=const
+eval $create3;
+insert into t1 (a) values (1), (2);
+select * from t1;
+update t1 set a=3 where c=-2;
+select * from t1;
+delete from t1;
+select * from t1;
+
+
+--echo # INDEX created on vcol 
+--echo # UPDATE tbl_name SET non-vcol=expr WHERE vcol=between const1 and const2
+insert into t1 (a) values (1), (2);
+select * from t1;
+update t1 set a=3 where c between -3 and -2;
+select * from t1;
+delete from t1;
+select * from t1;
+
+--echo # No INDEX created on vcol 
+--echo # UPDATE tbl_name SET non-vcol=expr WHERE vcol=between const1 and const2
+insert into t1 (a) values (1), (2);
+select * from t1;
+update t1 set a=3 where b between -3 and -2;
+select * from t1;
+delete from t1;
+select * from t1;
+
+--echo # INDEX created on vcol 
+--echo # UPDATE tbl_name SET non-vcol=expr 
+--echo # WHERE vcol=between const1 and const2 ORDER BY vcol
+insert into t1 (a) values (1), (2), (3), (4), (5);
+select * from t1;
+update t1 set a=6 where c between -1 and 0
+          order by c;
+select * from t1;
+delete from t1 where c between -6 and 0;
+select * from t1;
+
+--echo # INDEX created on vcol 
+--echo # UPDATE tbl_name SET non-vcol=expr 
+--echo # WHERE vcol=between const1 and const2 ORDER BY vcol LIMIT 2
+insert into t1 (a) values (1), (2), (3), (4), (5);
+select * from t1;
+update t1 set a=6 where c between -1 and 0
+          order by c limit 2;
+select * from t1;
+delete from t1 where c between -2 and 0 order by c;
+select * from t1;
+delete from t1;
+
+--echo # INDEX created on vcol 
+--echo # UPDATE tbl_name SET non-vcol=expr
+--echo # WHERE indexed vcol=between const1 and const2 and non-indexed vcol=const3
+insert into t1 (a) values (1), (2), (3), (4), (5);
+select * from t1;
+update t1 set a=6 where (c between -2 and 0) and (b=-1);
+select * from t1;
+delete from t1;
+
+--echo # INDEX created on vcol 
+--echo # UPDATE tbl_name SET non-vcol=expr
+--echo # WHERE indexed vcol=between const1 and const2 and non-indexed vcol=const3
+--echo # ORDER BY indexed vcol
+insert into t1 (a) values (1), (2), (3), (4), (5);
+select * from t1;
+update t1 set a=6 where (c between -2 and 0) and (b=-1) order by c;
+select * from t1;
+delete from t1;
+drop table t1;
+
+let $innodb_engine = `SELECT @@session.storage_engine='innodb'`;
+if ($innodb_engine)
+{
+  --echo #
+  --echo # Verify ON UPDATE/DELETE actions of FOREIGN KEYs
+  create table t2 (a int primary key, name varchar(10));
+  create table t1 (a int primary key, b virtual int as (a % 10) stored);
+  insert into t2 values (1, 'value1'), (2,'value2'), (3,'value3');
+  insert into t1 (a) values (1),(2),(3);
+  select * from t1;
+  select * from t2;
+  select t1.a, t1.b, t2.name from t1,t2 where t1.b=t2.a;
+
+  --echo #  - ON UPDATE RESTRICT
+  alter table t1 add foreign key (b) references t2(a) on update restrict;
+  --error 1452
+  insert into t1 (a) values (4);
+  --error 1451
+  update t2 set a=4 where a=3;
+  select t1.a, t1.b, t2.name from t1,t2 where t1.b=t2.a;
+  alter table t1 drop foreign key t1_ibfk_1;
+
+  --echo #  - ON DELETE RESTRICT
+  alter table t1 add foreign key (b) references t2(a) on delete restrict;
+  --error 1451
+  delete from t2 where a=3;
+  select t1.a, t1.b, t2.name from t1,t2 where t1.b=t2.a;
+  select t1.a, t1.b, t2.name from t1 left outer join t2 on (t1.b=t2.a);
+  alter table t1 drop foreign key t1_ibfk_1;
+
+  --echo #  - ON DELETE CASCADE
+  alter table t1 add foreign key (b) references t2(a) on delete cascade;
+  delete from t2 where a=3;
+  select t1.a, t1.b, t2.name from t1,t2 where t1.b=t2.a;
+  select t1.a, t1.b, t2.name from t1 left outer join t2 on (t1.b=t2.a);
+  alter table t1 drop foreign key t1_ibfk_1;
+
+  drop table t1;
+  drop table t2;
+}
+
+--echo #
+--echo # *** REPLACE ***
+--echo #
+
+--echo # UNIQUE INDEX on vcol
+--echo # REPLACE tbl_name (non-vcols) VALUES (non-vcols);
+eval $create4;
+insert into t1 (a,d) values (1,'a'), (2,'b');
+select * from t1;
+replace t1 (a,d) values (1,'c');
+select * from t1;
+delete from t1;
+select * from t1;
+
+
+# *** DELETE
+# All required tests for DELETE are performed as part of the above testing
+# for INSERT, UPDATE and REPLACE.
+
+set sql_warnings = 0;
+drop table t1;

=== added file 'tests/suite/vcol/inc/vcol_keys.inc'
--- tests/suite/vcol/inc/vcol_keys.inc	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/inc/vcol_keys.inc	2008-09-19 11:49:17 +0000
@@ -0,0 +1,146 @@
+################################################################################
+# inc/vcol_keys.inc                                                            #
+#                                                                              #
+# Purpose:                                                                     #
+#  Testing keys, indexes defined upon virtual columns.                         #
+#                                                                              #
+#                                                                              #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-02                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+
+--echo #            - UNIQUE KEY
+--echo #            - INDEX
+--echo #            - FOREIGN INDEX (partially supported)
+--echo #            - CHECK (allowed but not used)
+
+--echo # UNIQUE
+--error ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN
+create table t1 (a int, b virtual int as (a*2) unique);
+create table t1 (a int, b virtual int as (a*2) stored unique);
+show create table t1;
+describe t1;
+drop table t1;
+
+--error ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN
+create table t1 (a int, b virtual int as (a*2), unique key (b));
+create table t1 (a int, b virtual int as (a*2) stored, unique (b));
+show create table t1;
+describe t1;
+drop table t1;
+
+create table t1 (a int, b virtual int as (a*2));
+--error ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN
+alter table t1 add unique key (b);
+drop table t1;
+create table t1 (a int, b virtual int as (a*2) stored);
+alter table t1 add unique key (b);
+drop table t1;
+
+--echo # Testing data manipulation operations involving UNIQUE keys 
+--echo # on virtual columns can be found in:
+--echo #  - vcol_ins_upd.inc
+--echo #  - vcol_select.inc
+
+--echo # 
+--echo # INDEX
+--error ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN
+create table t1 (a int, b virtual int as (a*2), index (b));
+--error ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN
+create table t1 (a int, b virtual int as (a*2), index (a,b));
+
+create table t1 (a int, b virtual int as (a*2) stored, index (b));
+show create table t1;
+describe t1;
+drop table t1;
+
+create table t1 (a int, b virtual int as (a*2) stored, index (a,b));
+show create table t1;
+describe t1;
+drop table t1;
+
+create table t1 (a int, b virtual int as (a*2));
+--error ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN
+alter table t1 add index (b);
+--error ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN
+alter table t1 add index (a,b);
+drop table t1;
+
+create table t1 (a int, b virtual int as (a*2) stored);
+alter table t1 add index (b);
+drop table t1;
+
+create table t1 (a int, b virtual int as (a*2) stored);
+alter table t1 add index (a,b);
+create table t2 like t1;
+drop table t2;
+drop table t1;
+
+--echo # Testing data manipulation operations involving INDEX
+--echo # on virtual columns can be found in:
+--echo #  - vcol_select.inc
+
+--echo # FOREIGN KEY
+
+--echo # Rejected FK options.
+--error ER_WRONG_FK_OPTION_FOR_VIRTUAL_COLUMN 
+create table t1 (a int, b virtual int as (a+1) stored,
+                 foreign key (b) references t2(a) on update set null);
+--error ER_WRONG_FK_OPTION_FOR_VIRTUAL_COLUMN 
+create table t1 (a int, b virtual int as (a+1) stored,
+                 foreign key (b) references t2(a) on update cascade);
+--error ER_WRONG_FK_OPTION_FOR_VIRTUAL_COLUMN 
+create table t1 (a int, b virtual int as (a+1) stored,
+                 foreign key (b) references t2(a) on delete set null);
+
+create table t1 (a int, b virtual int as (a+1) stored);
+--error ER_WRONG_FK_OPTION_FOR_VIRTUAL_COLUMN 
+alter table t1 add foreign key (b) references t2(a) on update set null;
+--error ER_WRONG_FK_OPTION_FOR_VIRTUAL_COLUMN 
+alter table t1 add foreign key (b) references t2(a) on update cascade;
+--error ER_WRONG_FK_OPTION_FOR_VIRTUAL_COLUMN 
+alter table t1 add foreign key (b) references t2(a) on delete set null;
+drop table t1;
+
+--error ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN
+create table t1 (a int, b virtual int as (a+1),
+                 foreign key (b) references t2(a));
+
+create table t1 (a int, b virtual int as (a+1));
+--error ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN
+alter table t1 add foreign key (b) references t2(a);
+drop table t1;
+
+--echo # Allowed FK options.
+create table t2 (a int primary key, b char(5));
+create table t1 (a int, b virtual int as (a % 10) stored,
+                 foreign key (b) references t2(a) on update restrict);
+drop table t1;
+create table t1 (a int, b virtual int as (a % 10) stored,
+                 foreign key (b) references t2(a) on update no action);
+drop table t1;
+create table t1 (a int, b virtual int as (a % 10) stored,
+                 foreign key (b) references t2(a) on delete restrict);
+drop table t1;
+create table t1 (a int, b virtual int as (a % 10) stored,
+                 foreign key (b) references t2(a) on delete cascade);
+drop table t1;
+create table t1 (a int, b virtual int as (a % 10) stored,
+                 foreign key (b) references t2(a) on delete no action);
+drop table t1;
+
+--echo 
+--echo # Testing data manipulation operations involving FOREIGN KEY 
+--echo # on virtual columns can be found in:
+--echo #  - vcol_ins_upd.inc
+--echo #  - vcol_select.inc
+
+--echo #
+--echo # TODO: CHECK
+

=== added file 'tests/suite/vcol/inc/vcol_non_stored_columns.inc'
--- tests/suite/vcol/inc/vcol_non_stored_columns.inc	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/inc/vcol_non_stored_columns.inc	2008-09-19 11:49:17 +0000
@@ -0,0 +1,162 @@
+################################################################################
+# inc/vcol_non_stored_columns.inc                                              #
+#                                                                              #
+# Purpose:                                                                     #
+#  Ensure that MySQL behaviour is consistent irrelevant of                     #
+#    - the place of a non-stored column among other columns,                   #
+#    - the total number of non-stored fields.                                  #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-04                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+--echo # Case 1. All non-stored columns.
+--echo # This scenario is currently impossible due to the fact that virtual columns
+--echo # with a constant expression are not allowed.
+
+--echo # Case 2. CREATE
+--echo #  - Column1: "real"
+--echo #  - Column 2: virtual non-stored
+create table t1 (a int, b virtual int as (-a));
+insert into t1 values (1,default);
+select * from t1;
+insert into t1 values (2,default);
+select * from t1;
+drop table t1;
+
+--echo # Case 3. CREATE
+--echo #  - Column1: "real"
+--echo #  - Column 2: virtual stored
+create table t1 (a int, b virtual int as (-a) stored);
+insert into t1 values (1,default);
+select * from t1;
+insert into t1 values (2,default);
+select * from t1;
+drop table t1;
+
+--echo # Case 4. CREATE
+--echo #  - Column1: virtual non-stored
+--echo #  - Column2: "real"
+create table t1 (a virtual int as (-b), b int);
+insert into t1 values (default,1);
+select * from t1;
+insert into t1 values (default,2);
+select * from t1;
+drop table t1;
+
+--echo # Case 5. CREATE
+--echo #  - Column1: virtual stored
+--echo #  - Column2: "real"
+create table t1 (a virtual int as (-b) stored, b int);
+insert into t1 values (default,1);
+select * from t1;
+insert into t1 values (default,2);
+select * from t1;
+drop table t1;
+
+--echo # Case 6. CREATE
+--echo #  - Column1: "real"
+--echo #  - Column2: virtual non-stored
+--echo #  - Column3: virtual stored
+create table t1 (a int, b virtual int as (-a), c virtual int as (-a) stored);
+insert into t1 values (1,default,default);
+select * from t1;
+insert into t1 values (2,default,default);
+select * from t1;
+drop table t1;
+
+--echo # Case 7. ALTER. Modify virtual stored -> virtual non-stored
+create table t1 (a int, b virtual int as (a % 2) stored);
+--error ER_UNSUPPORTED_ACTION_ON_VIRTUAL_COLUMN
+alter table t1 modify b virtual int as (a % 2);
+show create table t1;
+drop table t1;
+
+--echo # Case 8. ALTER. Modify virtual non-stored -> virtual stored
+create table t1 (a int, b virtual int as (a % 2));
+--error ER_UNSUPPORTED_ACTION_ON_VIRTUAL_COLUMN
+alter table t1 modify b virtual int as (a % 2) stored;
+show create table t1;
+drop table t1;
+
+--echo # Case 9. CREATE LIKE
+--echo #  - Column1: "real"
+--echo #  - Column2: virtual non-stored
+--echo #  - Column3: virtual stored
+create table t1 (a int, b virtual int as (-a), c virtual int as (-a) stored);
+create table t2 like t1;
+insert into t2 values (1,default,default);
+select * from t2;
+insert into t2 values (2,default,default);
+select * from t2;
+drop table t2;
+drop table t1;
+
+--echo # Case 10. ALTER. Dropping a virtual non-stored column.
+--echo #  - Column1: virtual non-stored
+--echo #  - Column2: "real"
+create table t1 (a virtual int as (-b), b int, c varchar(5));
+insert into t1 values (default,1,'v1');
+insert into t1 values (default,2,'v2');
+select * from t1;
+alter table t1 drop column a;
+select * from t1;
+show create table t1;
+drop table t1;
+
+--echo # Case 11. ALTER. Dropping a virtual stored column.
+--echo #  - Column1: virtual stored
+--echo #  - Column2: "real"
+create table t1 (a virtual int as (-b) stored, b int, c char(5));
+insert into t1 values (default,1,'v1');
+insert into t1 values (default,2,'v2');
+select * from t1;
+alter table t1 drop column a;
+select * from t1;
+show create table t1;
+drop table t1;
+
+--echo # Case 12. ALTER. Adding a new virtual non-stored column.
+create table t1 (a int, b datetime);
+insert into t1 values (1,'2008-09-04');
+insert into t1 values (2,'2008-09-05');
+select * from t1;
+alter table t1 add column c virtual int as (dayofyear(b)) after a;
+select * from t1;
+show create table t1;
+drop table t1;
+
+--echo # Case 13. ALTER. Adding a new virtual stored column.
+create table t1 (a int, b datetime);
+insert into t1 values (1,'2008-09-04');
+insert into t1 values (2,'2008-09-05');
+select * from t1;
+alter table t1 add column c virtual int as (dayofyear(b)) stored after a;
+select * from t1;
+show create table t1;
+drop table t1;
+
+--echo # Case 14. ALTER. Changing the expression of a virtual stored column.
+create table t1 (a int, b datetime, c virtual int as (week(b)) stored);
+insert into t1 values (1,'2008-09-04',default);
+insert into t1 values (2,'2008-09-05',default);
+select * from t1;
+alter table t1 change column c c virtual int as (week(b,1)) stored;
+select * from t1;
+show create table t1;
+drop table t1;
+
+--echo # Case 15. ALTER. Changing the expression of a virtual non-stored column.
+create table t1 (a int, b datetime, c virtual int as (week(b)));
+insert into t1 values (1,'2008-09-04',default);
+insert into t1 values (2,'2008-09-05',default);
+select * from t1;
+alter table t1 change column c c virtual int as (week(b,1));
+select * from t1;
+show create table t1;
+drop table t1;
+

=== added file 'tests/suite/vcol/inc/vcol_select.inc'
--- tests/suite/vcol/inc/vcol_select.inc	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/inc/vcol_select.inc	2008-09-19 11:49:17 +0000
@@ -0,0 +1,216 @@
+################################################################################
+# inc/vcol_select.inc                                                          #
+#                                                                              #
+# Purpose:                                                                     #
+#  Testing different SELECTs.                                                  #
+#                                                                              #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-18                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+# Table t1 is used below to test:
+#  - Join type of ALL (sequential scan of the entire table)
+#  - Join type of Index
+#  - Join type of Range
+#  - Join type of Ref_or_null
+create table t1 (a int,
+                 b virtual int as (-a),
+                 c virtual int as (-a) stored,
+                 index (c));
+insert into t1 (a) values (2), (1), (1), (3), (NULL);
+
+# Table t2 is used below to test:
+#  - Join type of system and const
+create table t2 like t1;
+insert into t2 (a) values (1);
+
+# Table t3 is used below to test
+#  - Join type of Eq_ref with a unique virtual column
+#  - Join type of Const
+create table t3 (a int primary key, 
+                 b virtual int as (-a),
+		 c virtual int as (-a) stored unique);
+insert into t3 (a) values (2),(1),(3);
+
+
+--echo # select_type=SIMPLE, type=system
+let $s = select * from t2;
+eval $s;
+eval explain $s;
+
+let $s = select * from t2 where c=-1;
+eval $s;
+eval explain $s;
+
+--echo # select_type=SIMPLE, type=ALL
+let $s = select * from t1 where b=-1;
+eval $s;
+eval explain $s;
+
+--echo # select_type=SIMPLE, type=const
+let $s = select * from t3 where a=1;
+eval $s;
+eval explain $s;
+
+--echo # select_type=SIMPLE, type=range
+let $s = select * from t3 where c>=-1;
+eval $s;
+eval explain $s;
+
+--echo # select_type=SIMPLE, type=ref
+let $s = select * from t1,t3 where t1.c=t3.c and t3.c=-1;
+eval $s;
+eval explain $s;
+
+--echo # select_type=PRIMARY, type=index,ALL
+let $s = select * from t1 where b in (select c from t3);
+eval $s;
+eval explain $s;
+
+--echo # select_type=PRIMARY, type=range,ref
+let $s = select * from t1 where c in (select c from t3 where c between -2 and -1);
+eval $s;
+eval explain $s;
+
+--echo # select_type=UNION, type=system
+--echo # select_type=UNION RESULT, type=<union1,2>
+let $s = select * from t1 union select * from t2;
+eval $s;
+eval explain $s;
+
+--echo # select_type=DERIVED, type=system
+let $s = select * from (select a,b,c from t1) as t11;
+eval $s;
+eval explain $s;
+
+--echo ###
+--echo ### Using aggregate functions with/without DISTINCT
+--echo ###
+--echo # SELECT COUNT(*) FROM tbl_name
+let $s = select count(*) from t1;
+eval $s;
+eval explain $s;
+
+--echo # SELECT COUNT(DISTINCT <non-vcol>) FROM tbl_name
+let $s = select count(distinct a) from t1;
+eval $s;
+eval explain $s;
+
+--echo # SELECT COUNT(DISTINCT <non-stored vcol>) FROM tbl_name
+let $s = select count(distinct b) from t1;
+eval $s;
+eval explain $s;
+
+--echo # SELECT COUNT(DISTINCT <stored vcol>) FROM tbl_name
+let $s = select count(distinct c) from t1;
+eval $s;
+eval explain $s;
+
+--echo ###
+--echo ### filesort & range-based utils
+--echo ###
+--echo # SELECT * FROM tbl_name WHERE <vcol expr>
+let $s = select * from t3 where c >= -2;
+eval $s;
+eval explain $s;
+
+--echo # SELECT * FROM tbl_name WHERE <non-vcol expr>
+let $s = select * from t3 where a between 1 and 2;
+eval $s;
+eval explain $s;
+
+--echo # SELECT * FROM tbl_name WHERE <non-indexed vcol expr>
+let $s = select * from t3 where b between -2 and -1;
+eval $s;
+eval explain $s;
+
+--echo # SELECT * FROM tbl_name WHERE <indexed vcol expr>
+let $s = select * from t3 where c between -2 and -1;
+eval $s;
+eval explain $s;
+
+#### Remove for MyISAM due to a bug
+#### when all the three records are returned (a=1,2,3) 
+#### instead of just two (a=1,2).
+#### This bug is presumably in base SQL routines as the same happens
+#### with this table:
+####   create table t4 (a int primary key, b int, c int unique);
+let $myisam_engine = `SELECT @@session.storage_engine='myisam'`;
+if (!$myisam_engine)
+{
+  --echo # SELECT * FROM tbl_name WHERE <non-vcol expr> ORDER BY <non-indexed vcol>
+  let $s = select * from t3 where a between 1 and 2 order by b;
+  eval $s;
+  eval explain $s;
+}
+
+--echo # SELECT * FROM tbl_name WHERE <non-vcol expr> ORDER BY <indexed vcol>
+let $s = select * from t3 where a between 1 and 2 order by c;
+eval $s;
+eval explain $s;
+
+--echo # SELECT * FROM tbl_name WHERE <non-indexed vcol expr> ORDER BY <non-vcol>
+let $s = select * from t3 where b between -2 and -1 order by a;
+eval $s;
+eval explain $s;
+
+#### Remove for MyISAM due to a bug
+#### when all the three records are returned (a=1,2,3) 
+#### instead of just two (a=1,2).
+#### This bug is presumably in base SQL routines as the same happens
+#### with this table:
+####   create table t4 (a int primary key, b int, c int unique);
+let $innodb_engine = `SELECT @@session.storage_engine='innodb'`;
+if (!$innodb_engine)
+{
+  --echo # SELECT * FROM tbl_name WHERE <indexed vcol expr> ORDER BY <non-vcol>
+  let $s = select * from t3 where c between -2 and -1 order by a;
+  eval $s;
+  eval explain $s;
+}
+
+--echo # SELECT * FROM tbl_name WHERE <non-indexed vcol expr> ORDER BY <non-indexed vcol>
+let $s = select * from t3 where b between -2 and -1 order by b;
+eval $s;
+eval explain $s;
+
+--echo # SELECT * FROM tbl_name WHERE <indexed vcol expr> ORDER BY <non-indexed vcol>
+let $s = select * from t3 where c between -2 and -1 order by b;
+eval $s;
+eval explain $s;
+
+--echo # SELECT * FROM tbl_name WHERE <non-indexed vcol expr> ORDER BY <indexed vcol>
+let $s = select * from t3 where b between -2 and -1 order by c;
+eval $s;
+eval explain $s;
+
+--echo # SELECT * FROM tbl_name WHERE <indexed vcol expr> ORDER BY <indexed vcol>
+let $s = select * from t3 where c between -2 and -1 order by c;
+eval $s;
+eval explain $s;
+
+--echo # SELECT sum(<non-indexed vcol>) FROM tbl_name GROUP BY <non-indexed vcol>
+let $s = select sum(b) from t1 group by b;
+eval $s;
+eval explain $s;
+
+--echo # SELECT sum(<indexed vcol>) FROM tbl_name GROUP BY <indexed vcol>
+let $s = select sum(c) from t1 group by c;
+eval $s;
+eval explain $s;
+
+--echo # SELECT sum(<non-indexed vcol>) FROM tbl_name GROUP BY <indexed vcol>
+let $s = select sum(b) from t1 group by c;
+eval $s;
+eval explain $s;
+
+--echo # SELECT sum(<indexed vcol>) FROM tbl_name GROUP BY <non-indexed vcol>
+let $s = select sum(c) from t1 group by b;
+eval $s;
+eval explain $s;
+

=== added file 'tests/suite/vcol/inc/vcol_supported_sql_funcs.inc'
--- tests/suite/vcol/inc/vcol_supported_sql_funcs.inc	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/inc/vcol_supported_sql_funcs.inc	2008-09-19 11:49:17 +0000
@@ -0,0 +1,42 @@
+################################################################################
+# inc/vcol_supported_sql_funcs.inc                                             #
+#                                                                              #
+# Purpose:                                                                     #
+#  Tests frame for allowed sql functions                                       #
+#                                                                              #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-08-31                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+--enable_warnings
+set sql_warnings = 1;
+eval create table t1 ($cols);
+show create table t1;
+if ($rows)
+{
+  eval insert into t1 values ($values1);
+  dec $rows;
+}
+if ($rows)
+{
+  eval insert into t1 values ($values2);
+  dec $rows;
+}
+if ($rows)
+{
+  eval insert into t1 values ($values3);
+  dec $rows;
+}
+if ($rows)
+{
+  eval insert into t1 values ($values4);
+  dec $rows;
+}
+select * from t1;
+drop table t1;
+set sql_warnings = 0;

=== added file 'tests/suite/vcol/inc/vcol_supported_sql_funcs_main.inc'
--- tests/suite/vcol/inc/vcol_supported_sql_funcs_main.inc	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/inc/vcol_supported_sql_funcs_main.inc	2008-09-19 11:49:17 +0000
@@ -0,0 +1,1057 @@
+################################################################################
+# inc/vcol_supported_sql_funcs_main.inc                                        #
+#                                                                              #
+# Purpose:                                                                     #
+#  Tests frame for allowed sql functions                                       #
+#                                                                              #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-08-31                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+--echo #
+--echo # NUMERIC FUNCTIONS
+--echo #
+
+--echo # ABS()
+let $cols = a int, b virtual int as (abs(a));
+let $values1 = -1, default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # ACOS()
+let $cols = a double, b virtual double as (acos(a));
+let $values1 = 1, default;
+let $values2 = 1.0001,default;
+let $values3 = 0,default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # ASIN()
+let $cols = a double, b virtual double as (asin(a));
+let $values1 = 0.2, default;
+let $values2 = 1.0001,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo #ATAN
+let $cols = a double, b double, c virtual double as (atan(a,b));
+let $values1 = -2,2,default;
+let $values2 = PI(),0,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+let $cols = a double, c virtual double as (atan(a));
+let $values1 = -2,default;
+let $values2 = PI(),default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # ATAN2
+let $cols = a double, b double, c virtual double as (atan2(a,b));
+let $values1 = -2,2,default;
+let $values2 = PI(),0,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # CEIL()
+let $cols = a double, b virtual int as (ceil(a));
+let $values1 = 1.23,default;
+let $values2 = -1.23,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # CONV()
+let $cols = a varchar(10), b int, c int, d virtual varchar(10) as (conv(a,b,c));
+let $values1 = 'a',16,2,default;
+let $values2 = '6e',18,8,default;
+let $values3 = -17,10,-18,default;
+let $values4 = 10+'10'+'10'+0xa,10,10,default;
+let $rows = 4;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # COS()
+let $cols = a double, b virtual double as (cos(a));
+let $values1 = PI(),default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # COT()
+let $cols = a double, b virtual double as (cot(a));
+let $values1 = 12,default;
+let $values2 = 0,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # DEGREES()
+let $cols = a double, b virtual double as (degrees(a));
+let $values1 = PI(),default;
+let $values2 = PI()/2,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # /
+let $cols = a double, b virtual double as (a/2);
+let $values1 = 2,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # EXP()
+let $cols = a double, b virtual double as (exp(a));
+let $values1 = 2,default;
+let $values2 = -2,default;
+let $values3 = 0,default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # FLOOR()
+let $cols = a double, b virtual int as (floor(a));
+let $values1 = 1.23,default;
+let $values2 = -1.23,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # LN()
+let $cols = a double, b virtual double as (ln(a));
+let $values1 = 2,default;
+let $values2 = -2,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # LOG()
+let $cols = a double, b double, c virtual double as (log(a,b));
+let $values1 = 2,65536,default;
+let $values2 = 10,100,default;
+let $values3 = 1,100,default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+let $cols = a double, b virtual double as (log(a));
+let $values1 = 2,default;
+let $values2 = -2,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # LOG2()
+let $cols = a double, b virtual double as (log2(a));
+let $values1 = 65536,default;
+let $values2 = -100,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # LOG10()
+let $cols = a double, b virtual double as (log10(a));
+let $values1 = 2,default;
+let $values2 = 100,default;
+let $values3 = -100,default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # -
+let $cols = a double, b virtual double as (a-1);
+let $values1 = 2,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # MOD()
+let $cols = a double, b virtual int as (mod(a,10));
+let $values1 = 1,default;
+let $values2 = 11,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # %
+let $cols = a double, b virtual int as (a % 10);
+let $values1 = 1,default;
+let $values2 = 11,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # OCT()
+let $cols = a double, b virtual varchar(10) as (oct(a));
+let $values1 = 12,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # PI()
+let $cols = a double, b virtual double as (PI()*a*a);
+let $values1 = 1,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # +
+let $cols = a int, b virtual int as (a+1);
+let $values1 = 1,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # POW, POWER
+let $cols = a int, b virtual int as (pow(a,2)), c virtual int as (power(a,2));
+let $values1 = 1,default,default;
+let $values2 = 2,default,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # RADIANS()
+let $cols = a double, b virtual double as (radians(a));
+let $values1 = 90,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # ROUND()
+let $cols = a double, b virtual int as (round(a));
+let $values1 = -1.23,default;
+let $values2 = -1.58,default;
+let $values3 = 1.58,default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+let $cols = a double, b double, c virtual int as (round(a,b));
+let $values1 = 1.298,1,default;
+let $values2 = 1.298,0,default;
+let $values3 = 23.298,-1,default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # SIGN()
+let $cols = a double, b virtual int as (sign(a));
+let $values1 = -32,default;
+let $values2 = 0,default;
+let $values3 = 234,default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # SIN()
+let $cols = a double, b virtual double as (sin(a));
+let $values1 = PI(),default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # SQRT()
+let $cols = a double, b virtual double as (sqrt(a));
+let $values1 = 4,default;
+let $values2 = 20,default;
+let $values3 = -16,default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # TAN()
+let $cols = a double, b virtual double as (tan(a));
+let $values1 = PI(),default;
+let $values2 = PI()+1,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # *
+let $cols = a double, b virtual double as (a*3);
+let $values1 = 0,default;
+let $values2 = 1,default;
+let $values3 = 2,default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # TRUNCATE()
+let $cols = a double, b virtual double as (truncate(a,4));
+let $values1 = 1.223,default;
+let $values2 = 1.999,default;
+let $values3 = 1.999,default;
+let $values4 = 122,default;
+let $rows = 4;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # Unary -
+let $cols = a double, b virtual double as (-a);
+let $values1 = 1,default;
+let $values2 = -1,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo #
+--echo # STRING FUNCTIONS
+--echo #
+
+--echo # ASCII()
+let $cols = a char(2), b virtual int as (ascii(a));
+let $values1 = '2',default;
+let $values2 = 2,default;
+let $values3 = 'dx',default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # BIN()
+let $cols = a int, b virtual varchar(10) as (bin(a));
+let $values1 = 12,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # BIT_LENGTH()
+let $cols = a varchar(10), b virtual int as (bit_length(a));
+let $values1 = 'text',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # CHAR_LENGTH()
+let $cols = a varchar(10), b virtual int as (char_length(a));
+let $values1 = 'text',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # CHAR()
+let $cols = a int, b int, c virtual varbinary(10) as (char(a,b));
+let $values1 = 77,121,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # CHARACTER_LENGTH()
+let $cols = a varchar(10), b virtual int as (character_length(a));
+let $values1 = 'text',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # CONCAT_WS()
+let $cols = a varchar(10), b varchar(10), c virtual varchar(20) as (concat_ws(',',a,b));
+let $values1 = 'value1','value2',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # CONCAT()
+let $cols = a varchar(10), b varchar(10), c virtual varchar(20) as (concat(a,',',b));
+let $values1 = 'value1','value2',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # ELT()
+let $cols = a varchar(10), b varchar(10), c int, d virtual varchar(10) as (elt(c,a,b));
+let $values1 = 'value1','value2',1,default;
+let $values2 = 'value1','value2',2,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # EXPORT_SET()
+let $cols = a int, b virtual varchar(10) as (export_set(a,'1','0','',10));
+let $values1 = 6,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # FIELD()
+let $cols = a varchar(10), b varchar(10), c virtual int as (field('aa',a,b));
+let $values1 = 'aa','bb',default;
+let $values2 = 'bb','aa',default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # FIND_IN_SET()
+let $cols = a varchar(10), b varchar(10), c virtual int as (find_in_set(a,b));
+let $values1 = 'aa','aa,bb,cc',default;
+let $values2 = 'aa','bb,aa,cc',default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # FORMAT()
+let $cols = a double, b virtual varchar(20) as (format(a,2));
+let $values1 = 12332.123456,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # HEX()
+let $cols = a double, b virtual varchar(10) as (hex(a));
+let $values1 = 17,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+let $cols = a varchar(10), b virtual varchar(10) as (hex(a));
+let $values1 = 'abc',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # INSERT()
+let $cols = a varchar(10), b varchar(10), c virtual varchar(20) as (insert(a,length(a),length(b),b));
+let $values1 = 'start,','end',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # INSTR()
+let $cols = a varchar(10), b varchar(10), c virtual int as (instr(a,b));
+let $values1 = 'foobarbar,','bar',default;
+let $values2 = 'xbar,','foobar',default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # LCASE()
+let $cols = a varchar(10), b virtual varchar(10) as (lcase(a));
+let $values1 = 'MySQL',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # LEFT()
+let $cols = a varchar(10), b virtual varchar(5) as (left(a,5));
+let $values1 = 'foobarbar',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # LENGTH()
+let $cols = a varchar(10), b virtual int as (length(a));
+let $values1 = 'text',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # LIKE
+let $cols = a varchar(10), b virtual bool as (a like 'H%o');
+let $values1 = 'Hello',default;
+let $values2 = 'MySQL',default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # LOCATE()
+let $cols = a varchar(10), b virtual varchar(10) as (locate('bar',a));
+let $values1 = 'foobarbar',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # LOWER()
+let $cols = a varchar(10), b virtual varchar(10) as (lower(a));
+let $values1 = 'MySQL',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # LPAD()
+let $cols = a varchar(10), b virtual varchar(10) as (lpad(a,4,' '));
+let $values1 = 'MySQL',default;
+let $values2 = 'M',default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # LTRIM()
+let $cols = a varchar(10), b virtual varchar(10) as (ltrim(a));
+let $values1 = '  MySQL',default;
+let $values2 = 'MySQL',default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # MAKE_SET()
+let $cols = a varchar(10), b varchar(10), c int, d virtual varchar(30) as (make_set(c,a,b));
+let $values1 = 'a','b',1,default;
+let $values2 = 'a','b',3,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # MID()
+let $cols = a varchar(10), b virtual varchar(10) as (mid(a,1,2));
+let $values1 = 'foobarbar',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # NOT LIKE
+let $cols = a varchar(10), b virtual bool as (a not like 'H%o');
+let $values1 = 'Hello',default;
+let $values2 = 'MySQL',default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # OCTET_LENGTH()
+let $cols = a varchar(10), b virtual int as (octet_length(a));
+let $values1 = 'text',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # ORD()
+let $cols = a varchar(10), b virtual int as (ord(a));
+let $values1 = '2',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # POSITION()
+let $cols = a varchar(10), b virtual varchar(10) as (position('bar' in a));
+let $values1 = 'foobarbar',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # QUOTE()
+let $cols = a varchar(10), b virtual varchar(10) as (quote(a));
+let $values1 = 'Don\'t',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # REPEAT()
+let $cols = a varchar(10), b virtual varchar(30) as (repeat(a,3));
+let $values1 = 'MySQL',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # REPLACE()
+let $cols = a varchar(10), b virtual varchar(30) as (replace(a,'aa','bb'));
+let $values1 = 'maa',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # REVERSE()
+let $cols = a varchar(10), b virtual varchar(30) as (reverse(a));
+let $values1 = 'maa',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # RIGHT()
+let $cols = a varchar(10), b virtual varchar(10) as (right(a,4));
+let $values1 = 'foobarbar',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # RPAD()
+let $cols = a varchar(10), b virtual varchar(10) as (rpad(a,4,'??'));
+let $values1 = 'He',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # RTRIM();
+let $cols = a varchar(10), b virtual varchar(10) as (rtrim(a));
+let $values1 = 'Hello  ',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # SPACE()
+let $cols = a varchar(5), b virtual varchar(10) as (concat(a,space(5)));
+let $values1 = 'Hello', default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # STRCMP()
+let $cols = a varchar(9), b varchar(9), c virtual tinyint as (strcmp(a,b));
+let $values1 = 'Hello','Hello', default;
+let $values2 = 'Hello','Hello1', default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # SUBSTR()
+let $cols = a varchar(5), b virtual varchar(10) as (substr(a,2));
+let $values1 = 'Hello',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # SUBSTRING_INDEX()
+let $cols = a varchar(15), b virtual varchar(10) as (substring_index(a,'.',2));
+let $values1 = 'www.mysql.com',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # SUBSTRING()
+let $cols = a varchar(5), b virtual varchar(10) as (substring(a from 2 for 2));
+let $values1 = 'Hello',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # TRIM()
+let $cols = a varchar(15), b virtual varchar(10) as (trim(a));
+let $values1 = ' aa ',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # UCASE()
+let $cols = a varchar(5), b virtual varchar(10) as (ucase(a));
+let $values1 = 'MySQL',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # UNHEX()
+let $cols = a varchar(15), b virtual varchar(10) as (unhex(a));
+let $values1 = '4D7953514C',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # UPPER()
+let $cols = a varchar(5), b virtual varchar(10) as (upper(a));
+let $values1 = 'MySQL',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo #
+--echo # CONTROL FLOW FUNCTIONS
+--echo #
+
+--echo # CASE
+let $cols = a varchar(10), b virtual varchar(16) as (case a when NULL then 'asd' when 'b' then 'B' else a end);
+let $values1 = NULL,default;
+let $values2 = 'b',default;
+let $values3 = 'c',default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # IF
+let $cols = a int, b int, c virtual int as (if(a=1,a,b));
+let $values1 = 1,2,default;
+let $values2 = 3,4,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # IFNULL
+let $cols = a varchar(10), b varchar(10), c virtual varchar(10) as (ifnull(a,'DEFAULT'));
+let $values1 = NULL,'adf',default;
+let $values2 = 'a','adf',default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # NULLIF
+let $cols = a varchar(10), b virtual varchar(10) as (nullif(a,'DEFAULT'));
+let $values1 = 'DEFAULT',default;
+let $values2 = 'a',default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo #
+--echo # OPERATORS
+--echo #
+
+--echo # AND
+let $cols = a int, b virtual bool as (a>0 and a<2);
+let $values1 = -1,default;
+let $values2 = 1,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # BETWEEN ... AND ... 
+let $cols = a int, b virtual bool as (a between 0 and 2);
+let $values1 = -1,default;
+let $values2 = 1,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # BINARY
+let $cols = a varchar(10), b virtual varbinary(10) as (binary a);
+let $values1 = '11',default;
+let $values2 = 1,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # DIV
+let $cols = a int, b virtual int as (a div 5);
+let $values1 = 1,default;
+let $values2 = 7,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # <=>
+let $cols = a int, b int, c virtual bool as (a <=> b);
+let $values1 = 1,1,default;
+let $values2 = NULL,NULL,default;
+let $values3 = 1,NULL,default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # =
+let $cols = a varchar(10), b varchar(10), c virtual bool as (a=b);
+let $values1 = 'a','b',default;
+let $values2 = 'a','a',default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # >=
+let $cols = a varchar(10), b varchar(10), c virtual bool as (a >= b);
+let $values1 = 'a','b',default;
+let $values2 = 'a','a',default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # >
+let $cols = a varchar(10), b varchar(10), c virtual bool as (a > b);
+let $values1 = 'a','b',default;
+let $values2 = 'a','a',default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # IS NOT NULL
+let $cols = a int, b virtual bool as (a is not null);
+let $values1 = 1,default;
+let $values2 = NULL,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # IS NULL
+let $cols = a int, b virtual bool as (a is null);
+let $values1 = 1,default;
+let $values2 = NULL,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # <=
+let $cols = a varchar(10), b varchar(10), c virtual bool as (a <= b);
+let $values1 = 'b','a',default;
+let $values2 = 'b','b',default;
+let $values3 = 'b','c',default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # <
+let $cols = a varchar(10), b varchar(10), c virtual bool as (a < b);
+let $values1 = 'b','a',default;
+let $values2 = 'b','b',default;
+let $values3 = 'b','c',default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # NOT BETWEEN ... AND ...
+let $cols = a int, b virtual bool as (a not between 0 and 2);
+let $values1 = -1,default;
+let $values2 = 1,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # <>
+let $cols = a varchar(10), b varchar(10), c virtual bool as (a <> b);
+let $values1 = 'b','a',default;
+let $values2 = 'b','b',default;
+let $values3 = 'b','c',default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # !=
+let $cols = a varchar(10), b varchar(10), c virtual bool as (a != b);
+let $values1 = 'b','a',default;
+let $values2 = 'b','b',default;
+let $values3 = 'b','c',default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # OR
+let $cols = a int, b virtual int as (a>5 or a<3);
+let $values1 = 1,default;
+let $values2 = 4,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # XOR
+let $cols = a int, b virtual int as (a xor 5);
+let $values1 = 0,default;
+let $values2 = 1,default;
+let $values3 = 2,default;
+let $rows = 3;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo #
+--echo # DATE AND TIME FUNCTIONS
+--echo #
+
+--echo # ADDDATE()
+let $cols = a datetime, b virtual datetime as (adddate(a,interval 1 month));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # ADDTIME()
+let $cols = a datetime, b virtual datetime as (addtime(a,'02:00:00'));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # DATE_ADD()
+let $cols = a datetime, b virtual datetime as (date_add(a,interval 1 month));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # DATE_FORMAT()
+let $cols = a datetime, b virtual varchar(64) as (date_format(a,'%W %M %D'));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # DATE_SUB()
+let $cols = a datetime, b virtual datetime as (date_sub(a,interval 1 month));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # DATE()
+let $cols = a datetime, b virtual datetime as (date(a));
+let $values1 = '2008-08-31 02:00:00',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # DATEDIFF()
+let $cols = a datetime, b virtual int as (datediff(a,'2000-01-01'));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # DAY()
+let $cols = a datetime, b virtual int as (day(a));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # DAYNAME()
+let $cols = a datetime, b virtual varchar(10) as (dayname(a));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # DAYOFMONTH()
+let $cols = a datetime, b virtual int as (dayofmonth(a));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # DAYOFWEEK()
+let $cols = a datetime, b virtual int as (dayofweek(a));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # DAYOFYEAR()
+let $cols = a datetime, b virtual int as (dayofyear(a));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # EXTRACT
+let $cols = a datetime, b virtual int as (extract(year from a));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # FROM_DAYS()
+let $cols = a int, b virtual datetime as (from_days(a));
+let $values1 = 730669,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # FROM_UNIXTIME()
+let $cols = a int, b virtual datetime as (from_unixtime(a));
+let $values1 = 1196440219,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # GET_FORMAT()
+let $cols = a datetime, b virtual varchar(32) as (date_format(a,get_format(DATE,'EUR')));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # HOUR()
+let $cols = a time, b virtual int as (hour(a));
+let $values1 = '10:05:03',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # LAST_DAY()
+let $cols = a datetime, b virtual datetime as (last_day(a));
+let $values1 = '2003-02-05',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # MAKEDATE()
+let $cols = a int, b virtual datetime as (makedate(a,1));
+let $values1 = 2001,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # MAKETIME()
+let $cols = a int, b virtual time as (maketime(a,1,3));
+let $values1 = 12,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # MICROSECOND()
+let $cols = a datetime, b virtual int as (microsecond(a));
+let $values1 = '2009-12-31 12:00:00.123456',default;
+let $values2 = '2009-12-31 23:59:59.000010',default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # MINUTE()
+let $cols = a datetime, b virtual int as (minute(a));
+let $values1 = '2009-12-31 23:59:59.000010',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # MONTH()
+let $cols = a datetime, b virtual int as (month(a));
+let $values1 = '2009-12-31 23:59:59.000010',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # MONTHNAME()
+let $cols = a datetime, b virtual varchar(16) as (monthname(a));
+let $values1 = '2009-12-31 23:59:59.000010',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # PERIOD_ADD()
+let $cols = a int, b virtual int as (period_add(a,2));
+let $values1 = 200801,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # PERIOD_DIFF()
+let $cols = a int, b int, c virtual int as (period_diff(a,b));
+let $values1 = 200802,200703,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # QUARTER()
+let $cols = a datetime, b virtual int as (quarter(a));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # SEC_TO_TIME()
+let $cols = a int, b virtual time as (sec_to_time(a));
+let $values1 = 2378,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # SECOND()
+let $cols = a datetime, b virtual int as (second(a));
+let $values1 = '10:05:03',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # STR_TO_DATE()
+let $cols = a varchar(64), b virtual datetime as (str_to_date(a,'%m/%d/%Y'));
+let $values1 = '04/30/2004',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # SUBDATE()
+let $cols = a datetime, b virtual datetime as (subdate(a,interval 1 month));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # SUBTIME()
+let $cols = a datetime, b virtual datetime as (subtime(a,'02:00:00'));
+let $values1 = '2008-08-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # TIME_FORMAT()
+let $cols = a datetime, b virtual varchar(32) as (time_format(a,'%r'));
+let $values1 = '2008-08-31 02:03:04',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # TIME_TO_SEC()
+let $cols = a time, b virtual int as (time_to_sec(a));
+let $values1 = '22:23:00',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # TIME()
+let $cols = a datetime, b virtual time as (time(a));
+let $values1 = '2008-08-31 02:03:04',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # TIMEDIFF()
+let $cols = a datetime, b datetime, c virtual int as (timediff(a,b));
+let $values1 = '2008-12-31 23:59:59.000001','2008-12-30 01:01:01.000002',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # TIMESTAMP()
+let $cols = a datetime, b virtual timestamp as (timestamp(a));
+let $values1 = '2008-12-31',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # TIMESTAMPADD()
+let $cols = a datetime, b virtual timestamp as (timestampadd(minute,1,a));
+let $values1 = '2003-01-02',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # TIMESTAMPDIFF()
+let $cols = a timestamp, b timestamp, c virtual int as (timestampdiff(MONTH, a,b));
+let $values1 = '2003-02-01','2003-05-01',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # TO_DAYS()
+let $cols = a datetime, b virtual int as (to_days(a));
+let $values1 = '2007-10-07',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # WEEK()
+let $cols = a datetime, b virtual int as (week(a));
+let $values1 = '2008-09-01',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # WEEKDAY()
+let $cols = a datetime, b virtual int as (weekday(a));
+let $values1 = '2008-09-01',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # WEEKOFYEAR()
+let $cols = a datetime, b virtual int as (weekofyear(a));
+let $values1 = '2008-09-01',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # YEAR()
+let $cols = a datetime, b virtual int as (year(a));
+let $values1 = '2008-09-01',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # YEARWEEK()
+let $cols = a datetime, b virtual int as (yearweek(a));
+let $values1 = '2008-09-01',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo #
+--echo # FULL TEXT SEARCH FUNCTIONS
+--echo #
+--echo # None.
+
+--echo #
+--echo # CAST FUNCTIONS AND OPERATORS
+--echo #
+
+--echo # CAST()
+let $cols = a int, b virtual int as (cast(a as unsigned));
+let $values1 = 1,default;
+let $values2 = -1,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # Convert()
+let $cols = a int, b virtual int as (convert(a,unsigned));
+let $values1 = 1,default;
+let $values2 = -1,default;
+let $rows = 2;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo #
+--echo # OTHER FUNCTIONS
+--echo #
+
+--echo # BIT_COUNT()
+let $cols = a int, b virtual int as (bit_count(a));
+let $values1 = 5,default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # COERCIBILITY()
+let $cols = a varchar(1024), b virtual int as (coercibility(a));
+let $values1 = 'abc',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # COLLATION()
+let $cols = a varchar(1024), b virtual varchar(1024) as (collation(a));
+let $values1 = 'abc',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+
+--echo # DEFAULT()
+let $cols = a varchar(1024) default 'aaa', b virtual varchar(1024) as (ifnull(a,default(a)));
+let $values1 = 'any value',default;
+let $rows = 1;
+--source suite/vcol/inc/vcol_supported_sql_funcs.inc
+

=== added file 'tests/suite/vcol/inc/vcol_unsupported_storage_engines.inc'
--- tests/suite/vcol/inc/vcol_unsupported_storage_engines.inc	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/inc/vcol_unsupported_storage_engines.inc	2008-09-19 11:49:17 +0000
@@ -0,0 +1,21 @@
+################################################################################
+# inc/vcol_unsupported_storage_engines.inc                                     #
+#                                                                              #
+# Purpose:                                                                     #
+#  Ensure that defining a virtual column for an unsupported table type         #
+#  results in a graceful error.                                                #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-02                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+--error ER_UNSUPPORTED_ACTION_ON_VIRTUAL_COLUMN
+create table t1 (a int, b virtual int as (a+1));
+create table t1 (a int);
+--error ER_UNSUPPORTED_ACTION_ON_VIRTUAL_COLUMN
+alter table t1 add column b virtual int as (a+1);
+drop table t1;

=== added file 'tests/suite/vcol/inc/vcol_view.inc'
--- tests/suite/vcol/inc/vcol_view.inc	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/inc/vcol_view.inc	2008-09-19 11:49:17 +0000
@@ -0,0 +1,201 @@
+################################################################################
+# inc/vcol_view.inc                                                            #
+#                                                                              #
+# Purpose:                                                                     #
+#  Testing views defined on tables with virtual columns.                       #
+#                                                                              #
+#                                                                              #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-04                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+
+
+create table t1 (a int not null,
+                 b virtual int as (-a), 
+		 c virtual int as (-a) stored);
+insert into t1 (a) values (1), (1), (2), (2), (3);
+
+# simple view
+create view v1 (d,e) as select abs(b), abs(c) from t1;
+select d,e from v1;
+select is_updatable from information_schema.views where table_name='v1';
+
+# view with different algorithms (explain output differs)
+explain extended select d,e from v1;
+create algorithm=temptable view v2 (d,e) as select abs(b), abs(c) from t1;
+show create view v2;
+select d,e from v2;
+explain extended select d,e from v2;
+
+# VIEW on VIEW test
+create view v3 (d,e) as select d*2, e*2 from v1;
+select * from v3;
+explain extended select * from v3;
+
+drop view v1,v2,v3;
+drop table t1;
+
+#
+# DISTINCT option for VIEW
+#
+create table t1 (a int not null,
+                 b virtual int as (-a), 
+		 c virtual int as (-a) stored);
+insert into t1 (a) values (1), (2), (3), (1), (2), (3);
+create view v1 as select distinct b from t1;
+select * from v1;
+explain select * from v1;
+select * from t1;
+drop view v1;
+create view v1 as select distinct c from t1;
+select * from v1;
+explain select * from v1;
+select * from t1;
+drop view v1;
+drop table t1;
+
+#
+# LIMIT clause test
+#
+create table t1 (a int not null,
+                 b virtual int as (-a), 
+		 c virtual int as (-a) stored);
+insert into t1 (a) values (1), (2), (3), (4);
+create view v1 as select b+1 from t1 order by 1 desc limit 2;
+select * from v1;
+explain select * from v1;
+drop view v1;
+create view v1 as select c+1 from t1 order by 1 desc limit 2;
+select * from v1;
+explain select * from v1;
+drop view v1;
+drop table t1;
+
+#
+# simple view + simple update, insert and delete
+#
+create table t1 (a int,
+                 b int,
+		 c virtual int as (-a),
+		 d virtual int as (-a) stored,
+                 primary key(a));
+insert into t1 (a,b) values (10,2), (20,3), (30,4), (40,5), (50,10);
+create view v1 (a,e,f,g) as select a, b+1,c+1,d+1 from t1;
+# updatable field of updateable view
+update v1 set a=a+e;
+select * from v1;
+select * from t1;
+delete from v1;
+select * from v1;
+select * from t1;
+--error 1471
+insert into v1 (a,e) values (60,15);
+drop table t1;
+drop view v1;
+
+#
+# outer join based on VIEW with WHERE clause
+#
+create table t1 (a int, 
+		 b virtual int as (-a),
+		 c virtual int as (-a) stored,
+                 primary key(a));
+insert into t1 (a) values (1), (2), (3);
+create view v1 (x,y,z) as select a,b,c from t1 where b < -1;
+select t1.a, v1.x, v1.y, v1.z from t1 left join v1 on (t1.b= v1.y);
+drop view v1;
+create view v1 (x,y,z) as select a,b,c from t1 where c < -1;
+select t1.a, v1.x, v1.y, v1.z from t1 left join v1 on (t1.c= v1.z);
+drop view v1;
+drop table t1;
+
+#
+# VIEW built over UNION
+#
+create table t1 (a1 int,
+                 b1 virtual int as (-a1),
+		 c1 virtual int as (-a1) stored);
+create table t2 (a2 int,
+                 b2 virtual int as (-a2),
+		 c2 virtual int as (-a2) stored);
+insert into t1 (a1) values (1), (2);
+insert into t2 (a2) values (2), (3);
+create view v1 as select * from t1,t2 union all select * from t1,t2;
+select * from v1;
+drop view v1;
+drop table t1, t2;
+
+#
+# Showing VIEW with VIEWs in subquery
+#
+create table t1 (a int,
+                 b virtual int as (-a),
+		 c virtual int as (-a) stored);
+create table t2 like t1;
+create view v1 as select a,b,c from t1;
+create view v2 as select a,b,c from t2 where b in (select b from v1);
+show create view v2;
+drop view v2, v1;
+drop table t1, t2;
+
+#
+# TODO: VIEW with full text
+#
+#CREATE TABLE t1 (c1 int not null auto_increment primary key, c2 varchar(20), fulltext(c2));
+#insert into t1 (c2) VALUES ('real Beer'),('Water'),('Kossu'),('Coca-Cola'),('Vodka'),('Wine'),('almost real Beer');
+#select * from t1 WHERE match (c2) against ('Beer');
+#CREATE VIEW v1 AS SELECT  * from t1 WHERE match (c2) against ('Beer');
+#select * from v1;
+#drop view v1;
+#drop table t1;
+
+#
+# distinct in temporary table with a VIEW
+#
+create table t1 (a int,
+                 b virtual int as (-a),
+		 c virtual int as (-a) stored);
+insert into t1 (a) values (1),(1),(2),(2),(3),(3);
+create view v1 as select b from t1;
+select distinct b from v1;
+select distinct b from v1 limit 2;
+select distinct b from t1 limit 2;
+prepare stmt1 from "select distinct b from v1 limit 2";
+execute stmt1;
+execute stmt1;
+deallocate prepare stmt1;
+drop view v1;
+create view v1 as select c from t1;
+select distinct c from v1;
+select distinct c from v1 limit 2;
+select distinct c from t1 limit 2;
+prepare stmt1 from "select distinct c from v1 limit 2";
+execute stmt1;
+execute stmt1;
+deallocate prepare stmt1;
+drop view v1;
+drop table t1;
+
+#
+# WITH CHECK OPTION insert/update test
+#
+create table t1 (a int,
+                 b virtual int as (-a),
+		 c virtual int as (-a) stored);
+create view v1 as select * from t1 where b > -2 && c >-2 with check option;
+# simple insert
+insert into v1 (a) values (1);
+-- error 1369
+insert into v1 (a) values (3);
+# simple insert with ignore
+insert ignore into v1 (a) values (2),(3),(0);
+select * from t1;
+drop view v1;
+drop table t1;
+

=== added directory 'tests/suite/vcol/r'
=== added file 'tests/suite/vcol/r/vcol_blocked_sql_funcs_innodb.result'
--- tests/suite/vcol/r/vcol_blocked_sql_funcs_innodb.result	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/r/vcol_blocked_sql_funcs_innodb.result	2008-09-19 11:49:17 +0000
@@ -0,0 +1,175 @@
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+SET @@session.storage_engine = 'InnoDB';
+# RAND()
+create table t1 (b virtual double as (rand()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# LOAD_FILE()
+create table t1 (a varchar(64), b virtual varchar(1024) as (load_file(a)));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# CURDATE()
+create table t1 (a virtual datetime as (curdate()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# CURRENT_DATE(), CURRENT_DATE
+create table t1 (a virtual datetime as (current_date));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+create table t1 (a virtual datetime as (current_date()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# CURRENT_TIME(), CURRENT_TIME
+create table t1 (a virtual datetime as (current_time));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+create table t1 (a virtual datetime as (current_time()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# CURRENT_TIMESTAMP(), CURRENT_TIMESTAMP
+create table t1 (a virtual datetime as (current_timestamp()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+create table t1 (a virtual datetime as (current_timestamp));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# CURTIME()
+create table t1 (a virtual datetime as (curtime()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# LOCALTIME(), LOCALTIME
+create table t1 (a datetime, b virtual varchar(10) as (localtime()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+create table t1 (a datetime, b virtual varchar(10) as (localtime));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# LOCALTIMESTAMP, LOCALTIMESTAMP()(v4.0.6)
+create table t1 (a datetime, b virtual varchar(10) as (localtimestamp()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+create table t1 (a datetime, b virtual varchar(10) as (localtimestamp));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# NOW()
+create table t1 (a datetime, b virtual varchar(10) as (now()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# SYSDATE()
+create table t1 (a int, b virtual varchar(10) as (sysdate()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# UNIX_TIMESTAMP()
+create table t1 (a datetime, b virtual datetime as (unix_timestamp()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# UTC_DATE()
+create table t1 (a datetime, b virtual datetime as (utc_date()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# UTC_TIME()
+create table t1 (a datetime, b virtual datetime as (utc_time()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# UTC_TIMESTAMP()
+create table t1 (a datetime, b virtual datetime as (utc_timestamp()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# BENCHMARK()
+create table t1 (a varchar(1024), b virtual varchar(1024) as (benchmark(a,3)));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# CONNECTION_ID()
+create table t1 (a virtual int as (connection_id()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# CURRENT_USER(), CURRENT_USER
+create table t1 (a virtual varchar(32) as (current_user()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+create table t1 (a virtual varchar(32) as (current_user));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# DATABASE()
+create table t1 (a varchar(1024), b virtual varchar(1024) as (database()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# FOUND_ROWS()
+create table t1 (a varchar(1024), b virtual varchar(1024) as (found_rows()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# LAST_INSERT_ID()
+create table t1 (a virtual int as (last_insert_id()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# MASTER_POS_WAIT()
+create table t1 (a varchar(32), b virtual int as (master_pos_wait(a,0,2)));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# ROW_COUNT()
+create table t1 (a virtual int as (row_count()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# SCHEMA()
+create table t1 (a virtual varchar(32) as (schema()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# SESSION_USER()
+create table t1 (a virtual varchar(32) as (session_user()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# SYSTEM_USER()
+create table t1 (a virtual varchar(32) as (system_user()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# USER()
+create table t1 (a varchar(1024), b virtual varchar(1024) as (user()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# UUID()
+create table t1 (a virtual varchar(1024) as (uuid()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# VALUES()
+create table t1 (a varchar(1024), b virtual varchar(1024) as (values(a)));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# VERSION()
+create table t1 (a varchar(1024), b virtual varchar(1024) as (version()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# Unknown functions
+create table t1 (a virtual int as (f1()));
+ERROR 42000: FUNCTION f1 does not exist
+# WEIGHT_STRING()
+create table t1 (a varchar(5), b virtual varchar(10) as (weight_string(a as char(4))));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+#
+# GROUP BY FUNCTIONS
+#
+# AVG()
+create table t1 (a int, b virtual int as (avg(a)));
+ERROR HY000: Invalid use of group function
+# COUNT(DISTINCT)
+create table t1 (a int, b virtual int as (count(distinct a)));
+ERROR HY000: Invalid use of group function
+# COUNT()
+create table t1 (a int, b virtual int as (count(a)));
+ERROR HY000: Invalid use of group function
+# GROUP_CONCAT()
+create table t1 (a varchar(32), b virtual int as (group_concat(a,'')));
+ERROR HY000: Invalid use of group function
+# MAX()
+create table t1 (a int, b virtual int as (max(a)));
+ERROR HY000: Invalid use of group function
+# MIN()
+create table t1 (a int, b virtual int as (min(a)));
+ERROR HY000: Invalid use of group function
+# STD()
+create table t1 (a int, b virtual int as (std(a)));
+ERROR HY000: Invalid use of group function
+# STDDEV_POP()
+create table t1 (a int, b virtual int as (stddev_pop(a)));
+ERROR HY000: Invalid use of group function
+# STDDEV_SAMP()
+create table t1 (a int, b virtual int as (stddev_samp(a)));
+ERROR HY000: Invalid use of group function
+# STDDEV()
+create table t1 (a int, b virtual int as (stddev(a)));
+ERROR HY000: Invalid use of group function
+# SUM()
+create table t1 (a int, b virtual int as (sum(a)));
+ERROR HY000: Invalid use of group function
+# VAR_POP()
+create table t1 (a int, b virtual int as (var_pop(a)));
+ERROR HY000: Invalid use of group function
+# VAR_SAMP()
+create table t1 (a int, b virtual int as (var_samp(a)));
+ERROR HY000: Invalid use of group function
+# VARIANCE()
+create table t1 (a int, b virtual int as (variance(a)));
+ERROR HY000: Invalid use of group function
+#
+# Sub-selects
+#
+create table t1 (a int);
+create table t2 (a int, b virtual int as (select count(*) from t1));
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'select count(*) from t1))' at line 1
+drop table t1;
+#
+# Long expression
+create table t1 (a int, b virtual varchar(300) as (concat(a,'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa')));
+drop table t1;
+create table t1 (a int, b virtual varchar(300) as (concat(a,'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa')));
+ERROR HY000: String 'concat(a,'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa' is too long for VIRTUAL COLUMN EXPRESSION (should be no longer than 252)
+#
+# Constant expression
+create table t1 (a virtual int as (1));
+ERROR HY000: Constant expression in virtual column function is not allowed.
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;

=== added file 'tests/suite/vcol/r/vcol_blocked_sql_funcs_myisam.result'
--- tests/suite/vcol/r/vcol_blocked_sql_funcs_myisam.result	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/r/vcol_blocked_sql_funcs_myisam.result	2008-09-19 11:49:17 +0000
@@ -0,0 +1,175 @@
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+SET @@session.storage_engine = 'MyISAM';
+# RAND()
+create table t1 (b virtual double as (rand()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# LOAD_FILE()
+create table t1 (a varchar(64), b virtual varchar(1024) as (load_file(a)));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# CURDATE()
+create table t1 (a virtual datetime as (curdate()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# CURRENT_DATE(), CURRENT_DATE
+create table t1 (a virtual datetime as (current_date));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+create table t1 (a virtual datetime as (current_date()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# CURRENT_TIME(), CURRENT_TIME
+create table t1 (a virtual datetime as (current_time));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+create table t1 (a virtual datetime as (current_time()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# CURRENT_TIMESTAMP(), CURRENT_TIMESTAMP
+create table t1 (a virtual datetime as (current_timestamp()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+create table t1 (a virtual datetime as (current_timestamp));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# CURTIME()
+create table t1 (a virtual datetime as (curtime()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# LOCALTIME(), LOCALTIME
+create table t1 (a datetime, b virtual varchar(10) as (localtime()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+create table t1 (a datetime, b virtual varchar(10) as (localtime));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# LOCALTIMESTAMP, LOCALTIMESTAMP()(v4.0.6)
+create table t1 (a datetime, b virtual varchar(10) as (localtimestamp()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+create table t1 (a datetime, b virtual varchar(10) as (localtimestamp));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# NOW()
+create table t1 (a datetime, b virtual varchar(10) as (now()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# SYSDATE()
+create table t1 (a int, b virtual varchar(10) as (sysdate()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# UNIX_TIMESTAMP()
+create table t1 (a datetime, b virtual datetime as (unix_timestamp()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# UTC_DATE()
+create table t1 (a datetime, b virtual datetime as (utc_date()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# UTC_TIME()
+create table t1 (a datetime, b virtual datetime as (utc_time()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# UTC_TIMESTAMP()
+create table t1 (a datetime, b virtual datetime as (utc_timestamp()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# BENCHMARK()
+create table t1 (a varchar(1024), b virtual varchar(1024) as (benchmark(a,3)));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# CONNECTION_ID()
+create table t1 (a virtual int as (connection_id()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# CURRENT_USER(), CURRENT_USER
+create table t1 (a virtual varchar(32) as (current_user()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+create table t1 (a virtual varchar(32) as (current_user));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# DATABASE()
+create table t1 (a varchar(1024), b virtual varchar(1024) as (database()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# FOUND_ROWS()
+create table t1 (a varchar(1024), b virtual varchar(1024) as (found_rows()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# LAST_INSERT_ID()
+create table t1 (a virtual int as (last_insert_id()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# MASTER_POS_WAIT()
+create table t1 (a varchar(32), b virtual int as (master_pos_wait(a,0,2)));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# ROW_COUNT()
+create table t1 (a virtual int as (row_count()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# SCHEMA()
+create table t1 (a virtual varchar(32) as (schema()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# SESSION_USER()
+create table t1 (a virtual varchar(32) as (session_user()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# SYSTEM_USER()
+create table t1 (a virtual varchar(32) as (system_user()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# USER()
+create table t1 (a varchar(1024), b virtual varchar(1024) as (user()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# UUID()
+create table t1 (a virtual varchar(1024) as (uuid()));
+ERROR HY000: Non-deterministic expression for virtual column 'a'.
+# VALUES()
+create table t1 (a varchar(1024), b virtual varchar(1024) as (values(a)));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# VERSION()
+create table t1 (a varchar(1024), b virtual varchar(1024) as (version()));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+# Unknown functions
+create table t1 (a virtual int as (f1()));
+ERROR 42000: FUNCTION f1 does not exist
+# WEIGHT_STRING()
+create table t1 (a varchar(5), b virtual varchar(10) as (weight_string(a as char(4))));
+ERROR HY000: Non-deterministic expression for virtual column 'b'.
+#
+# GROUP BY FUNCTIONS
+#
+# AVG()
+create table t1 (a int, b virtual int as (avg(a)));
+ERROR HY000: Invalid use of group function
+# COUNT(DISTINCT)
+create table t1 (a int, b virtual int as (count(distinct a)));
+ERROR HY000: Invalid use of group function
+# COUNT()
+create table t1 (a int, b virtual int as (count(a)));
+ERROR HY000: Invalid use of group function
+# GROUP_CONCAT()
+create table t1 (a varchar(32), b virtual int as (group_concat(a,'')));
+ERROR HY000: Invalid use of group function
+# MAX()
+create table t1 (a int, b virtual int as (max(a)));
+ERROR HY000: Invalid use of group function
+# MIN()
+create table t1 (a int, b virtual int as (min(a)));
+ERROR HY000: Invalid use of group function
+# STD()
+create table t1 (a int, b virtual int as (std(a)));
+ERROR HY000: Invalid use of group function
+# STDDEV_POP()
+create table t1 (a int, b virtual int as (stddev_pop(a)));
+ERROR HY000: Invalid use of group function
+# STDDEV_SAMP()
+create table t1 (a int, b virtual int as (stddev_samp(a)));
+ERROR HY000: Invalid use of group function
+# STDDEV()
+create table t1 (a int, b virtual int as (stddev(a)));
+ERROR HY000: Invalid use of group function
+# SUM()
+create table t1 (a int, b virtual int as (sum(a)));
+ERROR HY000: Invalid use of group function
+# VAR_POP()
+create table t1 (a int, b virtual int as (var_pop(a)));
+ERROR HY000: Invalid use of group function
+# VAR_SAMP()
+create table t1 (a int, b virtual int as (var_samp(a)));
+ERROR HY000: Invalid use of group function
+# VARIANCE()
+create table t1 (a int, b virtual int as (variance(a)));
+ERROR HY000: Invalid use of group function
+#
+# Sub-selects
+#
+create table t1 (a int);
+create table t2 (a int, b virtual int as (select count(*) from t1));
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'select count(*) from t1))' at line 1
+drop table t1;
+#
+# Long expression
+create table t1 (a int, b virtual varchar(300) as (concat(a,'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa')));
+drop table t1;
+create table t1 (a int, b virtual varchar(300) as (concat(a,'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa')));
+ERROR HY000: String 'concat(a,'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa' is too long for VIRTUAL COLUMN EXPRESSION (should be no longer than 252)
+#
+# Constant expression
+create table t1 (a virtual int as (1));
+ERROR HY000: Constant expression in virtual column function is not allowed.
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;

=== added file 'tests/suite/vcol/r/vcol_column_def_options_innodb.result'
--- tests/suite/vcol/r/vcol_column_def_options_innodb.result	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/r/vcol_column_def_options_innodb.result	2008-09-19 11:49:17 +0000
@@ -0,0 +1,150 @@
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+SET @@session.storage_engine = 'InnoDB';
+#
+# Section 1. Wrong column definition options
+#            - NOT NULL
+#            - NULL
+#            - DEFAULT <value>
+#            - AUTO_INCREMENT
+#            - [PRIMARY] KEY
+# NOT NULL
+create table t1 (a int, b virtual int as (a+1) not null);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'not null)' at line 1
+create table t1 (a int);
+alter table t1 add column b virtual int as (a+1) not null;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'not null' at line 1
+drop table t1;
+# NULL  
+create table t1 (a int, b virtual int as (a+1) null);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'null)' at line 1
+create table t1 (a int);
+alter table t1 add column b virtual int as (a+1) null;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'null' at line 1
+drop table t1;
+# DEFAULT
+create table t1 (a int, b virtual int as (a+1) default 0);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'default 0)' at line 1
+create table t1 (a int);
+alter table t1 add column b virtual int as (a+1) default 0;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'default 0' at line 1
+drop table t1;
+# AUTO_INCREMENT
+create table t1 (a int, b virtual int as (a+1) AUTO_INCREMENT);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'AUTO_INCREMENT)' at line 1
+create table t1 (a int);
+alter table t1 add column b virtual int as (a+1) AUTO_INCREMENT;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'AUTO_INCREMENT' at line 1
+drop table t1;
+# [PRIMARY] KEY
+create table t1 (a int, b virtual int as (a+1) key);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'key)' at line 1
+create table t1 (a int, b virtual int as (a+1) primary key);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'primary key)' at line 1
+create table t1 (a int);
+alter table t1 add column b virtual int as (a+1) key;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'key' at line 1
+alter table t1 add column b virtual int as (a+1) primary key;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'primary key' at line 1
+drop table t1;
+# Section 2. Other column definition options
+#            - COMMENT
+#            - REFERENCES (only syntax testing here)
+#            - STORED (only systax testing here)
+create table t1 (a int, b virtual int as (a % 2) comment 'my comment');
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2) COMMENT 'my comment'
+) ENGINE=InnoDB
+describe t1;
+Field	Type	Null	Key	Default	Extra
+a	int	YES		NULL	
+b	int	YES		NULL	VIRTUAL
+drop table t1;
+create table t1 (a int, b virtual int as (a % 2));
+alter table t1 modify b virtual int as (a % 2) comment 'my comment';
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2) COMMENT 'my comment'
+) ENGINE=InnoDB
+describe t1;
+Field	Type	Null	Key	Default	Extra
+a	int	YES		NULL	
+b	int	YES		NULL	VIRTUAL
+insert into t1 (a) values (1);
+select * from t1;
+a	b
+1	1
+insert into t1 values (2,default);
+select a,b from t1;
+a	b
+1	1
+2	0
+create table t2 like t1;
+show create table t2;
+Table	Create Table
+t2	CREATE TABLE `t2` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2) COMMENT 'my comment'
+) ENGINE=InnoDB
+describe t2;
+Field	Type	Null	Key	Default	Extra
+a	int	YES		NULL	
+b	int	YES		NULL	VIRTUAL
+insert into t2 (a) values (1);
+select * from t2;
+a	b
+1	1
+insert into t2 values (2,default);
+select a,b from t2;
+a	b
+1	1
+2	0
+drop table t2;
+drop table t1;
+create table t1 (a int, b virtual int as (a % 2) stored);
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2) STORED
+) ENGINE=InnoDB
+describe t1;
+Field	Type	Null	Key	Default	Extra
+a	int	YES		NULL	
+b	int	YES		NULL	VIRTUAL
+insert into t1 (a) values (1);
+select * from t1;
+a	b
+1	1
+insert into t1 values (2,default);
+select a,b from t1;
+a	b
+1	1
+2	0
+drop table t1;
+create table t2 (a int);
+create table t1 (a int, b virtual int as (a % 2) stored references t2(a));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2) STORED
+) ENGINE=InnoDB
+drop table t1;
+create table t1 (a int, b virtual int as (a % 2));
+alter table t1 modify b virtual int as (a % 2) stored references t2(a);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'references t2(a)' at line 1
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2)
+) ENGINE=InnoDB
+drop table t1;
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;

=== added file 'tests/suite/vcol/r/vcol_column_def_options_myisam.result'
--- tests/suite/vcol/r/vcol_column_def_options_myisam.result	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/r/vcol_column_def_options_myisam.result	2008-09-19 11:49:17 +0000
@@ -0,0 +1,150 @@
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+SET @@session.storage_engine = 'MyISAM';
+#
+# Section 1. Wrong column definition options
+#            - NOT NULL
+#            - NULL
+#            - DEFAULT <value>
+#            - AUTO_INCREMENT
+#            - [PRIMARY] KEY
+# NOT NULL
+create table t1 (a int, b virtual int as (a+1) not null);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'not null)' at line 1
+create table t1 (a int);
+alter table t1 add column b virtual int as (a+1) not null;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'not null' at line 1
+drop table t1;
+# NULL  
+create table t1 (a int, b virtual int as (a+1) null);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'null)' at line 1
+create table t1 (a int);
+alter table t1 add column b virtual int as (a+1) null;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'null' at line 1
+drop table t1;
+# DEFAULT
+create table t1 (a int, b virtual int as (a+1) default 0);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'default 0)' at line 1
+create table t1 (a int);
+alter table t1 add column b virtual int as (a+1) default 0;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'default 0' at line 1
+drop table t1;
+# AUTO_INCREMENT
+create table t1 (a int, b virtual int as (a+1) AUTO_INCREMENT);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'AUTO_INCREMENT)' at line 1
+create table t1 (a int);
+alter table t1 add column b virtual int as (a+1) AUTO_INCREMENT;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'AUTO_INCREMENT' at line 1
+drop table t1;
+# [PRIMARY] KEY
+create table t1 (a int, b virtual int as (a+1) key);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'key)' at line 1
+create table t1 (a int, b virtual int as (a+1) primary key);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'primary key)' at line 1
+create table t1 (a int);
+alter table t1 add column b virtual int as (a+1) key;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'key' at line 1
+alter table t1 add column b virtual int as (a+1) primary key;
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'primary key' at line 1
+drop table t1;
+# Section 2. Other column definition options
+#            - COMMENT
+#            - REFERENCES (only syntax testing here)
+#            - STORED (only systax testing here)
+create table t1 (a int, b virtual int as (a % 2) comment 'my comment');
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2) COMMENT 'my comment'
+) ENGINE=MyISAM
+describe t1;
+Field	Type	Null	Key	Default	Extra
+a	int	YES		NULL	
+b	int	YES		NULL	VIRTUAL
+drop table t1;
+create table t1 (a int, b virtual int as (a % 2));
+alter table t1 modify b virtual int as (a % 2) comment 'my comment';
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2) COMMENT 'my comment'
+) ENGINE=MyISAM
+describe t1;
+Field	Type	Null	Key	Default	Extra
+a	int	YES		NULL	
+b	int	YES		NULL	VIRTUAL
+insert into t1 (a) values (1);
+select * from t1;
+a	b
+1	1
+insert into t1 values (2,default);
+select a,b from t1;
+a	b
+1	1
+2	0
+create table t2 like t1;
+show create table t2;
+Table	Create Table
+t2	CREATE TABLE `t2` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2) COMMENT 'my comment'
+) ENGINE=MyISAM
+describe t2;
+Field	Type	Null	Key	Default	Extra
+a	int	YES		NULL	
+b	int	YES		NULL	VIRTUAL
+insert into t2 (a) values (1);
+select * from t2;
+a	b
+1	1
+insert into t2 values (2,default);
+select a,b from t2;
+a	b
+1	1
+2	0
+drop table t2;
+drop table t1;
+create table t1 (a int, b virtual int as (a % 2) stored);
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2) STORED
+) ENGINE=MyISAM
+describe t1;
+Field	Type	Null	Key	Default	Extra
+a	int	YES		NULL	
+b	int	YES		NULL	VIRTUAL
+insert into t1 (a) values (1);
+select * from t1;
+a	b
+1	1
+insert into t1 values (2,default);
+select a,b from t1;
+a	b
+1	1
+2	0
+drop table t1;
+create table t2 (a int);
+create table t1 (a int, b virtual int as (a % 2) stored references t2(a));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2) STORED
+) ENGINE=MyISAM
+drop table t1;
+create table t1 (a int, b virtual int as (a % 2));
+alter table t1 modify b virtual int as (a % 2) stored references t2(a);
+ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near 'references t2(a)' at line 1
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2)
+) ENGINE=MyISAM
+drop table t1;
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;

=== added file 'tests/suite/vcol/r/vcol_ins_upd_innodb.result'
--- tests/suite/vcol/r/vcol_ins_upd_innodb.result	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/r/vcol_ins_upd_innodb.result	2008-09-19 11:49:17 +0000
@@ -0,0 +1,431 @@
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+SET @@session.storage_engine = 'InnoDB';
+create table t1 (a int, 
+b virtual int as (-a),
+c virtual int as (-a) stored);
+set sql_warnings = 1;
+#
+# *** INSERT ***
+#
+# INSERT INTO tbl_name VALUES… DEFAULT is specified against vcols
+insert into t1 values (1,default,default);
+select * from t1;
+a	b	c
+1	-1	-1
+delete from t1;
+select * from t1;
+a	b	c
+# INSERT INTO tbl_name VALUES… NULL is specified against vcols
+insert into t1 values (1,null,null);
+select * from t1;
+a	b	c
+1	-1	-1
+delete from t1;
+select * from t1;
+a	b	c
+# INSERT INTO tbl_name VALUES… a non-NULL value is specified against vcols
+insert into t1 values (1,2,3);
+Warnings:
+Warning	1679	The value specified for virtual column 'b' in table 't1' ignored.
+Warning	1679	The value specified for virtual column 'c' in table 't1' ignored.
+select * from t1;
+a	b	c
+1	-1	-1
+delete from t1;
+select * from t1;
+a	b	c
+# INSERT INTO tbl_name (<non_vcol_list>) VALUES…
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+delete from t1;
+select * from t1;
+a	b	c
+# INSERT INTO tbl_name (<normal+vcols>) VALUES… DEFAULT is specified 
+# against vcols
+insert into t1 (a,b) values (1,default), (2,default);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+delete from t1;
+select * from t1;
+a	b	c
+# INSERT INTO tbl_name (<normal+vcols>) VALUES… NULL is specified against vcols
+insert into t1 (a,b) values (1,null), (2,null);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+delete from t1;
+select * from t1;
+a	b	c
+# INSERT INTO tbl_name (<normal+vcols>) VALUES… a non-NULL value is specified 
+# against vcols
+insert into t1 (a,b) values (1,3), (2,4);
+Warnings:
+Warning	1679	The value specified for virtual column 'b' in table 't1' ignored.
+Warning	1679	The value specified for virtual column 'b' in table 't1' ignored.
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+delete from t1;
+select * from t1;
+a	b	c
+drop table t1;
+# Table with UNIQUE non-vcol field. INSERT INTO tbl_name VALUES… ON DUPLICATE 
+# KEY UPDATE <non_vcol>=expr, <vcol>=expr
+create table t1 (a int unique, 
+b virtual int as (-a),
+c virtual int as (-a) stored);
+insert into t1 values (1,default,default);
+insert into t1 values (1,default,default) 
+on duplicate key update a=2, b=default;
+select a,b,c from t1;
+a	b	c
+2	-2	-2
+delete from t1 where b in (1,2);
+select * from t1;
+a	b	c
+2	-2	-2
+drop table t1;
+# Table with UNIQUE vcol field. INSERT INTO tbl_name VALUES… ON DUPLICATE 
+# KEY UPDATE <non_vcol>=expr, <vcol>=expr
+create table t1 (a int, 
+b virtual int as (-a),
+c virtual int as (-a) stored unique);
+insert into t1 values (1,default,default);
+insert into t1 values (1,default,default) 
+on duplicate key update a=2, b=default;
+select a,b,c from t1;
+a	b	c
+2	-2	-2
+# CREATE new_table … LIKE old_table
+# INSERT INTO new_table SELECT * from old_table
+create table t2 like t1;
+insert into t2 select * from t1;
+Warnings:
+Warning	1679	The value specified for virtual column 'b' in table 't2' ignored.
+Warning	1679	The value specified for virtual column 'c' in table 't2' ignored.
+select * from t1;
+a	b	c
+2	-2	-2
+drop table t2;
+# CREATE new_table … LIKE old_table INSERT INTO new_table (<non-vcols>, <vcols>) 
+# SELECT <non-vcols>, <vcols> from old_table
+insert into t1 values (1,default,default);
+select * from t1;
+a	b	c
+2	-2	-2
+1	-1	-1
+create table t2 like t1;
+insert into t2 (a,b) select a,b from t1;
+Warnings:
+Warning	1679	The value specified for virtual column 'b' in table 't2' ignored.
+Warning	1679	The value specified for virtual column 'b' in table 't2' ignored.
+select * from t2;
+a	b	c
+2	-2	-2
+1	-1	-1
+drop table t2;
+drop table t1;
+#
+# *** UPDATE ***
+#
+# UPDATE tbl_name SET non-vcol=expr WHERE non-vcol=expr
+create table t1 (a int, 
+b virtual int as (-a),
+c virtual int as (-a) stored);
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+update t1 set a=3 where a=2;
+select * from t1;
+a	b	c
+1	-1	-1
+3	-3	-3
+delete from t1;
+select * from t1;
+a	b	c
+# UPDATE tbl_name SET vcol=expr WHERE non-vcol=expr
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+update t1 set c=3 where a=2;
+Warnings:
+Warning	1679	The value specified for virtual column 'c' in table 't1' ignored.
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+delete from t1;
+select * from t1;
+a	b	c
+# UPDATE tbl_name SET non-vcol=expr WHERE vcol=expr
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+update t1 set a=3 where b=-2;
+select * from t1;
+a	b	c
+1	-1	-1
+3	-3	-3
+delete from t1;
+select * from t1;
+a	b	c
+# UPDATE tbl_name SET vcol=expr WHERE vcol=expr
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+update t1 set c=3 where b=-2;
+Warnings:
+Warning	1679	The value specified for virtual column 'c' in table 't1' ignored.
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+delete from t1;
+select * from t1;
+a	b	c
+drop table t1;
+# INDEX created on vcol 
+# UPDATE tbl_name SET non-vcol=expr WHERE vcol=const
+create table t1 (a int, 
+b virtual int as (-a),
+c virtual int as (-a) stored unique);
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+update t1 set a=3 where c=-2;
+select * from t1;
+a	b	c
+1	-1	-1
+3	-3	-3
+delete from t1;
+select * from t1;
+a	b	c
+# INDEX created on vcol 
+# UPDATE tbl_name SET non-vcol=expr WHERE vcol=between const1 and const2
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+update t1 set a=3 where c between -3 and -2;
+select * from t1;
+a	b	c
+1	-1	-1
+3	-3	-3
+delete from t1;
+select * from t1;
+a	b	c
+# No INDEX created on vcol 
+# UPDATE tbl_name SET non-vcol=expr WHERE vcol=between const1 and const2
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+update t1 set a=3 where b between -3 and -2;
+select * from t1;
+a	b	c
+1	-1	-1
+3	-3	-3
+delete from t1;
+select * from t1;
+a	b	c
+# INDEX created on vcol 
+# UPDATE tbl_name SET non-vcol=expr 
+# WHERE vcol=between const1 and const2 ORDER BY vcol
+insert into t1 (a) values (1), (2), (3), (4), (5);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+3	-3	-3
+4	-4	-4
+5	-5	-5
+update t1 set a=6 where c between -1 and 0
+order by c;
+select * from t1;
+a	b	c
+6	-6	-6
+2	-2	-2
+3	-3	-3
+4	-4	-4
+5	-5	-5
+delete from t1 where c between -6 and 0;
+select * from t1;
+a	b	c
+# INDEX created on vcol 
+# UPDATE tbl_name SET non-vcol=expr 
+# WHERE vcol=between const1 and const2 ORDER BY vcol LIMIT 2
+insert into t1 (a) values (1), (2), (3), (4), (5);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+3	-3	-3
+4	-4	-4
+5	-5	-5
+update t1 set a=6 where c between -1 and 0
+order by c limit 2;
+select * from t1;
+a	b	c
+6	-6	-6
+2	-2	-2
+3	-3	-3
+4	-4	-4
+5	-5	-5
+delete from t1 where c between -2 and 0 order by c;
+select * from t1;
+a	b	c
+6	-6	-6
+3	-3	-3
+4	-4	-4
+5	-5	-5
+delete from t1;
+# INDEX created on vcol 
+# UPDATE tbl_name SET non-vcol=expr
+# WHERE indexed vcol=between const1 and const2 and non-indexed vcol=const3
+insert into t1 (a) values (1), (2), (3), (4), (5);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+3	-3	-3
+4	-4	-4
+5	-5	-5
+update t1 set a=6 where (c between -2 and 0) and (b=-1);
+select * from t1;
+a	b	c
+6	-6	-6
+2	-2	-2
+3	-3	-3
+4	-4	-4
+5	-5	-5
+delete from t1;
+# INDEX created on vcol 
+# UPDATE tbl_name SET non-vcol=expr
+# WHERE indexed vcol=between const1 and const2 and non-indexed vcol=const3
+# ORDER BY indexed vcol
+insert into t1 (a) values (1), (2), (3), (4), (5);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+3	-3	-3
+4	-4	-4
+5	-5	-5
+update t1 set a=6 where (c between -2 and 0) and (b=-1) order by c;
+select * from t1;
+a	b	c
+6	-6	-6
+2	-2	-2
+3	-3	-3
+4	-4	-4
+5	-5	-5
+delete from t1;
+drop table t1;
+#
+# Verify ON UPDATE/DELETE actions of FOREIGN KEYs
+create table t2 (a int primary key, name varchar(10));
+create table t1 (a int primary key, b virtual int as (a % 10) stored);
+insert into t2 values (1, 'value1'), (2,'value2'), (3,'value3');
+insert into t1 (a) values (1),(2),(3);
+select * from t1;
+a	b
+1	1
+2	2
+3	3
+select * from t2;
+a	name
+1	value1
+2	value2
+3	value3
+select t1.a, t1.b, t2.name from t1,t2 where t1.b=t2.a;
+a	b	name
+1	1	value1
+2	2	value2
+3	3	value3
+#  - ON UPDATE RESTRICT
+alter table t1 add foreign key (b) references t2(a) on update restrict;
+insert into t1 (a) values (4);
+ERROR 23000: Cannot add or update a child row: a foreign key constraint fails (`test`.`t1`, CONSTRAINT `t1_ibfk_1` FOREIGN KEY (`b`) REFERENCES `t2` (`a`))
+update t2 set a=4 where a=3;
+ERROR 23000: Cannot delete or update a parent row: a foreign key constraint fails (`test`.`t1`, CONSTRAINT `t1_ibfk_1` FOREIGN KEY (`b`) REFERENCES `t2` (`a`))
+select t1.a, t1.b, t2.name from t1,t2 where t1.b=t2.a;
+a	b	name
+1	1	value1
+2	2	value2
+3	3	value3
+alter table t1 drop foreign key t1_ibfk_1;
+#  - ON DELETE RESTRICT
+alter table t1 add foreign key (b) references t2(a) on delete restrict;
+delete from t2 where a=3;
+ERROR 23000: Cannot delete or update a parent row: a foreign key constraint fails (`test`.`t1`, CONSTRAINT `t1_ibfk_1` FOREIGN KEY (`b`) REFERENCES `t2` (`a`))
+select t1.a, t1.b, t2.name from t1,t2 where t1.b=t2.a;
+a	b	name
+1	1	value1
+2	2	value2
+3	3	value3
+select t1.a, t1.b, t2.name from t1 left outer join t2 on (t1.b=t2.a);
+a	b	name
+1	1	value1
+2	2	value2
+3	3	value3
+alter table t1 drop foreign key t1_ibfk_1;
+#  - ON DELETE CASCADE
+alter table t1 add foreign key (b) references t2(a) on delete cascade;
+delete from t2 where a=3;
+select t1.a, t1.b, t2.name from t1,t2 where t1.b=t2.a;
+a	b	name
+1	1	value1
+2	2	value2
+select t1.a, t1.b, t2.name from t1 left outer join t2 on (t1.b=t2.a);
+a	b	name
+1	1	value1
+2	2	value2
+alter table t1 drop foreign key t1_ibfk_1;
+drop table t1;
+drop table t2;
+#
+# *** REPLACE ***
+#
+# UNIQUE INDEX on vcol
+# REPLACE tbl_name (non-vcols) VALUES (non-vcols);
+create table t1 (a int, 
+b virtual int as (-a),
+c virtual int as (-a) stored unique,
+d varchar(16));
+insert into t1 (a,d) values (1,'a'), (2,'b');
+select * from t1;
+a	b	c	d
+1	-1	-1	a
+2	-2	-2	b
+replace t1 (a,d) values (1,'c');
+select * from t1;
+a	b	c	d
+1	-1	-1	c
+2	-2	-2	b
+delete from t1;
+select * from t1;
+a	b	c	d
+set sql_warnings = 0;
+drop table t1;
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;

=== added file 'tests/suite/vcol/r/vcol_ins_upd_myisam.result'
--- tests/suite/vcol/r/vcol_ins_upd_myisam.result	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/r/vcol_ins_upd_myisam.result	2008-09-19 11:49:17 +0000
@@ -0,0 +1,369 @@
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+SET @@session.storage_engine = 'MyISAM';
+create table t1 (a int, 
+b virtual int as (-a),
+c virtual int as (-a) stored);
+set sql_warnings = 1;
+#
+# *** INSERT ***
+#
+# INSERT INTO tbl_name VALUES… DEFAULT is specified against vcols
+insert into t1 values (1,default,default);
+select * from t1;
+a	b	c
+1	-1	-1
+delete from t1;
+select * from t1;
+a	b	c
+# INSERT INTO tbl_name VALUES… NULL is specified against vcols
+insert into t1 values (1,null,null);
+select * from t1;
+a	b	c
+1	-1	-1
+delete from t1;
+select * from t1;
+a	b	c
+# INSERT INTO tbl_name VALUES… a non-NULL value is specified against vcols
+insert into t1 values (1,2,3);
+Warnings:
+Warning	1679	The value specified for virtual column 'b' in table 't1' ignored.
+Warning	1679	The value specified for virtual column 'c' in table 't1' ignored.
+select * from t1;
+a	b	c
+1	-1	-1
+delete from t1;
+select * from t1;
+a	b	c
+# INSERT INTO tbl_name (<non_vcol_list>) VALUES…
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+delete from t1;
+select * from t1;
+a	b	c
+# INSERT INTO tbl_name (<normal+vcols>) VALUES… DEFAULT is specified 
+# against vcols
+insert into t1 (a,b) values (1,default), (2,default);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+delete from t1;
+select * from t1;
+a	b	c
+# INSERT INTO tbl_name (<normal+vcols>) VALUES… NULL is specified against vcols
+insert into t1 (a,b) values (1,null), (2,null);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+delete from t1;
+select * from t1;
+a	b	c
+# INSERT INTO tbl_name (<normal+vcols>) VALUES… a non-NULL value is specified 
+# against vcols
+insert into t1 (a,b) values (1,3), (2,4);
+Warnings:
+Warning	1679	The value specified for virtual column 'b' in table 't1' ignored.
+Warning	1679	The value specified for virtual column 'b' in table 't1' ignored.
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+delete from t1;
+select * from t1;
+a	b	c
+drop table t1;
+# Table with UNIQUE non-vcol field. INSERT INTO tbl_name VALUES… ON DUPLICATE 
+# KEY UPDATE <non_vcol>=expr, <vcol>=expr
+create table t1 (a int unique, 
+b virtual int as (-a),
+c virtual int as (-a) stored);
+insert into t1 values (1,default,default);
+insert into t1 values (1,default,default) 
+on duplicate key update a=2, b=default;
+select a,b,c from t1;
+a	b	c
+2	-2	-2
+delete from t1 where b in (1,2);
+select * from t1;
+a	b	c
+2	-2	-2
+drop table t1;
+# Table with UNIQUE vcol field. INSERT INTO tbl_name VALUES… ON DUPLICATE 
+# KEY UPDATE <non_vcol>=expr, <vcol>=expr
+create table t1 (a int, 
+b virtual int as (-a),
+c virtual int as (-a) stored unique);
+insert into t1 values (1,default,default);
+insert into t1 values (1,default,default) 
+on duplicate key update a=2, b=default;
+select a,b,c from t1;
+a	b	c
+2	-2	-2
+# CREATE new_table … LIKE old_table
+# INSERT INTO new_table SELECT * from old_table
+create table t2 like t1;
+insert into t2 select * from t1;
+Warnings:
+Warning	1679	The value specified for virtual column 'b' in table 't2' ignored.
+Warning	1679	The value specified for virtual column 'c' in table 't2' ignored.
+select * from t1;
+a	b	c
+2	-2	-2
+drop table t2;
+# CREATE new_table … LIKE old_table INSERT INTO new_table (<non-vcols>, <vcols>) 
+# SELECT <non-vcols>, <vcols> from old_table
+insert into t1 values (1,default,default);
+select * from t1;
+a	b	c
+2	-2	-2
+1	-1	-1
+create table t2 like t1;
+insert into t2 (a,b) select a,b from t1;
+Warnings:
+Warning	1679	The value specified for virtual column 'b' in table 't2' ignored.
+Warning	1679	The value specified for virtual column 'b' in table 't2' ignored.
+select * from t2;
+a	b	c
+2	-2	-2
+1	-1	-1
+drop table t2;
+drop table t1;
+#
+# *** UPDATE ***
+#
+# UPDATE tbl_name SET non-vcol=expr WHERE non-vcol=expr
+create table t1 (a int, 
+b virtual int as (-a),
+c virtual int as (-a) stored);
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+update t1 set a=3 where a=2;
+select * from t1;
+a	b	c
+1	-1	-1
+3	-3	-3
+delete from t1;
+select * from t1;
+a	b	c
+# UPDATE tbl_name SET vcol=expr WHERE non-vcol=expr
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+update t1 set c=3 where a=2;
+Warnings:
+Warning	1679	The value specified for virtual column 'c' in table 't1' ignored.
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+delete from t1;
+select * from t1;
+a	b	c
+# UPDATE tbl_name SET non-vcol=expr WHERE vcol=expr
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+update t1 set a=3 where b=-2;
+select * from t1;
+a	b	c
+1	-1	-1
+3	-3	-3
+delete from t1;
+select * from t1;
+a	b	c
+# UPDATE tbl_name SET vcol=expr WHERE vcol=expr
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+update t1 set c=3 where b=-2;
+Warnings:
+Warning	1679	The value specified for virtual column 'c' in table 't1' ignored.
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+delete from t1;
+select * from t1;
+a	b	c
+drop table t1;
+# INDEX created on vcol 
+# UPDATE tbl_name SET non-vcol=expr WHERE vcol=const
+create table t1 (a int, 
+b virtual int as (-a),
+c virtual int as (-a) stored unique);
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+update t1 set a=3 where c=-2;
+select * from t1;
+a	b	c
+1	-1	-1
+3	-3	-3
+delete from t1;
+select * from t1;
+a	b	c
+# INDEX created on vcol 
+# UPDATE tbl_name SET non-vcol=expr WHERE vcol=between const1 and const2
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+update t1 set a=3 where c between -3 and -2;
+select * from t1;
+a	b	c
+1	-1	-1
+3	-3	-3
+delete from t1;
+select * from t1;
+a	b	c
+# No INDEX created on vcol 
+# UPDATE tbl_name SET non-vcol=expr WHERE vcol=between const1 and const2
+insert into t1 (a) values (1), (2);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+update t1 set a=3 where b between -3 and -2;
+select * from t1;
+a	b	c
+1	-1	-1
+3	-3	-3
+delete from t1;
+select * from t1;
+a	b	c
+# INDEX created on vcol 
+# UPDATE tbl_name SET non-vcol=expr 
+# WHERE vcol=between const1 and const2 ORDER BY vcol
+insert into t1 (a) values (1), (2), (3), (4), (5);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+3	-3	-3
+4	-4	-4
+5	-5	-5
+update t1 set a=6 where c between -1 and 0
+order by c;
+select * from t1;
+a	b	c
+6	-6	-6
+2	-2	-2
+3	-3	-3
+4	-4	-4
+5	-5	-5
+delete from t1 where c between -6 and 0;
+select * from t1;
+a	b	c
+# INDEX created on vcol 
+# UPDATE tbl_name SET non-vcol=expr 
+# WHERE vcol=between const1 and const2 ORDER BY vcol LIMIT 2
+insert into t1 (a) values (1), (2), (3), (4), (5);
+select * from t1;
+a	b	c
+5	-5	-5
+4	-4	-4
+3	-3	-3
+2	-2	-2
+1	-1	-1
+update t1 set a=6 where c between -1 and 0
+order by c limit 2;
+select * from t1;
+a	b	c
+5	-5	-5
+4	-4	-4
+3	-3	-3
+2	-2	-2
+6	-6	-6
+delete from t1 where c between -2 and 0 order by c;
+select * from t1;
+a	b	c
+5	-5	-5
+4	-4	-4
+3	-3	-3
+6	-6	-6
+delete from t1;
+# INDEX created on vcol 
+# UPDATE tbl_name SET non-vcol=expr
+# WHERE indexed vcol=between const1 and const2 and non-indexed vcol=const3
+insert into t1 (a) values (1), (2), (3), (4), (5);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+3	-3	-3
+4	-4	-4
+5	-5	-5
+update t1 set a=6 where (c between -2 and 0) and (b=-1);
+select * from t1;
+a	b	c
+6	-6	-6
+2	-2	-2
+3	-3	-3
+4	-4	-4
+5	-5	-5
+delete from t1;
+# INDEX created on vcol 
+# UPDATE tbl_name SET non-vcol=expr
+# WHERE indexed vcol=between const1 and const2 and non-indexed vcol=const3
+# ORDER BY indexed vcol
+insert into t1 (a) values (1), (2), (3), (4), (5);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+3	-3	-3
+4	-4	-4
+5	-5	-5
+update t1 set a=6 where (c between -2 and 0) and (b=-1) order by c;
+select * from t1;
+a	b	c
+6	-6	-6
+2	-2	-2
+3	-3	-3
+4	-4	-4
+5	-5	-5
+delete from t1;
+drop table t1;
+#
+# *** REPLACE ***
+#
+# UNIQUE INDEX on vcol
+# REPLACE tbl_name (non-vcols) VALUES (non-vcols);
+create table t1 (a int, 
+b virtual int as (-a),
+c virtual int as (-a) stored unique,
+d varchar(16));
+insert into t1 (a,d) values (1,'a'), (2,'b');
+select * from t1;
+a	b	c	d
+1	-1	-1	a
+2	-2	-2	b
+replace t1 (a,d) values (1,'c');
+select * from t1;
+a	b	c	d
+1	-1	-1	c
+2	-2	-2	b
+delete from t1;
+select * from t1;
+a	b	c	d
+set sql_warnings = 0;
+drop table t1;
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;

=== added file 'tests/suite/vcol/r/vcol_keys_innodb.result'
--- tests/suite/vcol/r/vcol_keys_innodb.result	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/r/vcol_keys_innodb.result	2008-09-19 11:49:17 +0000
@@ -0,0 +1,150 @@
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+SET @@session.storage_engine = 'InnoDB';
+#            - UNIQUE KEY
+#            - INDEX
+#            - FOREIGN INDEX (partially supported)
+#            - CHECK (allowed but not used)
+# UNIQUE
+create table t1 (a int, b virtual int as (a*2) unique);
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+create table t1 (a int, b virtual int as (a*2) stored unique);
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a*2) STORED,
+  UNIQUE KEY `b` (`b`)
+) ENGINE=InnoDB
+describe t1;
+Field	Type	Null	Key	Default	Extra
+a	int	YES		NULL	
+b	int	YES	UNI	NULL	VIRTUAL
+drop table t1;
+create table t1 (a int, b virtual int as (a*2), unique key (b));
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+create table t1 (a int, b virtual int as (a*2) stored, unique (b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a*2) STORED,
+  UNIQUE KEY `b` (`b`)
+) ENGINE=InnoDB
+describe t1;
+Field	Type	Null	Key	Default	Extra
+a	int	YES		NULL	
+b	int	YES	UNI	NULL	VIRTUAL
+drop table t1;
+create table t1 (a int, b virtual int as (a*2));
+alter table t1 add unique key (b);
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+drop table t1;
+create table t1 (a int, b virtual int as (a*2) stored);
+alter table t1 add unique key (b);
+drop table t1;
+# Testing data manipulation operations involving UNIQUE keys 
+# on virtual columns can be found in:
+#  - vcol_ins_upd.inc
+#  - vcol_select.inc
+# 
+# INDEX
+create table t1 (a int, b virtual int as (a*2), index (b));
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+create table t1 (a int, b virtual int as (a*2), index (a,b));
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+create table t1 (a int, b virtual int as (a*2) stored, index (b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a*2) STORED,
+  KEY `b` (`b`)
+) ENGINE=InnoDB
+describe t1;
+Field	Type	Null	Key	Default	Extra
+a	int	YES		NULL	
+b	int	YES	MUL	NULL	VIRTUAL
+drop table t1;
+create table t1 (a int, b virtual int as (a*2) stored, index (a,b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a*2) STORED,
+  KEY `a` (`a`,`b`)
+) ENGINE=InnoDB
+describe t1;
+Field	Type	Null	Key	Default	Extra
+a	int	YES	MUL	NULL	
+b	int	YES		NULL	VIRTUAL
+drop table t1;
+create table t1 (a int, b virtual int as (a*2));
+alter table t1 add index (b);
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+alter table t1 add index (a,b);
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+drop table t1;
+create table t1 (a int, b virtual int as (a*2) stored);
+alter table t1 add index (b);
+drop table t1;
+create table t1 (a int, b virtual int as (a*2) stored);
+alter table t1 add index (a,b);
+create table t2 like t1;
+drop table t2;
+drop table t1;
+# Testing data manipulation operations involving INDEX
+# on virtual columns can be found in:
+#  - vcol_select.inc
+# FOREIGN KEY
+# Rejected FK options.
+create table t1 (a int, b virtual int as (a+1) stored,
+foreign key (b) references t2(a) on update set null);
+ERROR HY000: Cannot define foreign key with ON UPDATE SET NULL clause on a virtual column.
+create table t1 (a int, b virtual int as (a+1) stored,
+foreign key (b) references t2(a) on update cascade);
+ERROR HY000: Cannot define foreign key with ON UPDATE CASCADE clause on a virtual column.
+create table t1 (a int, b virtual int as (a+1) stored,
+foreign key (b) references t2(a) on delete set null);
+ERROR HY000: Cannot define foreign key with ON DELETE SET NULL clause on a virtual column.
+create table t1 (a int, b virtual int as (a+1) stored);
+alter table t1 add foreign key (b) references t2(a) on update set null;
+ERROR HY000: Cannot define foreign key with ON UPDATE SET NULL clause on a virtual column.
+alter table t1 add foreign key (b) references t2(a) on update cascade;
+ERROR HY000: Cannot define foreign key with ON UPDATE CASCADE clause on a virtual column.
+alter table t1 add foreign key (b) references t2(a) on delete set null;
+ERROR HY000: Cannot define foreign key with ON DELETE SET NULL clause on a virtual column.
+drop table t1;
+create table t1 (a int, b virtual int as (a+1),
+foreign key (b) references t2(a));
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+create table t1 (a int, b virtual int as (a+1));
+alter table t1 add foreign key (b) references t2(a);
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+drop table t1;
+# Allowed FK options.
+create table t2 (a int primary key, b char(5));
+create table t1 (a int, b virtual int as (a % 10) stored,
+foreign key (b) references t2(a) on update restrict);
+drop table t1;
+create table t1 (a int, b virtual int as (a % 10) stored,
+foreign key (b) references t2(a) on update no action);
+drop table t1;
+create table t1 (a int, b virtual int as (a % 10) stored,
+foreign key (b) references t2(a) on delete restrict);
+drop table t1;
+create table t1 (a int, b virtual int as (a % 10) stored,
+foreign key (b) references t2(a) on delete cascade);
+drop table t1;
+create table t1 (a int, b virtual int as (a % 10) stored,
+foreign key (b) references t2(a) on delete no action);
+drop table t1;
+
+# Testing data manipulation operations involving FOREIGN KEY 
+# on virtual columns can be found in:
+#  - vcol_ins_upd.inc
+#  - vcol_select.inc
+#
+# TODO: CHECK
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;

=== added file 'tests/suite/vcol/r/vcol_keys_myisam.result'
--- tests/suite/vcol/r/vcol_keys_myisam.result	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/r/vcol_keys_myisam.result	2008-09-19 11:49:17 +0000
@@ -0,0 +1,150 @@
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+SET @@session.storage_engine = 'MyISAM';
+#            - UNIQUE KEY
+#            - INDEX
+#            - FOREIGN INDEX (partially supported)
+#            - CHECK (allowed but not used)
+# UNIQUE
+create table t1 (a int, b virtual int as (a*2) unique);
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+create table t1 (a int, b virtual int as (a*2) stored unique);
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a*2) STORED,
+  UNIQUE KEY `b` (`b`)
+) ENGINE=MyISAM
+describe t1;
+Field	Type	Null	Key	Default	Extra
+a	int	YES		NULL	
+b	int	YES	UNI	NULL	VIRTUAL
+drop table t1;
+create table t1 (a int, b virtual int as (a*2), unique key (b));
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+create table t1 (a int, b virtual int as (a*2) stored, unique (b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a*2) STORED,
+  UNIQUE KEY `b` (`b`)
+) ENGINE=MyISAM
+describe t1;
+Field	Type	Null	Key	Default	Extra
+a	int	YES		NULL	
+b	int	YES	UNI	NULL	VIRTUAL
+drop table t1;
+create table t1 (a int, b virtual int as (a*2));
+alter table t1 add unique key (b);
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+drop table t1;
+create table t1 (a int, b virtual int as (a*2) stored);
+alter table t1 add unique key (b);
+drop table t1;
+# Testing data manipulation operations involving UNIQUE keys 
+# on virtual columns can be found in:
+#  - vcol_ins_upd.inc
+#  - vcol_select.inc
+# 
+# INDEX
+create table t1 (a int, b virtual int as (a*2), index (b));
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+create table t1 (a int, b virtual int as (a*2), index (a,b));
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+create table t1 (a int, b virtual int as (a*2) stored, index (b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a*2) STORED,
+  KEY `b` (`b`)
+) ENGINE=MyISAM
+describe t1;
+Field	Type	Null	Key	Default	Extra
+a	int	YES		NULL	
+b	int	YES	MUL	NULL	VIRTUAL
+drop table t1;
+create table t1 (a int, b virtual int as (a*2) stored, index (a,b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a*2) STORED,
+  KEY `a` (`a`,`b`)
+) ENGINE=MyISAM
+describe t1;
+Field	Type	Null	Key	Default	Extra
+a	int	YES	MUL	NULL	
+b	int	YES		NULL	VIRTUAL
+drop table t1;
+create table t1 (a int, b virtual int as (a*2));
+alter table t1 add index (b);
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+alter table t1 add index (a,b);
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+drop table t1;
+create table t1 (a int, b virtual int as (a*2) stored);
+alter table t1 add index (b);
+drop table t1;
+create table t1 (a int, b virtual int as (a*2) stored);
+alter table t1 add index (a,b);
+create table t2 like t1;
+drop table t2;
+drop table t1;
+# Testing data manipulation operations involving INDEX
+# on virtual columns can be found in:
+#  - vcol_select.inc
+# FOREIGN KEY
+# Rejected FK options.
+create table t1 (a int, b virtual int as (a+1) stored,
+foreign key (b) references t2(a) on update set null);
+ERROR HY000: Cannot define foreign key with ON UPDATE SET NULL clause on a virtual column.
+create table t1 (a int, b virtual int as (a+1) stored,
+foreign key (b) references t2(a) on update cascade);
+ERROR HY000: Cannot define foreign key with ON UPDATE CASCADE clause on a virtual column.
+create table t1 (a int, b virtual int as (a+1) stored,
+foreign key (b) references t2(a) on delete set null);
+ERROR HY000: Cannot define foreign key with ON DELETE SET NULL clause on a virtual column.
+create table t1 (a int, b virtual int as (a+1) stored);
+alter table t1 add foreign key (b) references t2(a) on update set null;
+ERROR HY000: Cannot define foreign key with ON UPDATE SET NULL clause on a virtual column.
+alter table t1 add foreign key (b) references t2(a) on update cascade;
+ERROR HY000: Cannot define foreign key with ON UPDATE CASCADE clause on a virtual column.
+alter table t1 add foreign key (b) references t2(a) on delete set null;
+ERROR HY000: Cannot define foreign key with ON DELETE SET NULL clause on a virtual column.
+drop table t1;
+create table t1 (a int, b virtual int as (a+1),
+foreign key (b) references t2(a));
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+create table t1 (a int, b virtual int as (a+1));
+alter table t1 add foreign key (b) references t2(a);
+ERROR HY000: Key/Index cannot be defined on a non-stored virtual column.
+drop table t1;
+# Allowed FK options.
+create table t2 (a int primary key, b char(5));
+create table t1 (a int, b virtual int as (a % 10) stored,
+foreign key (b) references t2(a) on update restrict);
+drop table t1;
+create table t1 (a int, b virtual int as (a % 10) stored,
+foreign key (b) references t2(a) on update no action);
+drop table t1;
+create table t1 (a int, b virtual int as (a % 10) stored,
+foreign key (b) references t2(a) on delete restrict);
+drop table t1;
+create table t1 (a int, b virtual int as (a % 10) stored,
+foreign key (b) references t2(a) on delete cascade);
+drop table t1;
+create table t1 (a int, b virtual int as (a % 10) stored,
+foreign key (b) references t2(a) on delete no action);
+drop table t1;
+
+# Testing data manipulation operations involving FOREIGN KEY 
+# on virtual columns can be found in:
+#  - vcol_ins_upd.inc
+#  - vcol_select.inc
+#
+# TODO: CHECK
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;

=== added file 'tests/suite/vcol/r/vcol_memory.result'
--- tests/suite/vcol/r/vcol_memory.result	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/r/vcol_memory.result	2008-09-19 11:49:17 +0000
@@ -0,0 +1,11 @@
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+SET @@session.storage_engine = 'memory';
+create table t1 (a int, b virtual int as (a+1));
+ERROR HY000: 'Specified storage engine' is not yet supported for virtual columns.
+create table t1 (a int);
+alter table t1 add column b virtual int as (a+1);
+ERROR HY000: 'Specified storage engine' is not yet supported for virtual columns.
+drop table t1;
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;

=== added file 'tests/suite/vcol/r/vcol_non_stored_columns_innodb.result'
--- tests/suite/vcol/r/vcol_non_stored_columns_innodb.result	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/r/vcol_non_stored_columns_innodb.result	2008-09-19 11:49:17 +0000
@@ -0,0 +1,246 @@
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+SET @@session.storage_engine = 'InnoDB';
+# Case 1. All non-stored columns.
+# This scenario is currently impossible due to the fact that virtual columns
+# with a constant expression are not allowed.
+# Case 2. CREATE
+#  - Column1: "real"
+#  - Column 2: virtual non-stored
+create table t1 (a int, b virtual int as (-a));
+insert into t1 values (1,default);
+select * from t1;
+a	b
+1	-1
+insert into t1 values (2,default);
+select * from t1;
+a	b
+1	-1
+2	-2
+drop table t1;
+# Case 3. CREATE
+#  - Column1: "real"
+#  - Column 2: virtual stored
+create table t1 (a int, b virtual int as (-a) stored);
+insert into t1 values (1,default);
+select * from t1;
+a	b
+1	-1
+insert into t1 values (2,default);
+select * from t1;
+a	b
+1	-1
+2	-2
+drop table t1;
+# Case 4. CREATE
+#  - Column1: virtual non-stored
+#  - Column2: "real"
+create table t1 (a virtual int as (-b), b int);
+insert into t1 values (default,1);
+select * from t1;
+a	b
+-1	1
+insert into t1 values (default,2);
+select * from t1;
+a	b
+-1	1
+-2	2
+drop table t1;
+# Case 5. CREATE
+#  - Column1: virtual stored
+#  - Column2: "real"
+create table t1 (a virtual int as (-b) stored, b int);
+insert into t1 values (default,1);
+select * from t1;
+a	b
+-1	1
+insert into t1 values (default,2);
+select * from t1;
+a	b
+-1	1
+-2	2
+drop table t1;
+# Case 6. CREATE
+#  - Column1: "real"
+#  - Column2: virtual non-stored
+#  - Column3: virtual stored
+create table t1 (a int, b virtual int as (-a), c virtual int as (-a) stored);
+insert into t1 values (1,default,default);
+select * from t1;
+a	b	c
+1	-1	-1
+insert into t1 values (2,default,default);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+drop table t1;
+# Case 7. ALTER. Modify virtual stored -> virtual non-stored
+create table t1 (a int, b virtual int as (a % 2) stored);
+alter table t1 modify b virtual int as (a % 2);
+ERROR HY000: 'Changing the STORED status' is not yet supported for virtual columns.
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2) STORED
+) ENGINE=InnoDB
+drop table t1;
+# Case 8. ALTER. Modify virtual non-stored -> virtual stored
+create table t1 (a int, b virtual int as (a % 2));
+alter table t1 modify b virtual int as (a % 2) stored;
+ERROR HY000: 'Changing the STORED status' is not yet supported for virtual columns.
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2)
+) ENGINE=InnoDB
+drop table t1;
+# Case 9. CREATE LIKE
+#  - Column1: "real"
+#  - Column2: virtual non-stored
+#  - Column3: virtual stored
+create table t1 (a int, b virtual int as (-a), c virtual int as (-a) stored);
+create table t2 like t1;
+insert into t2 values (1,default,default);
+select * from t2;
+a	b	c
+1	-1	-1
+insert into t2 values (2,default,default);
+select * from t2;
+a	b	c
+1	-1	-1
+2	-2	-2
+drop table t2;
+drop table t1;
+# Case 10. ALTER. Dropping a virtual non-stored column.
+#  - Column1: virtual non-stored
+#  - Column2: "real"
+create table t1 (a virtual int as (-b), b int, c varchar(5));
+insert into t1 values (default,1,'v1');
+insert into t1 values (default,2,'v2');
+select * from t1;
+a	b	c
+-1	1	v1
+-2	2	v2
+alter table t1 drop column a;
+select * from t1;
+b	c
+1	v1
+2	v2
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `b` int,
+  `c` varchar(5)
+) ENGINE=InnoDB
+drop table t1;
+# Case 11. ALTER. Dropping a virtual stored column.
+#  - Column1: virtual stored
+#  - Column2: "real"
+create table t1 (a virtual int as (-b) stored, b int, c char(5));
+insert into t1 values (default,1,'v1');
+insert into t1 values (default,2,'v2');
+select * from t1;
+a	b	c
+-1	1	v1
+-2	2	v2
+alter table t1 drop column a;
+select * from t1;
+b	c
+1	v1
+2	v2
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `b` int,
+  `c` varchar(5)
+) ENGINE=InnoDB
+drop table t1;
+# Case 12. ALTER. Adding a new virtual non-stored column.
+create table t1 (a int, b datetime);
+insert into t1 values (1,'2008-09-04');
+insert into t1 values (2,'2008-09-05');
+select * from t1;
+a	b
+1	2008-09-04 00:00:00
+2	2008-09-05 00:00:00
+alter table t1 add column c virtual int as (dayofyear(b)) after a;
+select * from t1;
+a	c	b
+1	248	2008-09-04 00:00:00
+2	249	2008-09-05 00:00:00
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `c` VIRTUAL int AS (dayofyear(b)),
+  `b` datetime
+) ENGINE=InnoDB
+drop table t1;
+# Case 13. ALTER. Adding a new virtual stored column.
+create table t1 (a int, b datetime);
+insert into t1 values (1,'2008-09-04');
+insert into t1 values (2,'2008-09-05');
+select * from t1;
+a	b
+1	2008-09-04 00:00:00
+2	2008-09-05 00:00:00
+alter table t1 add column c virtual int as (dayofyear(b)) stored after a;
+select * from t1;
+a	c	b
+1	248	2008-09-04 00:00:00
+2	249	2008-09-05 00:00:00
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `c` VIRTUAL int AS (dayofyear(b)) STORED,
+  `b` datetime
+) ENGINE=InnoDB
+drop table t1;
+# Case 14. ALTER. Changing the expression of a virtual stored column.
+create table t1 (a int, b datetime, c virtual int as (week(b)) stored);
+insert into t1 values (1,'2008-09-04',default);
+insert into t1 values (2,'2008-09-05',default);
+select * from t1;
+a	b	c
+1	2008-09-04 00:00:00	35
+2	2008-09-05 00:00:00	35
+alter table t1 change column c c virtual int as (week(b,1)) stored;
+select * from t1;
+a	b	c
+1	2008-09-04 00:00:00	36
+2	2008-09-05 00:00:00	36
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` datetime,
+  `c` VIRTUAL int AS (week(b,1)) STORED
+) ENGINE=InnoDB
+drop table t1;
+# Case 15. ALTER. Changing the expression of a virtual non-stored column.
+create table t1 (a int, b datetime, c virtual int as (week(b)));
+insert into t1 values (1,'2008-09-04',default);
+insert into t1 values (2,'2008-09-05',default);
+select * from t1;
+a	b	c
+1	2008-09-04 00:00:00	35
+2	2008-09-05 00:00:00	35
+alter table t1 change column c c virtual int as (week(b,1));
+select * from t1;
+a	b	c
+1	2008-09-04 00:00:00	36
+2	2008-09-05 00:00:00	36
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` datetime,
+  `c` VIRTUAL int AS (week(b,1))
+) ENGINE=InnoDB
+drop table t1;
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;

=== added file 'tests/suite/vcol/r/vcol_non_stored_columns_myisam.result'
--- tests/suite/vcol/r/vcol_non_stored_columns_myisam.result	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/r/vcol_non_stored_columns_myisam.result	2008-09-19 11:49:17 +0000
@@ -0,0 +1,246 @@
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+SET @@session.storage_engine = 'MyISAM';
+# Case 1. All non-stored columns.
+# This scenario is currently impossible due to the fact that virtual columns
+# with a constant expression are not allowed.
+# Case 2. CREATE
+#  - Column1: "real"
+#  - Column 2: virtual non-stored
+create table t1 (a int, b virtual int as (-a));
+insert into t1 values (1,default);
+select * from t1;
+a	b
+1	-1
+insert into t1 values (2,default);
+select * from t1;
+a	b
+1	-1
+2	-2
+drop table t1;
+# Case 3. CREATE
+#  - Column1: "real"
+#  - Column 2: virtual stored
+create table t1 (a int, b virtual int as (-a) stored);
+insert into t1 values (1,default);
+select * from t1;
+a	b
+1	-1
+insert into t1 values (2,default);
+select * from t1;
+a	b
+1	-1
+2	-2
+drop table t1;
+# Case 4. CREATE
+#  - Column1: virtual non-stored
+#  - Column2: "real"
+create table t1 (a virtual int as (-b), b int);
+insert into t1 values (default,1);
+select * from t1;
+a	b
+-1	1
+insert into t1 values (default,2);
+select * from t1;
+a	b
+-1	1
+-2	2
+drop table t1;
+# Case 5. CREATE
+#  - Column1: virtual stored
+#  - Column2: "real"
+create table t1 (a virtual int as (-b) stored, b int);
+insert into t1 values (default,1);
+select * from t1;
+a	b
+-1	1
+insert into t1 values (default,2);
+select * from t1;
+a	b
+-1	1
+-2	2
+drop table t1;
+# Case 6. CREATE
+#  - Column1: "real"
+#  - Column2: virtual non-stored
+#  - Column3: virtual stored
+create table t1 (a int, b virtual int as (-a), c virtual int as (-a) stored);
+insert into t1 values (1,default,default);
+select * from t1;
+a	b	c
+1	-1	-1
+insert into t1 values (2,default,default);
+select * from t1;
+a	b	c
+1	-1	-1
+2	-2	-2
+drop table t1;
+# Case 7. ALTER. Modify virtual stored -> virtual non-stored
+create table t1 (a int, b virtual int as (a % 2) stored);
+alter table t1 modify b virtual int as (a % 2);
+ERROR HY000: 'Changing the STORED status' is not yet supported for virtual columns.
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2) STORED
+) ENGINE=MyISAM
+drop table t1;
+# Case 8. ALTER. Modify virtual non-stored -> virtual stored
+create table t1 (a int, b virtual int as (a % 2));
+alter table t1 modify b virtual int as (a % 2) stored;
+ERROR HY000: 'Changing the STORED status' is not yet supported for virtual columns.
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a % 2)
+) ENGINE=MyISAM
+drop table t1;
+# Case 9. CREATE LIKE
+#  - Column1: "real"
+#  - Column2: virtual non-stored
+#  - Column3: virtual stored
+create table t1 (a int, b virtual int as (-a), c virtual int as (-a) stored);
+create table t2 like t1;
+insert into t2 values (1,default,default);
+select * from t2;
+a	b	c
+1	-1	-1
+insert into t2 values (2,default,default);
+select * from t2;
+a	b	c
+1	-1	-1
+2	-2	-2
+drop table t2;
+drop table t1;
+# Case 10. ALTER. Dropping a virtual non-stored column.
+#  - Column1: virtual non-stored
+#  - Column2: "real"
+create table t1 (a virtual int as (-b), b int, c varchar(5));
+insert into t1 values (default,1,'v1');
+insert into t1 values (default,2,'v2');
+select * from t1;
+a	b	c
+-1	1	v1
+-2	2	v2
+alter table t1 drop column a;
+select * from t1;
+b	c
+1	v1
+2	v2
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `b` int,
+  `c` varchar(5)
+) ENGINE=MyISAM
+drop table t1;
+# Case 11. ALTER. Dropping a virtual stored column.
+#  - Column1: virtual stored
+#  - Column2: "real"
+create table t1 (a virtual int as (-b) stored, b int, c char(5));
+insert into t1 values (default,1,'v1');
+insert into t1 values (default,2,'v2');
+select * from t1;
+a	b	c
+-1	1	v1
+-2	2	v2
+alter table t1 drop column a;
+select * from t1;
+b	c
+1	v1
+2	v2
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `b` int,
+  `c` varchar(5)
+) ENGINE=MyISAM
+drop table t1;
+# Case 12. ALTER. Adding a new virtual non-stored column.
+create table t1 (a int, b datetime);
+insert into t1 values (1,'2008-09-04');
+insert into t1 values (2,'2008-09-05');
+select * from t1;
+a	b
+1	2008-09-04 00:00:00
+2	2008-09-05 00:00:00
+alter table t1 add column c virtual int as (dayofyear(b)) after a;
+select * from t1;
+a	c	b
+1	248	2008-09-04 00:00:00
+2	249	2008-09-05 00:00:00
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `c` VIRTUAL int AS (dayofyear(b)),
+  `b` datetime
+) ENGINE=MyISAM
+drop table t1;
+# Case 13. ALTER. Adding a new virtual stored column.
+create table t1 (a int, b datetime);
+insert into t1 values (1,'2008-09-04');
+insert into t1 values (2,'2008-09-05');
+select * from t1;
+a	b
+1	2008-09-04 00:00:00
+2	2008-09-05 00:00:00
+alter table t1 add column c virtual int as (dayofyear(b)) stored after a;
+select * from t1;
+a	c	b
+1	248	2008-09-04 00:00:00
+2	249	2008-09-05 00:00:00
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `c` VIRTUAL int AS (dayofyear(b)) STORED,
+  `b` datetime
+) ENGINE=MyISAM
+drop table t1;
+# Case 14. ALTER. Changing the expression of a virtual stored column.
+create table t1 (a int, b datetime, c virtual int as (week(b)) stored);
+insert into t1 values (1,'2008-09-04',default);
+insert into t1 values (2,'2008-09-05',default);
+select * from t1;
+a	b	c
+1	2008-09-04 00:00:00	35
+2	2008-09-05 00:00:00	35
+alter table t1 change column c c virtual int as (week(b,1)) stored;
+select * from t1;
+a	b	c
+1	2008-09-04 00:00:00	36
+2	2008-09-05 00:00:00	36
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` datetime,
+  `c` VIRTUAL int AS (week(b,1)) STORED
+) ENGINE=MyISAM
+drop table t1;
+# Case 15. ALTER. Changing the expression of a virtual non-stored column.
+create table t1 (a int, b datetime, c virtual int as (week(b)));
+insert into t1 values (1,'2008-09-04',default);
+insert into t1 values (2,'2008-09-05',default);
+select * from t1;
+a	b	c
+1	2008-09-04 00:00:00	35
+2	2008-09-05 00:00:00	35
+alter table t1 change column c c virtual int as (week(b,1));
+select * from t1;
+a	b	c
+1	2008-09-04 00:00:00	36
+2	2008-09-05 00:00:00	36
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` datetime,
+  `c` VIRTUAL int AS (week(b,1))
+) ENGINE=MyISAM
+drop table t1;
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;

=== added file 'tests/suite/vcol/r/vcol_select_innodb.result'
--- tests/suite/vcol/r/vcol_select_innodb.result	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/r/vcol_select_innodb.result	2008-09-19 11:49:17 +0000
@@ -0,0 +1,268 @@
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+SET @@session.storage_engine = 'InnoDB';
+create table t1 (a int,
+b virtual int as (-a),
+c virtual int as (-a) stored,
+index (c));
+insert into t1 (a) values (2), (1), (1), (3), (NULL);
+create table t2 like t1;
+insert into t2 (a) values (1);
+create table t3 (a int primary key, 
+b virtual int as (-a),
+c virtual int as (-a) stored unique);
+insert into t3 (a) values (2),(1),(3);
+# select_type=SIMPLE, type=system
+select * from t2;
+a	b	c
+1	-1	-1
+explain select * from t2;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t2	ALL	NULL	NULL	NULL	NULL	1	
+select * from t2 where c=-1;
+a	b	c
+1	-1	-1
+explain select * from t2 where c=-1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t2	ref	c	c	5	const	1	
+# select_type=SIMPLE, type=ALL
+select * from t1 where b=-1;
+a	b	c
+1	-1	-1
+1	-1	-1
+explain select * from t1 where b=-1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	ALL	NULL	NULL	NULL	NULL	5	Using where
+# select_type=SIMPLE, type=const
+select * from t3 where a=1;
+a	b	c
+1	-1	-1
+explain select * from t3 where a=1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	const	PRIMARY	PRIMARY	4	const	1	
+# select_type=SIMPLE, type=range
+select * from t3 where c>=-1;
+a	b	c
+1	-1	-1
+explain select * from t3 where c>=-1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	c	c	5	NULL	1	Using index condition; Using MRR
+# select_type=SIMPLE, type=ref
+select * from t1,t3 where t1.c=t3.c and t3.c=-1;
+a	b	c	a	b	c
+1	-1	-1	1	-1	-1
+1	-1	-1	1	-1	-1
+explain select * from t1,t3 where t1.c=t3.c and t3.c=-1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	const	c	c	5	const	1	
+1	SIMPLE	t1	ref	c	c	5	const	2	
+# select_type=PRIMARY, type=index,ALL
+select * from t1 where b in (select c from t3);
+a	b	c
+2	-2	-2
+1	-1	-1
+1	-1	-1
+3	-3	-3
+explain select * from t1 where b in (select c from t3);
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	PRIMARY	t3	index	c	PRIMARY	4	NULL	3	
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	5	Using where; Using join buffer
+# select_type=PRIMARY, type=range,ref
+select * from t1 where c in (select c from t3 where c between -2 and -1);
+a	b	c
+1	-1	-1
+1	-1	-1
+2	-2	-2
+explain select * from t1 where c in (select c from t3 where c between -2 and -1);
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	PRIMARY	t3	index	c	PRIMARY	4	NULL	3	Using where
+1	PRIMARY	t1	ref	c	c	5	test.t3.c	1	
+# select_type=UNION, type=system
+# select_type=UNION RESULT, type=<union1,2>
+select * from t1 union select * from t2;
+a	b	c
+2	-2	-2
+1	-1	-1
+3	-3	-3
+NULL	NULL	NULL
+explain select * from t1 union select * from t2;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	5	
+2	UNION	t2	ALL	NULL	NULL	NULL	NULL	1	
+NULL	UNION RESULT	<union1,2>	ALL	NULL	NULL	NULL	NULL	NULL	
+# select_type=DERIVED, type=system
+select * from (select a,b,c from t1) as t11;
+a	b	c
+2	-2	-2
+1	-1	-1
+1	-1	-1
+3	-3	-3
+NULL	NULL	NULL
+explain select * from (select a,b,c from t1) as t11;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	PRIMARY	<derived2>	ALL	NULL	NULL	NULL	NULL	5	
+2	DERIVED	t1	ALL	NULL	NULL	NULL	NULL	5	
+###
+### Using aggregate functions with/without DISTINCT
+###
+# SELECT COUNT(*) FROM tbl_name
+select count(*) from t1;
+count(*)
+5
+explain select count(*) from t1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	index	NULL	c	5	NULL	5	Using index
+# SELECT COUNT(DISTINCT <non-vcol>) FROM tbl_name
+select count(distinct a) from t1;
+count(distinct a)
+3
+explain select count(distinct a) from t1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	ALL	NULL	NULL	NULL	NULL	5	
+# SELECT COUNT(DISTINCT <non-stored vcol>) FROM tbl_name
+select count(distinct b) from t1;
+count(distinct b)
+3
+explain select count(distinct b) from t1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	ALL	NULL	NULL	NULL	NULL	5	
+# SELECT COUNT(DISTINCT <stored vcol>) FROM tbl_name
+select count(distinct c) from t1;
+count(distinct c)
+3
+explain select count(distinct c) from t1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	index	NULL	c	5	NULL	5	Using index
+###
+### filesort & range-based utils
+###
+# SELECT * FROM tbl_name WHERE <vcol expr>
+select * from t3 where c >= -2;
+a	b	c
+1	-1	-1
+2	-2	-2
+explain select * from t3 where c >= -2;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	c	c	5	NULL	1	Using index condition; Using MRR
+# SELECT * FROM tbl_name WHERE <non-vcol expr>
+select * from t3 where a between 1 and 2;
+a	b	c
+1	-1	-1
+2	-2	-2
+explain select * from t3 where a between 1 and 2;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	PRIMARY	PRIMARY	4	NULL	1	Using where
+# SELECT * FROM tbl_name WHERE <non-indexed vcol expr>
+select * from t3 where b between -2 and -1;
+a	b	c
+1	-1	-1
+2	-2	-2
+explain select * from t3 where b between -2 and -1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	ALL	NULL	NULL	NULL	NULL	3	Using where
+# SELECT * FROM tbl_name WHERE <indexed vcol expr>
+select * from t3 where c between -2 and -1;
+a	b	c
+1	-1	-1
+2	-2	-2
+explain select * from t3 where c between -2 and -1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	c	c	5	NULL	1	Using index condition; Using MRR
+# SELECT * FROM tbl_name WHERE <non-vcol expr> ORDER BY <non-indexed vcol>
+select * from t3 where a between 1 and 2 order by b;
+a	b	c
+2	-2	-2
+1	-1	-1
+explain select * from t3 where a between 1 and 2 order by b;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	PRIMARY	PRIMARY	4	NULL	1	Using where; Using filesort
+# SELECT * FROM tbl_name WHERE <non-vcol expr> ORDER BY <indexed vcol>
+select * from t3 where a between 1 and 2 order by c;
+a	b	c
+2	-2	-2
+1	-1	-1
+explain select * from t3 where a between 1 and 2 order by c;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	PRIMARY	PRIMARY	4	NULL	1	Using where; Using filesort
+# SELECT * FROM tbl_name WHERE <non-indexed vcol expr> ORDER BY <non-vcol>
+select * from t3 where b between -2 and -1 order by a;
+a	b	c
+1	-1	-1
+2	-2	-2
+explain select * from t3 where b between -2 and -1 order by a;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	index	NULL	PRIMARY	4	NULL	3	Using where
+# SELECT * FROM tbl_name WHERE <non-indexed vcol expr> ORDER BY <non-indexed vcol>
+select * from t3 where b between -2 and -1 order by b;
+a	b	c
+2	-2	-2
+1	-1	-1
+explain select * from t3 where b between -2 and -1 order by b;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	ALL	NULL	NULL	NULL	NULL	3	Using where; Using filesort
+# SELECT * FROM tbl_name WHERE <indexed vcol expr> ORDER BY <non-indexed vcol>
+select * from t3 where c between -2 and -1 order by b;
+a	b	c
+2	-2	-2
+1	-1	-1
+explain select * from t3 where c between -2 and -1 order by b;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	c	c	5	NULL	1	Using index condition; Using MRR; Using filesort
+# SELECT * FROM tbl_name WHERE <non-indexed vcol expr> ORDER BY <indexed vcol>
+select * from t3 where b between -2 and -1 order by c;
+a	b	c
+2	-2	-2
+1	-1	-1
+explain select * from t3 where b between -2 and -1 order by c;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	ALL	NULL	NULL	NULL	NULL	3	Using where; Using filesort
+# SELECT * FROM tbl_name WHERE <indexed vcol expr> ORDER BY <indexed vcol>
+select * from t3 where c between -2 and -1 order by c;
+a	b	c
+2	-2	-2
+1	-1	-1
+explain select * from t3 where c between -2 and -1 order by c;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	c	c	5	NULL	1	Using index condition; Using MRR
+# SELECT sum(<non-indexed vcol>) FROM tbl_name GROUP BY <non-indexed vcol>
+select sum(b) from t1 group by b;
+sum(b)
+NULL
+-3
+-2
+-2
+explain select sum(b) from t1 group by b;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	ALL	NULL	NULL	NULL	NULL	5	Using temporary; Using filesort
+# SELECT sum(<indexed vcol>) FROM tbl_name GROUP BY <indexed vcol>
+select sum(c) from t1 group by c;
+sum(c)
+NULL
+-3
+-2
+-2
+explain select sum(c) from t1 group by c;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	index	NULL	c	5	NULL	5	Using index
+# SELECT sum(<non-indexed vcol>) FROM tbl_name GROUP BY <indexed vcol>
+select sum(b) from t1 group by c;
+sum(b)
+NULL
+-3
+-2
+-2
+explain select sum(b) from t1 group by c;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	index	NULL	c	5	NULL	5	
+# SELECT sum(<indexed vcol>) FROM tbl_name GROUP BY <non-indexed vcol>
+select sum(c) from t1 group by b;
+sum(c)
+NULL
+-3
+-2
+-2
+explain select sum(c) from t1 group by b;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	ALL	NULL	NULL	NULL	NULL	5	Using temporary; Using filesort
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;

=== added file 'tests/suite/vcol/r/vcol_select_myisam.result'
--- tests/suite/vcol/r/vcol_select_myisam.result	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/r/vcol_select_myisam.result	2008-09-19 11:49:17 +0000
@@ -0,0 +1,269 @@
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+SET @@session.storage_engine = 'MyISAM';
+create table t1 (a int,
+b virtual int as (-a),
+c virtual int as (-a) stored,
+index (c));
+insert into t1 (a) values (2), (1), (1), (3), (NULL);
+create table t2 like t1;
+insert into t2 (a) values (1);
+create table t3 (a int primary key, 
+b virtual int as (-a),
+c virtual int as (-a) stored unique);
+insert into t3 (a) values (2),(1),(3);
+# select_type=SIMPLE, type=system
+select * from t2;
+a	b	c
+1	-1	-1
+explain select * from t2;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t2	system	NULL	NULL	NULL	NULL	1	
+select * from t2 where c=-1;
+a	b	c
+1	-1	-1
+explain select * from t2 where c=-1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t2	system	c	NULL	NULL	NULL	1	
+# select_type=SIMPLE, type=ALL
+select * from t1 where b=-1;
+a	b	c
+1	-1	-1
+1	-1	-1
+explain select * from t1 where b=-1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	ALL	NULL	NULL	NULL	NULL	5	Using where
+# select_type=SIMPLE, type=const
+select * from t3 where a=1;
+a	b	c
+1	-1	-1
+explain select * from t3 where a=1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	const	PRIMARY	PRIMARY	4	const	1	
+# select_type=SIMPLE, type=range
+select * from t3 where c>=-1;
+a	b	c
+1	-1	-1
+explain select * from t3 where c>=-1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	c	c	5	NULL	2	Using index condition; Using MRR
+# select_type=SIMPLE, type=ref
+select * from t1,t3 where t1.c=t3.c and t3.c=-1;
+a	b	c	a	b	c
+1	-1	-1	1	-1	-1
+1	-1	-1	1	-1	-1
+explain select * from t1,t3 where t1.c=t3.c and t3.c=-1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	const	c	c	5	const	1	
+1	SIMPLE	t1	ref	c	c	5	const	2	
+# select_type=PRIMARY, type=index,ALL
+select * from t1 where b in (select c from t3);
+a	b	c
+2	-2	-2
+1	-1	-1
+1	-1	-1
+3	-3	-3
+explain select * from t1 where b in (select c from t3);
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	PRIMARY	t3	index	c	c	5	NULL	3	Using index
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	5	Using where; Using join buffer
+# select_type=PRIMARY, type=range,ref
+select * from t1 where c in (select c from t3 where c between -2 and -1);
+a	b	c
+2	-2	-2
+1	-1	-1
+1	-1	-1
+explain select * from t1 where c in (select c from t3 where c between -2 and -1);
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	PRIMARY	t1	range	c	c	5	NULL	2	Using index condition; Using MRR
+1	PRIMARY	t3	ref	c	c	5	test.t1.c	2	Using index
+# select_type=UNION, type=system
+# select_type=UNION RESULT, type=<union1,2>
+select * from t1 union select * from t2;
+a	b	c
+2	-2	-2
+1	-1	-1
+3	-3	-3
+NULL	NULL	NULL
+explain select * from t1 union select * from t2;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	5	
+2	UNION	t2	system	NULL	NULL	NULL	NULL	1	
+NULL	UNION RESULT	<union1,2>	ALL	NULL	NULL	NULL	NULL	NULL	
+# select_type=DERIVED, type=system
+select * from (select a,b,c from t1) as t11;
+a	b	c
+2	-2	-2
+1	-1	-1
+1	-1	-1
+3	-3	-3
+NULL	NULL	NULL
+explain select * from (select a,b,c from t1) as t11;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	PRIMARY	<derived2>	ALL	NULL	NULL	NULL	NULL	5	
+2	DERIVED	t1	ALL	NULL	NULL	NULL	NULL	5	
+###
+### Using aggregate functions with/without DISTINCT
+###
+# SELECT COUNT(*) FROM tbl_name
+select count(*) from t1;
+count(*)
+5
+explain select count(*) from t1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	NULL	NULL	NULL	NULL	NULL	NULL	NULL	Select tables optimized away
+# SELECT COUNT(DISTINCT <non-vcol>) FROM tbl_name
+select count(distinct a) from t1;
+count(distinct a)
+3
+explain select count(distinct a) from t1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	ALL	NULL	NULL	NULL	NULL	5	
+# SELECT COUNT(DISTINCT <non-stored vcol>) FROM tbl_name
+select count(distinct b) from t1;
+count(distinct b)
+3
+explain select count(distinct b) from t1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	ALL	NULL	NULL	NULL	NULL	5	
+# SELECT COUNT(DISTINCT <stored vcol>) FROM tbl_name
+select count(distinct c) from t1;
+count(distinct c)
+3
+explain select count(distinct c) from t1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	index	NULL	c	5	NULL	5	Using index
+###
+### filesort & range-based utils
+###
+# SELECT * FROM tbl_name WHERE <vcol expr>
+select * from t3 where c >= -2;
+a	b	c
+2	-2	-2
+1	-1	-1
+explain select * from t3 where c >= -2;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	c	c	5	NULL	2	Using index condition; Using MRR
+# SELECT * FROM tbl_name WHERE <non-vcol expr>
+select * from t3 where a between 1 and 2;
+a	b	c
+2	-2	-2
+1	-1	-1
+3	-3	-3
+explain select * from t3 where a between 1 and 2;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	PRIMARY	PRIMARY	4	NULL	1	Using index condition; Using MRR
+# SELECT * FROM tbl_name WHERE <non-indexed vcol expr>
+select * from t3 where b between -2 and -1;
+a	b	c
+2	-2	-2
+1	-1	-1
+explain select * from t3 where b between -2 and -1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	ALL	NULL	NULL	NULL	NULL	3	Using where
+# SELECT * FROM tbl_name WHERE <indexed vcol expr>
+select * from t3 where c between -2 and -1;
+a	b	c
+2	-2	-2
+1	-1	-1
+explain select * from t3 where c between -2 and -1;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	c	c	5	NULL	1	Using index condition; Using MRR
+# SELECT * FROM tbl_name WHERE <non-vcol expr> ORDER BY <indexed vcol>
+select * from t3 where a between 1 and 2 order by c;
+a	b	c
+2	-2	-2
+1	-1	-1
+explain select * from t3 where a between 1 and 2 order by c;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	PRIMARY	PRIMARY	4	NULL	1	Using index condition; Using where; Using MRR; Using filesort
+# SELECT * FROM tbl_name WHERE <non-indexed vcol expr> ORDER BY <non-vcol>
+select * from t3 where b between -2 and -1 order by a;
+a	b	c
+1	-1	-1
+2	-2	-2
+explain select * from t3 where b between -2 and -1 order by a;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	ALL	NULL	NULL	NULL	NULL	3	Using where; Using filesort
+# SELECT * FROM tbl_name WHERE <indexed vcol expr> ORDER BY <non-vcol>
+select * from t3 where c between -2 and -1 order by a;
+a	b	c
+1	-1	-1
+2	-2	-2
+explain select * from t3 where c between -2 and -1 order by a;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	c	c	5	NULL	1	Using index condition; Using where; Using MRR; Using filesort
+# SELECT * FROM tbl_name WHERE <non-indexed vcol expr> ORDER BY <non-indexed vcol>
+select * from t3 where b between -2 and -1 order by b;
+a	b	c
+2	-2	-2
+1	-1	-1
+explain select * from t3 where b between -2 and -1 order by b;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	ALL	NULL	NULL	NULL	NULL	3	Using where; Using filesort
+# SELECT * FROM tbl_name WHERE <indexed vcol expr> ORDER BY <non-indexed vcol>
+select * from t3 where c between -2 and -1 order by b;
+a	b	c
+2	-2	-2
+1	-1	-1
+explain select * from t3 where c between -2 and -1 order by b;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	c	c	5	NULL	1	Using index condition; Using MRR; Using filesort
+# SELECT * FROM tbl_name WHERE <non-indexed vcol expr> ORDER BY <indexed vcol>
+select * from t3 where b between -2 and -1 order by c;
+a	b	c
+2	-2	-2
+1	-1	-1
+explain select * from t3 where b between -2 and -1 order by c;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	ALL	NULL	NULL	NULL	NULL	3	Using where; Using filesort
+# SELECT * FROM tbl_name WHERE <indexed vcol expr> ORDER BY <indexed vcol>
+select * from t3 where c between -2 and -1 order by c;
+a	b	c
+2	-2	-2
+1	-1	-1
+explain select * from t3 where c between -2 and -1 order by c;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t3	range	c	c	5	NULL	1	Using index condition; Using MRR
+# SELECT sum(<non-indexed vcol>) FROM tbl_name GROUP BY <non-indexed vcol>
+select sum(b) from t1 group by b;
+sum(b)
+NULL
+-3
+-2
+-2
+explain select sum(b) from t1 group by b;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	ALL	NULL	NULL	NULL	NULL	5	Using temporary; Using filesort
+# SELECT sum(<indexed vcol>) FROM tbl_name GROUP BY <indexed vcol>
+select sum(c) from t1 group by c;
+sum(c)
+NULL
+-3
+-2
+-2
+explain select sum(c) from t1 group by c;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	index	NULL	c	5	NULL	5	Using index
+# SELECT sum(<non-indexed vcol>) FROM tbl_name GROUP BY <indexed vcol>
+select sum(b) from t1 group by c;
+sum(b)
+NULL
+-3
+-2
+-2
+explain select sum(b) from t1 group by c;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	ALL	NULL	NULL	NULL	NULL	5	Using temporary; Using filesort
+# SELECT sum(<indexed vcol>) FROM tbl_name GROUP BY <non-indexed vcol>
+select sum(c) from t1 group by b;
+sum(c)
+NULL
+-3
+-2
+-2
+explain select sum(c) from t1 group by b;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t1	ALL	NULL	NULL	NULL	NULL	5	Using temporary; Using filesort
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;

=== added file 'tests/suite/vcol/r/vcol_supported_sql_funcs_innodb.result'
--- tests/suite/vcol/r/vcol_supported_sql_funcs_innodb.result	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/r/vcol_supported_sql_funcs_innodb.result	2008-09-19 11:49:17 +0000
@@ -0,0 +1,2583 @@
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+SET @@session.storage_engine = 'InnoDB';
+#
+# NUMERIC FUNCTIONS
+#
+# ABS()
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (abs(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (abs(a))
+) ENGINE=InnoDB
+insert into t1 values (-1, default);
+select * from t1;
+a	b
+-1	1
+drop table t1;
+set sql_warnings = 0;
+# ACOS()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (acos(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (acos(a))
+) ENGINE=InnoDB
+insert into t1 values (1, default);
+insert into t1 values (1.0001,default);
+insert into t1 values (0,default);
+select * from t1;
+a	b
+1	0
+1.0001	NULL
+0	1.5707963267948966
+drop table t1;
+set sql_warnings = 0;
+# ASIN()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (asin(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (asin(a))
+) ENGINE=InnoDB
+insert into t1 values (0.2, default);
+insert into t1 values (1.0001,default);
+select * from t1;
+a	b
+0.2	0.20135792079033082
+1.0001	NULL
+drop table t1;
+set sql_warnings = 0;
+#ATAN
+set sql_warnings = 1;
+create table t1 (a double, b double, c virtual double as (atan(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` double,
+  `c` VIRTUAL double AS (atan(a,b))
+) ENGINE=InnoDB
+insert into t1 values (-2,2,default);
+insert into t1 values (PI(),0,default);
+select * from t1;
+a	b	c
+-2	2	-0.7853981633974483
+3.141592653589793	0	1.5707963267948966
+drop table t1;
+set sql_warnings = 0;
+set sql_warnings = 1;
+create table t1 (a double, c virtual double as (atan(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `c` VIRTUAL double AS (atan(a))
+) ENGINE=InnoDB
+insert into t1 values (-2,default);
+insert into t1 values (PI(),default);
+select * from t1;
+a	c
+-2	-1.1071487177940904
+3.141592653589793	1.2626272556789118
+drop table t1;
+set sql_warnings = 0;
+# ATAN2
+set sql_warnings = 1;
+create table t1 (a double, b double, c virtual double as (atan2(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` double,
+  `c` VIRTUAL double AS (atan2(a,b))
+) ENGINE=InnoDB
+insert into t1 values (-2,2,default);
+insert into t1 values (PI(),0,default);
+select * from t1;
+a	b	c
+-2	2	-0.7853981633974483
+3.141592653589793	0	1.5707963267948966
+drop table t1;
+set sql_warnings = 0;
+# CEIL()
+set sql_warnings = 1;
+create table t1 (a double, b virtual int as (ceil(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL int AS (ceil(a))
+) ENGINE=InnoDB
+insert into t1 values (1.23,default);
+insert into t1 values (-1.23,default);
+select * from t1;
+a	b
+1.23	2
+-1.23	-1
+drop table t1;
+set sql_warnings = 0;
+# CONV()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b int, c int, d virtual varchar(10) as (conv(a,b,c)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` int,
+  `c` int,
+  `d` VIRTUAL varchar(10) AS (conv(a,b,c))
+) ENGINE=InnoDB
+insert into t1 values ('a',16,2,default);
+insert into t1 values ('6e',18,8,default);
+insert into t1 values (-17,10,-18,default);
+insert into t1 values (10+'10'+'10'+0xa,10,10,default);
+select * from t1;
+a	b	c	d
+a	16	2	1010
+6e	18	8	172
+-17	10	-18	-H
+40	10	10	40
+drop table t1;
+set sql_warnings = 0;
+# COS()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (cos(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (cos(a))
+) ENGINE=InnoDB
+insert into t1 values (PI(),default);
+select * from t1;
+a	b
+3.141592653589793	-1
+drop table t1;
+set sql_warnings = 0;
+# COT()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (cot(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (cot(a))
+) ENGINE=InnoDB
+insert into t1 values (12,default);
+insert into t1 values (0,default);
+Warnings:
+Error	1365	Division by 0
+select * from t1;
+a	b
+12	-1.5726734063976893
+0	NULL
+Warnings:
+Error	1365	Division by 0
+drop table t1;
+set sql_warnings = 0;
+# DEGREES()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (degrees(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (degrees(a))
+) ENGINE=InnoDB
+insert into t1 values (PI(),default);
+insert into t1 values (PI()/2,default);
+select * from t1;
+a	b
+3.141592653589793	180
+1.5707963267948966	90
+drop table t1;
+set sql_warnings = 0;
+# /
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (a/2));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (a/2)
+) ENGINE=InnoDB
+insert into t1 values (2,default);
+select * from t1;
+a	b
+2	1
+drop table t1;
+set sql_warnings = 0;
+# EXP()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (exp(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (exp(a))
+) ENGINE=InnoDB
+insert into t1 values (2,default);
+insert into t1 values (-2,default);
+insert into t1 values (0,default);
+select * from t1;
+a	b
+2	7.38905609893065
+-2	0.1353352832366127
+0	1
+drop table t1;
+set sql_warnings = 0;
+# FLOOR()
+set sql_warnings = 1;
+create table t1 (a double, b virtual int as (floor(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL int AS (floor(a))
+) ENGINE=InnoDB
+insert into t1 values (1.23,default);
+insert into t1 values (-1.23,default);
+select * from t1;
+a	b
+1.23	1
+-1.23	-2
+drop table t1;
+set sql_warnings = 0;
+# LN()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (ln(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (ln(a))
+) ENGINE=InnoDB
+insert into t1 values (2,default);
+insert into t1 values (-2,default);
+Warnings:
+Error	1365	Division by 0
+select * from t1;
+a	b
+2	0.6931471805599453
+-2	NULL
+Warnings:
+Error	1365	Division by 0
+drop table t1;
+set sql_warnings = 0;
+# LOG()
+set sql_warnings = 1;
+create table t1 (a double, b double, c virtual double as (log(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` double,
+  `c` VIRTUAL double AS (log(a,b))
+) ENGINE=InnoDB
+insert into t1 values (2,65536,default);
+insert into t1 values (10,100,default);
+insert into t1 values (1,100,default);
+Warnings:
+Error	1365	Division by 0
+select * from t1;
+a	b	c
+2	65536	16
+10	100	2
+1	100	NULL
+Warnings:
+Error	1365	Division by 0
+drop table t1;
+set sql_warnings = 0;
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (log(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (log(a))
+) ENGINE=InnoDB
+insert into t1 values (2,default);
+insert into t1 values (-2,default);
+Warnings:
+Error	1365	Division by 0
+select * from t1;
+a	b
+2	0.6931471805599453
+-2	NULL
+Warnings:
+Error	1365	Division by 0
+drop table t1;
+set sql_warnings = 0;
+# LOG2()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (log2(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (log2(a))
+) ENGINE=InnoDB
+insert into t1 values (65536,default);
+insert into t1 values (-100,default);
+Warnings:
+Error	1365	Division by 0
+select * from t1;
+a	b
+65536	16
+-100	NULL
+Warnings:
+Error	1365	Division by 0
+drop table t1;
+set sql_warnings = 0;
+# LOG10()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (log10(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (log10(a))
+) ENGINE=InnoDB
+insert into t1 values (2,default);
+insert into t1 values (100,default);
+insert into t1 values (-100,default);
+Warnings:
+Error	1365	Division by 0
+select * from t1;
+a	b
+2	0.3010299956639812
+100	2
+-100	NULL
+Warnings:
+Error	1365	Division by 0
+drop table t1;
+set sql_warnings = 0;
+# -
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (a-1));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (a-1)
+) ENGINE=InnoDB
+insert into t1 values (2,default);
+select * from t1;
+a	b
+2	1
+drop table t1;
+set sql_warnings = 0;
+# MOD()
+set sql_warnings = 1;
+create table t1 (a double, b virtual int as (mod(a,10)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL int AS (mod(a,10))
+) ENGINE=InnoDB
+insert into t1 values (1,default);
+insert into t1 values (11,default);
+select * from t1;
+a	b
+1	1
+11	1
+drop table t1;
+set sql_warnings = 0;
+# %
+set sql_warnings = 1;
+create table t1 (a double, b virtual int as (a % 10));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL int AS (a % 10)
+) ENGINE=InnoDB
+insert into t1 values (1,default);
+insert into t1 values (11,default);
+select * from t1;
+a	b
+1	1
+11	1
+drop table t1;
+set sql_warnings = 0;
+# OCT()
+set sql_warnings = 1;
+create table t1 (a double, b virtual varchar(10) as (oct(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL varchar(10) AS (oct(a))
+) ENGINE=InnoDB
+insert into t1 values (12,default);
+select * from t1;
+a	b
+12	14
+drop table t1;
+set sql_warnings = 0;
+# PI()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (PI()*a*a));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (PI()*a*a)
+) ENGINE=InnoDB
+insert into t1 values (1,default);
+select * from t1;
+a	b
+1	3.141592653589793
+drop table t1;
+set sql_warnings = 0;
+# +
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (a+1));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a+1)
+) ENGINE=InnoDB
+insert into t1 values (1,default);
+select * from t1;
+a	b
+1	2
+drop table t1;
+set sql_warnings = 0;
+# POW, POWER
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (pow(a,2)), c virtual int as (power(a,2)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (pow(a,2)),
+  `c` VIRTUAL int AS (power(a,2))
+) ENGINE=InnoDB
+insert into t1 values (1,default,default);
+insert into t1 values (2,default,default);
+select * from t1;
+a	b	c
+1	1	1
+2	4	4
+drop table t1;
+set sql_warnings = 0;
+# RADIANS()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (radians(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (radians(a))
+) ENGINE=InnoDB
+insert into t1 values (90,default);
+select * from t1;
+a	b
+90	1.5707963267948966
+drop table t1;
+set sql_warnings = 0;
+# ROUND()
+set sql_warnings = 1;
+create table t1 (a double, b virtual int as (round(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL int AS (round(a))
+) ENGINE=InnoDB
+insert into t1 values (-1.23,default);
+insert into t1 values (-1.58,default);
+insert into t1 values (1.58,default);
+select * from t1;
+a	b
+-1.23	-1
+-1.58	-2
+1.58	2
+drop table t1;
+set sql_warnings = 0;
+set sql_warnings = 1;
+create table t1 (a double, b double, c virtual int as (round(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` double,
+  `c` VIRTUAL int AS (round(a,b))
+) ENGINE=InnoDB
+insert into t1 values (1.298,1,default);
+insert into t1 values (1.298,0,default);
+insert into t1 values (23.298,-1,default);
+select * from t1;
+a	b	c
+1.298	1	1
+1.298	0	1
+23.298	-1	20
+drop table t1;
+set sql_warnings = 0;
+# SIGN()
+set sql_warnings = 1;
+create table t1 (a double, b virtual int as (sign(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL int AS (sign(a))
+) ENGINE=InnoDB
+insert into t1 values (-32,default);
+insert into t1 values (0,default);
+insert into t1 values (234,default);
+select * from t1;
+a	b
+-32	-1
+0	0
+234	1
+drop table t1;
+set sql_warnings = 0;
+# SIN()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (sin(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (sin(a))
+) ENGINE=InnoDB
+insert into t1 values (PI(),default);
+Warnings:
+Warning	1292	Incorrect datetime value: '3.141592653589793'
+select * from t1;
+a	b
+3.141592653589793	NULL
+Warnings:
+Warning	1292	Incorrect datetime value: '3.141592653589793'
+drop table t1;
+set sql_warnings = 0;
+# SQRT()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (sqrt(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (sqrt(a))
+) ENGINE=InnoDB
+insert into t1 values (4,default);
+insert into t1 values (20,default);
+insert into t1 values (-16,default);
+select * from t1;
+a	b
+4	2
+20	4.47213595499958
+-16	NULL
+drop table t1;
+set sql_warnings = 0;
+# TAN()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (tan(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (tan(a))
+) ENGINE=InnoDB
+insert into t1 values (PI(),default);
+insert into t1 values (PI()+1,default);
+select * from t1;
+a	b
+3.141592653589793	-1.2246063538223773e-16
+4.141592653589793	1.5574077246549018
+drop table t1;
+set sql_warnings = 0;
+# *
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (a*3));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (a*3)
+) ENGINE=InnoDB
+insert into t1 values (0,default);
+insert into t1 values (1,default);
+insert into t1 values (2,default);
+select * from t1;
+a	b
+0	0
+1	3
+2	6
+drop table t1;
+set sql_warnings = 0;
+# TRUNCATE()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (truncate(a,4)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (truncate(a,4))
+) ENGINE=InnoDB
+insert into t1 values (1.223,default);
+insert into t1 values (1.999,default);
+insert into t1 values (1.999,default);
+insert into t1 values (122,default);
+select * from t1;
+a	b
+1.223	1.223
+1.999	1.999
+1.999	1.999
+122	122
+drop table t1;
+set sql_warnings = 0;
+# Unary -
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (-a));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (-a)
+) ENGINE=InnoDB
+insert into t1 values (1,default);
+insert into t1 values (-1,default);
+select * from t1;
+a	b
+1	-1
+-1	1
+drop table t1;
+set sql_warnings = 0;
+#
+# STRING FUNCTIONS
+#
+# ASCII()
+set sql_warnings = 1;
+create table t1 (a char(2), b virtual int as (ascii(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(2),
+  `b` VIRTUAL int AS (ascii(a))
+) ENGINE=InnoDB
+insert into t1 values ('2',default);
+insert into t1 values (2,default);
+insert into t1 values ('dx',default);
+select * from t1;
+a	b
+2	50
+2	50
+dx	100
+drop table t1;
+set sql_warnings = 0;
+# BIN()
+set sql_warnings = 1;
+create table t1 (a int, b virtual varchar(10) as (bin(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL varchar(10) AS (bin(a))
+) ENGINE=InnoDB
+insert into t1 values (12,default);
+select * from t1;
+a	b
+12	1100
+drop table t1;
+set sql_warnings = 0;
+# BIT_LENGTH()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual int as (bit_length(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL int AS (bit_length(a))
+) ENGINE=InnoDB
+insert into t1 values ('text',default);
+select * from t1;
+a	b
+text	32
+drop table t1;
+set sql_warnings = 0;
+# CHAR_LENGTH()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual int as (char_length(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL int AS (char_length(a))
+) ENGINE=InnoDB
+insert into t1 values ('text',default);
+select * from t1;
+a	b
+text	4
+drop table t1;
+set sql_warnings = 0;
+# CHAR()
+set sql_warnings = 1;
+create table t1 (a int, b int, c virtual varbinary(10) as (char(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` int,
+  `c` VIRTUAL varbinary(10) AS (char(a,b))
+) ENGINE=InnoDB
+insert into t1 values (77,121,default);
+select * from t1;
+a	b	c
+77	121	My
+drop table t1;
+set sql_warnings = 0;
+# CHARACTER_LENGTH()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual int as (character_length(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL int AS (character_length(a))
+) ENGINE=InnoDB
+insert into t1 values ('text',default);
+select * from t1;
+a	b
+text	4
+drop table t1;
+set sql_warnings = 0;
+# CONCAT_WS()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual varchar(20) as (concat_ws(',',a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL varchar(20) AS (concat_ws(',',a,b))
+) ENGINE=InnoDB
+insert into t1 values ('value1','value2',default);
+select * from t1;
+a	b	c
+value1	value2	value1,value2
+drop table t1;
+set sql_warnings = 0;
+# CONCAT()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual varchar(20) as (concat(a,',',b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL varchar(20) AS (concat(a,',',b))
+) ENGINE=InnoDB
+insert into t1 values ('value1','value2',default);
+select * from t1;
+a	b	c
+value1	value2	value1,value2
+drop table t1;
+set sql_warnings = 0;
+# ELT()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c int, d virtual varchar(10) as (elt(c,a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` int,
+  `d` VIRTUAL varchar(10) AS (elt(c,a,b))
+) ENGINE=InnoDB
+insert into t1 values ('value1','value2',1,default);
+insert into t1 values ('value1','value2',2,default);
+select * from t1;
+a	b	c	d
+value1	value2	1	value1
+value1	value2	2	value2
+drop table t1;
+set sql_warnings = 0;
+# EXPORT_SET()
+set sql_warnings = 1;
+create table t1 (a int, b virtual varchar(10) as (export_set(a,'1','0','',10)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL varchar(10) AS (export_set(a,'1','0','',10))
+) ENGINE=InnoDB
+insert into t1 values (6,default);
+select * from t1;
+a	b
+6	0110000000
+drop table t1;
+set sql_warnings = 0;
+# FIELD()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual int as (field('aa',a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL int AS (field('aa',a,b))
+) ENGINE=InnoDB
+insert into t1 values ('aa','bb',default);
+insert into t1 values ('bb','aa',default);
+select * from t1;
+a	b	c
+aa	bb	1
+bb	aa	2
+drop table t1;
+set sql_warnings = 0;
+# FIND_IN_SET()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual int as (find_in_set(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL int AS (find_in_set(a,b))
+) ENGINE=InnoDB
+insert into t1 values ('aa','aa,bb,cc',default);
+insert into t1 values ('aa','bb,aa,cc',default);
+select * from t1;
+a	b	c
+aa	aa,bb,cc	1
+aa	bb,aa,cc	2
+drop table t1;
+set sql_warnings = 0;
+# FORMAT()
+set sql_warnings = 1;
+create table t1 (a double, b virtual varchar(20) as (format(a,2)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL varchar(20) AS (format(a,2))
+) ENGINE=InnoDB
+insert into t1 values (12332.123456,default);
+select * from t1;
+a	b
+12332.123456	12,332.12
+drop table t1;
+set sql_warnings = 0;
+# HEX()
+set sql_warnings = 1;
+create table t1 (a double, b virtual varchar(10) as (hex(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL varchar(10) AS (hex(a))
+) ENGINE=InnoDB
+insert into t1 values (17,default);
+select * from t1;
+a	b
+17	11
+drop table t1;
+set sql_warnings = 0;
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (hex(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (hex(a))
+) ENGINE=InnoDB
+insert into t1 values ('abc',default);
+select * from t1;
+a	b
+abc	616263
+drop table t1;
+set sql_warnings = 0;
+# INSERT()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual varchar(20) as (insert(a,length(a),length(b),b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL varchar(20) AS (insert(a,length(a),length(b),b))
+) ENGINE=InnoDB
+insert into t1 values ('start,','end',default);
+select * from t1;
+a	b	c
+start,	end	startend
+drop table t1;
+set sql_warnings = 0;
+# INSTR()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual int as (instr(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL int AS (instr(a,b))
+) ENGINE=InnoDB
+insert into t1 values ('foobarbar,','bar',default);
+insert into t1 values ('xbar,','foobar',default);
+select * from t1;
+a	b	c
+foobarbar,	bar	4
+xbar,	foobar	0
+drop table t1;
+set sql_warnings = 0;
+# LCASE()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (lcase(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (lcase(a))
+) ENGINE=InnoDB
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+MySQL	mysql
+drop table t1;
+set sql_warnings = 0;
+# LEFT()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(5) as (left(a,5)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(5) AS (left(a,5))
+) ENGINE=InnoDB
+insert into t1 values ('foobarbar',default);
+select * from t1;
+a	b
+foobarbar	fooba
+drop table t1;
+set sql_warnings = 0;
+# LENGTH()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual int as (length(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL int AS (length(a))
+) ENGINE=InnoDB
+insert into t1 values ('text',default);
+select * from t1;
+a	b
+text	4
+drop table t1;
+set sql_warnings = 0;
+# LIKE
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual bool as (a like 'H%o'));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL tinyint(1) AS (a like 'H%o')
+) ENGINE=InnoDB
+insert into t1 values ('Hello',default);
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+Hello	1
+MySQL	0
+drop table t1;
+set sql_warnings = 0;
+# LOCATE()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (locate('bar',a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (locate('bar',a))
+) ENGINE=InnoDB
+insert into t1 values ('foobarbar',default);
+select * from t1;
+a	b
+foobarbar	4
+drop table t1;
+set sql_warnings = 0;
+# LOWER()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (lower(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (lower(a))
+) ENGINE=InnoDB
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+MySQL	mysql
+drop table t1;
+set sql_warnings = 0;
+# LPAD()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (lpad(a,4,' ')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (lpad(a,4,' '))
+) ENGINE=InnoDB
+insert into t1 values ('MySQL',default);
+insert into t1 values ('M',default);
+select * from t1;
+a	b
+MySQL	MySQ
+M	   M
+drop table t1;
+set sql_warnings = 0;
+# LTRIM()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (ltrim(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (ltrim(a))
+) ENGINE=InnoDB
+insert into t1 values ('  MySQL',default);
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+  MySQL	MySQL
+MySQL	MySQL
+drop table t1;
+set sql_warnings = 0;
+# MAKE_SET()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c int, d virtual varchar(30) as (make_set(c,a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` int,
+  `d` VIRTUAL varchar(30) AS (make_set(c,a,b))
+) ENGINE=InnoDB
+insert into t1 values ('a','b',1,default);
+insert into t1 values ('a','b',3,default);
+select * from t1;
+a	b	c	d
+a	b	1	a
+a	b	3	a,b
+drop table t1;
+set sql_warnings = 0;
+# MID()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (mid(a,1,2)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (mid(a,1,2))
+) ENGINE=InnoDB
+insert into t1 values ('foobarbar',default);
+select * from t1;
+a	b
+foobarbar	fo
+drop table t1;
+set sql_warnings = 0;
+# NOT LIKE
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual bool as (a not like 'H%o'));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL tinyint(1) AS (a not like 'H%o')
+) ENGINE=InnoDB
+insert into t1 values ('Hello',default);
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+Hello	0
+MySQL	1
+drop table t1;
+set sql_warnings = 0;
+# OCTET_LENGTH()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual int as (octet_length(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL int AS (octet_length(a))
+) ENGINE=InnoDB
+insert into t1 values ('text',default);
+select * from t1;
+a	b
+text	4
+drop table t1;
+set sql_warnings = 0;
+# ORD()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual int as (ord(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL int AS (ord(a))
+) ENGINE=InnoDB
+insert into t1 values ('2',default);
+select * from t1;
+a	b
+2	50
+drop table t1;
+set sql_warnings = 0;
+# POSITION()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (position('bar' in a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (position('bar' in a))
+) ENGINE=InnoDB
+insert into t1 values ('foobarbar',default);
+select * from t1;
+a	b
+foobarbar	4
+drop table t1;
+set sql_warnings = 0;
+# QUOTE()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (quote(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (quote(a))
+) ENGINE=InnoDB
+insert into t1 values ('Don\'t',default);
+select * from t1;
+a	b
+Don't	'Don\'t'
+drop table t1;
+set sql_warnings = 0;
+# REPEAT()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(30) as (repeat(a,3)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(30) AS (repeat(a,3))
+) ENGINE=InnoDB
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+MySQL	MySQLMySQLMySQL
+drop table t1;
+set sql_warnings = 0;
+# REPLACE()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(30) as (replace(a,'aa','bb')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(30) AS (replace(a,'aa','bb'))
+) ENGINE=InnoDB
+insert into t1 values ('maa',default);
+select * from t1;
+a	b
+maa	mbb
+drop table t1;
+set sql_warnings = 0;
+# REVERSE()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(30) as (reverse(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(30) AS (reverse(a))
+) ENGINE=InnoDB
+insert into t1 values ('maa',default);
+select * from t1;
+a	b
+maa	aam
+drop table t1;
+set sql_warnings = 0;
+# RIGHT()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (right(a,4)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (right(a,4))
+) ENGINE=InnoDB
+insert into t1 values ('foobarbar',default);
+select * from t1;
+a	b
+foobarbar	rbar
+drop table t1;
+set sql_warnings = 0;
+# RPAD()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (rpad(a,4,'??')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (rpad(a,4,'??'))
+) ENGINE=InnoDB
+insert into t1 values ('He',default);
+select * from t1;
+a	b
+He	He??
+drop table t1;
+set sql_warnings = 0;
+# RTRIM();
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (rtrim(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (rtrim(a))
+) ENGINE=InnoDB
+insert into t1 values ('Hello  ',default);
+select * from t1;
+a	b
+Hello  	Hello
+drop table t1;
+set sql_warnings = 0;
+# SPACE()
+set sql_warnings = 1;
+create table t1 (a varchar(5), b virtual varchar(10) as (concat(a,space(5))));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(5),
+  `b` VIRTUAL varchar(10) AS (concat(a,space(5)))
+) ENGINE=InnoDB
+insert into t1 values ('Hello', default);
+select * from t1;
+a	b
+Hello	Hello     
+drop table t1;
+set sql_warnings = 0;
+# STRCMP()
+set sql_warnings = 1;
+create table t1 (a varchar(9), b varchar(9), c virtual tinyint as (strcmp(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(9),
+  `b` varchar(9),
+  `c` VIRTUAL tinyint(4) AS (strcmp(a,b))
+) ENGINE=InnoDB
+insert into t1 values ('Hello','Hello', default);
+insert into t1 values ('Hello','Hello1', default);
+select * from t1;
+a	b	c
+Hello	Hello	0
+Hello	Hello1	-1
+drop table t1;
+set sql_warnings = 0;
+# SUBSTR()
+set sql_warnings = 1;
+create table t1 (a varchar(5), b virtual varchar(10) as (substr(a,2)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(5),
+  `b` VIRTUAL varchar(10) AS (substr(a,2))
+) ENGINE=InnoDB
+insert into t1 values ('Hello',default);
+select * from t1;
+a	b
+Hello	ello
+drop table t1;
+set sql_warnings = 0;
+# SUBSTRING_INDEX()
+set sql_warnings = 1;
+create table t1 (a varchar(15), b virtual varchar(10) as (substring_index(a,'.',2)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(15),
+  `b` VIRTUAL varchar(10) AS (substring_index(a,'.',2))
+) ENGINE=InnoDB
+insert into t1 values ('www.mysql.com',default);
+select * from t1;
+a	b
+www.mysql.com	www.mysql
+drop table t1;
+set sql_warnings = 0;
+# SUBSTRING()
+set sql_warnings = 1;
+create table t1 (a varchar(5), b virtual varchar(10) as (substring(a from 2 for 2)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(5),
+  `b` VIRTUAL varchar(10) AS (substring(a from 2 for 2))
+) ENGINE=InnoDB
+insert into t1 values ('Hello',default);
+select * from t1;
+a	b
+Hello	el
+drop table t1;
+set sql_warnings = 0;
+# TRIM()
+set sql_warnings = 1;
+create table t1 (a varchar(15), b virtual varchar(10) as (trim(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(15),
+  `b` VIRTUAL varchar(10) AS (trim(a))
+) ENGINE=InnoDB
+insert into t1 values (' aa ',default);
+select * from t1;
+a	b
+ aa 	aa
+drop table t1;
+set sql_warnings = 0;
+# UCASE()
+set sql_warnings = 1;
+create table t1 (a varchar(5), b virtual varchar(10) as (ucase(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(5),
+  `b` VIRTUAL varchar(10) AS (ucase(a))
+) ENGINE=InnoDB
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+MySQL	MYSQL
+drop table t1;
+set sql_warnings = 0;
+# UNHEX()
+set sql_warnings = 1;
+create table t1 (a varchar(15), b virtual varchar(10) as (unhex(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(15),
+  `b` VIRTUAL varchar(10) AS (unhex(a))
+) ENGINE=InnoDB
+insert into t1 values ('4D7953514C',default);
+select * from t1;
+a	b
+4D7953514C	MySQL
+drop table t1;
+set sql_warnings = 0;
+# UPPER()
+set sql_warnings = 1;
+create table t1 (a varchar(5), b virtual varchar(10) as (upper(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(5),
+  `b` VIRTUAL varchar(10) AS (upper(a))
+) ENGINE=InnoDB
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+MySQL	MYSQL
+drop table t1;
+set sql_warnings = 0;
+#
+# CONTROL FLOW FUNCTIONS
+#
+# CASE
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(16) as (case a when NULL then 'asd' when 'b' then 'B' else a end));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(16) AS (case a when NULL then 'asd' when 'b' then 'B' else a end)
+) ENGINE=InnoDB
+insert into t1 values (NULL,default);
+insert into t1 values ('b',default);
+insert into t1 values ('c',default);
+select * from t1;
+a	b
+NULL	NULL
+b	B
+c	c
+drop table t1;
+set sql_warnings = 0;
+# IF
+set sql_warnings = 1;
+create table t1 (a int, b int, c virtual int as (if(a=1,a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` int,
+  `c` VIRTUAL int AS (if(a=1,a,b))
+) ENGINE=InnoDB
+insert into t1 values (1,2,default);
+insert into t1 values (3,4,default);
+select * from t1;
+a	b	c
+1	2	1
+3	4	4
+drop table t1;
+set sql_warnings = 0;
+# IFNULL
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual varchar(10) as (ifnull(a,'DEFAULT')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL varchar(10) AS (ifnull(a,'DEFAULT'))
+) ENGINE=InnoDB
+insert into t1 values (NULL,'adf',default);
+insert into t1 values ('a','adf',default);
+select * from t1;
+a	b	c
+NULL	adf	DEFAULT
+a	adf	a
+drop table t1;
+set sql_warnings = 0;
+# NULLIF
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (nullif(a,'DEFAULT')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (nullif(a,'DEFAULT'))
+) ENGINE=InnoDB
+insert into t1 values ('DEFAULT',default);
+insert into t1 values ('a',default);
+select * from t1;
+a	b
+DEFAULT	NULL
+a	a
+drop table t1;
+set sql_warnings = 0;
+#
+# OPERATORS
+#
+# AND
+set sql_warnings = 1;
+create table t1 (a int, b virtual bool as (a>0 and a<2));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL tinyint(1) AS (a>0 and a<2)
+) ENGINE=InnoDB
+insert into t1 values (-1,default);
+insert into t1 values (1,default);
+select * from t1;
+a	b
+-1	0
+1	1
+drop table t1;
+set sql_warnings = 0;
+# BETWEEN ... AND ... 
+set sql_warnings = 1;
+create table t1 (a int, b virtual bool as (a between 0 and 2));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL tinyint(1) AS (a between 0 and 2)
+) ENGINE=InnoDB
+insert into t1 values (-1,default);
+insert into t1 values (1,default);
+select * from t1;
+a	b
+-1	0
+1	1
+drop table t1;
+set sql_warnings = 0;
+# BINARY
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varbinary(10) as (binary a));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varbinary(10) AS (binary a)
+) ENGINE=InnoDB
+insert into t1 values ('11',default);
+insert into t1 values (1,default);
+select * from t1;
+a	b
+11	11
+1	1
+drop table t1;
+set sql_warnings = 0;
+# DIV
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (a div 5));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a div 5)
+) ENGINE=InnoDB
+insert into t1 values (1,default);
+insert into t1 values (7,default);
+select * from t1;
+a	b
+1	0
+7	1
+drop table t1;
+set sql_warnings = 0;
+# <=>
+set sql_warnings = 1;
+create table t1 (a int, b int, c virtual bool as (a <=> b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` int,
+  `c` VIRTUAL tinyint(1) AS (a <=> b)
+) ENGINE=InnoDB
+insert into t1 values (1,1,default);
+insert into t1 values (NULL,NULL,default);
+insert into t1 values (1,NULL,default);
+select * from t1;
+a	b	c
+1	1	1
+NULL	NULL	1
+1	NULL	0
+drop table t1;
+set sql_warnings = 0;
+# =
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual bool as (a=b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL tinyint(1) AS (a=b)
+) ENGINE=InnoDB
+insert into t1 values ('a','b',default);
+insert into t1 values ('a','a',default);
+select * from t1;
+a	b	c
+a	b	0
+a	a	1
+drop table t1;
+set sql_warnings = 0;
+# >=
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual bool as (a >= b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL tinyint(1) AS (a >= b)
+) ENGINE=InnoDB
+insert into t1 values ('a','b',default);
+insert into t1 values ('a','a',default);
+select * from t1;
+a	b	c
+a	b	0
+a	a	1
+drop table t1;
+set sql_warnings = 0;
+# >
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual bool as (a > b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL tinyint(1) AS (a > b)
+) ENGINE=InnoDB
+insert into t1 values ('a','b',default);
+insert into t1 values ('a','a',default);
+select * from t1;
+a	b	c
+a	b	0
+a	a	0
+drop table t1;
+set sql_warnings = 0;
+# IS NOT NULL
+set sql_warnings = 1;
+create table t1 (a int, b virtual bool as (a is not null));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL tinyint(1) AS (a is not null)
+) ENGINE=InnoDB
+insert into t1 values (1,default);
+insert into t1 values (NULL,default);
+select * from t1;
+a	b
+1	1
+NULL	0
+drop table t1;
+set sql_warnings = 0;
+# IS NULL
+set sql_warnings = 1;
+create table t1 (a int, b virtual bool as (a is null));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL tinyint(1) AS (a is null)
+) ENGINE=InnoDB
+insert into t1 values (1,default);
+insert into t1 values (NULL,default);
+select * from t1;
+a	b
+1	0
+NULL	1
+drop table t1;
+set sql_warnings = 0;
+# <=
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual bool as (a <= b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL tinyint(1) AS (a <= b)
+) ENGINE=InnoDB
+insert into t1 values ('b','a',default);
+insert into t1 values ('b','b',default);
+insert into t1 values ('b','c',default);
+select * from t1;
+a	b	c
+b	a	0
+b	b	1
+b	c	1
+drop table t1;
+set sql_warnings = 0;
+# <
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual bool as (a < b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL tinyint(1) AS (a < b)
+) ENGINE=InnoDB
+insert into t1 values ('b','a',default);
+insert into t1 values ('b','b',default);
+insert into t1 values ('b','c',default);
+select * from t1;
+a	b	c
+b	a	0
+b	b	0
+b	c	1
+drop table t1;
+set sql_warnings = 0;
+# NOT BETWEEN ... AND ...
+set sql_warnings = 1;
+create table t1 (a int, b virtual bool as (a not between 0 and 2));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL tinyint(1) AS (a not between 0 and 2)
+) ENGINE=InnoDB
+insert into t1 values (-1,default);
+insert into t1 values (1,default);
+select * from t1;
+a	b
+-1	1
+1	0
+drop table t1;
+set sql_warnings = 0;
+# <>
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual bool as (a <> b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL tinyint(1) AS (a <> b)
+) ENGINE=InnoDB
+insert into t1 values ('b','a',default);
+insert into t1 values ('b','b',default);
+insert into t1 values ('b','c',default);
+select * from t1;
+a	b	c
+b	a	1
+b	b	0
+b	c	1
+drop table t1;
+set sql_warnings = 0;
+# !=
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual bool as (a != b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL tinyint(1) AS (a != b)
+) ENGINE=InnoDB
+insert into t1 values ('b','a',default);
+insert into t1 values ('b','b',default);
+insert into t1 values ('b','c',default);
+select * from t1;
+a	b	c
+b	a	1
+b	b	0
+b	c	1
+drop table t1;
+set sql_warnings = 0;
+# OR
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (a>5 or a<3));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a>5 or a<3)
+) ENGINE=InnoDB
+insert into t1 values (1,default);
+insert into t1 values (4,default);
+select * from t1;
+a	b
+1	1
+4	0
+drop table t1;
+set sql_warnings = 0;
+# XOR
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (a xor 5));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a xor 5)
+) ENGINE=InnoDB
+insert into t1 values (0,default);
+insert into t1 values (1,default);
+insert into t1 values (2,default);
+select * from t1;
+a	b
+0	1
+1	0
+2	0
+drop table t1;
+set sql_warnings = 0;
+#
+# DATE AND TIME FUNCTIONS
+#
+# ADDDATE()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (adddate(a,interval 1 month)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (adddate(a,interval 1 month))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	2008-09-30 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# ADDTIME()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (addtime(a,'02:00:00')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (addtime(a,'02:00:00'))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	2008-08-31 02:00:00
+drop table t1;
+set sql_warnings = 0;
+# DATE_ADD()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (date_add(a,interval 1 month)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (date_add(a,interval 1 month))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	2008-09-30 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# DATE_FORMAT()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual varchar(64) as (date_format(a,'%W %M %D')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL varchar(64) AS (date_format(a,'%W %M %D'))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	Sunday August 31st
+drop table t1;
+set sql_warnings = 0;
+# DATE_SUB()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (date_sub(a,interval 1 month)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (date_sub(a,interval 1 month))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	2008-07-31 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# DATE()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (date(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (date(a))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31 02:00:00',default);
+select * from t1;
+a	b
+2008-08-31 02:00:00	2008-08-31 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# DATEDIFF()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (datediff(a,'2000-01-01')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (datediff(a,'2000-01-01'))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	3165
+drop table t1;
+set sql_warnings = 0;
+# DAY()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (day(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (day(a))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	31
+drop table t1;
+set sql_warnings = 0;
+# DAYNAME()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual varchar(10) as (dayname(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL varchar(10) AS (dayname(a))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	Sunday
+drop table t1;
+set sql_warnings = 0;
+# DAYOFMONTH()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (dayofmonth(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (dayofmonth(a))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	31
+drop table t1;
+set sql_warnings = 0;
+# DAYOFWEEK()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (dayofweek(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (dayofweek(a))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	1
+drop table t1;
+set sql_warnings = 0;
+# DAYOFYEAR()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (dayofyear(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (dayofyear(a))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	244
+drop table t1;
+set sql_warnings = 0;
+# EXTRACT
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (extract(year from a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (extract(year from a))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	2008
+drop table t1;
+set sql_warnings = 0;
+# FROM_DAYS()
+set sql_warnings = 1;
+create table t1 (a int, b virtual datetime as (from_days(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL datetime AS (from_days(a))
+) ENGINE=InnoDB
+insert into t1 values (730669,default);
+select * from t1;
+a	b
+730669	2000-07-03 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# FROM_UNIXTIME()
+set sql_warnings = 1;
+create table t1 (a int, b virtual datetime as (from_unixtime(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL datetime AS (from_unixtime(a))
+) ENGINE=InnoDB
+insert into t1 values (1196440219,default);
+select * from t1;
+a	b
+1196440219	2007-11-30 19:30:19
+drop table t1;
+set sql_warnings = 0;
+# GET_FORMAT()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual varchar(32) as (date_format(a,get_format(DATE,'EUR'))));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL varchar(32) AS (date_format(a,get_format(DATE,'EUR')))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	31.08.2008
+drop table t1;
+set sql_warnings = 0;
+# HOUR()
+set sql_warnings = 1;
+create table t1 (a time, b virtual int as (hour(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` time,
+  `b` VIRTUAL int AS (hour(a))
+) ENGINE=InnoDB
+insert into t1 values ('10:05:03',default);
+select * from t1;
+a	b
+10:05:03	10
+drop table t1;
+set sql_warnings = 0;
+# LAST_DAY()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (last_day(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (last_day(a))
+) ENGINE=InnoDB
+insert into t1 values ('2003-02-05',default);
+select * from t1;
+a	b
+2003-02-05 00:00:00	2003-02-28 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# MAKEDATE()
+set sql_warnings = 1;
+create table t1 (a int, b virtual datetime as (makedate(a,1)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL datetime AS (makedate(a,1))
+) ENGINE=InnoDB
+insert into t1 values (2001,default);
+select * from t1;
+a	b
+2001	2001-01-01 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# MAKETIME()
+set sql_warnings = 1;
+create table t1 (a int, b virtual time as (maketime(a,1,3)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL time AS (maketime(a,1,3))
+) ENGINE=InnoDB
+insert into t1 values (12,default);
+select * from t1;
+a	b
+12	12:01:03
+drop table t1;
+set sql_warnings = 0;
+# MICROSECOND()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (microsecond(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (microsecond(a))
+) ENGINE=InnoDB
+insert into t1 values ('2009-12-31 12:00:00.123456',default);
+insert into t1 values ('2009-12-31 23:59:59.000010',default);
+select * from t1;
+a	b
+2009-12-31 12:00:00	0
+2009-12-31 23:59:59	0
+drop table t1;
+set sql_warnings = 0;
+# MINUTE()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (minute(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (minute(a))
+) ENGINE=InnoDB
+insert into t1 values ('2009-12-31 23:59:59.000010',default);
+select * from t1;
+a	b
+2009-12-31 23:59:59	59
+drop table t1;
+set sql_warnings = 0;
+# MONTH()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (month(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (month(a))
+) ENGINE=InnoDB
+insert into t1 values ('2009-12-31 23:59:59.000010',default);
+select * from t1;
+a	b
+2009-12-31 23:59:59	12
+drop table t1;
+set sql_warnings = 0;
+# MONTHNAME()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual varchar(16) as (monthname(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL varchar(16) AS (monthname(a))
+) ENGINE=InnoDB
+insert into t1 values ('2009-12-31 23:59:59.000010',default);
+select * from t1;
+a	b
+2009-12-31 23:59:59	December
+drop table t1;
+set sql_warnings = 0;
+# PERIOD_ADD()
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (period_add(a,2)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (period_add(a,2))
+) ENGINE=InnoDB
+insert into t1 values (200801,default);
+select * from t1;
+a	b
+200801	200803
+drop table t1;
+set sql_warnings = 0;
+# PERIOD_DIFF()
+set sql_warnings = 1;
+create table t1 (a int, b int, c virtual int as (period_diff(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` int,
+  `c` VIRTUAL int AS (period_diff(a,b))
+) ENGINE=InnoDB
+insert into t1 values (200802,200703,default);
+select * from t1;
+a	b	c
+200802	200703	11
+drop table t1;
+set sql_warnings = 0;
+# QUARTER()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (quarter(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (quarter(a))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	3
+drop table t1;
+set sql_warnings = 0;
+# SEC_TO_TIME()
+set sql_warnings = 1;
+create table t1 (a int, b virtual time as (sec_to_time(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL time AS (sec_to_time(a))
+) ENGINE=InnoDB
+insert into t1 values (2378,default);
+select * from t1;
+a	b
+2378	00:39:38
+drop table t1;
+set sql_warnings = 0;
+# SECOND()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (second(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (second(a))
+) ENGINE=InnoDB
+insert into t1 values ('10:05:03',default);
+select * from t1;
+a	b
+2010-05-03 00:00:00	0
+drop table t1;
+set sql_warnings = 0;
+# STR_TO_DATE()
+set sql_warnings = 1;
+create table t1 (a varchar(64), b virtual datetime as (str_to_date(a,'%m/%d/%Y')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(64),
+  `b` VIRTUAL datetime AS (str_to_date(a,'%m/%d/%Y'))
+) ENGINE=InnoDB
+insert into t1 values ('04/30/2004',default);
+select * from t1;
+a	b
+04/30/2004	2004-04-30 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# SUBDATE()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (subdate(a,interval 1 month)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (subdate(a,interval 1 month))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	2008-07-31 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# SUBTIME()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (subtime(a,'02:00:00')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (subtime(a,'02:00:00'))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	2008-08-30 22:00:00
+drop table t1;
+set sql_warnings = 0;
+# TIME_FORMAT()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual varchar(32) as (time_format(a,'%r')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL varchar(32) AS (time_format(a,'%r'))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31 02:03:04',default);
+select * from t1;
+a	b
+2008-08-31 02:03:04	02:03:04 AM
+drop table t1;
+set sql_warnings = 0;
+# TIME_TO_SEC()
+set sql_warnings = 1;
+create table t1 (a time, b virtual int as (time_to_sec(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` time,
+  `b` VIRTUAL int AS (time_to_sec(a))
+) ENGINE=InnoDB
+insert into t1 values ('22:23:00',default);
+select * from t1;
+a	b
+22:23:00	80580
+drop table t1;
+set sql_warnings = 0;
+# TIME()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual time as (time(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL time AS (time(a))
+) ENGINE=InnoDB
+insert into t1 values ('2008-08-31 02:03:04',default);
+select * from t1;
+a	b
+2008-08-31 02:03:04	02:03:04
+drop table t1;
+set sql_warnings = 0;
+# TIMEDIFF()
+set sql_warnings = 1;
+create table t1 (a datetime, b datetime, c virtual int as (timediff(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` datetime,
+  `c` VIRTUAL int AS (timediff(a,b))
+) ENGINE=InnoDB
+insert into t1 values ('2008-12-31 23:59:59.000001','2008-12-30 01:01:01.000002',default);
+Warnings:
+Warning	1265	Data truncated for column 'c' at row 1
+select * from t1;
+a	b	c
+2008-12-31 23:59:59	2008-12-30 01:01:01	46
+drop table t1;
+set sql_warnings = 0;
+# TIMESTAMP()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual timestamp as (timestamp(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL timestamp AS (timestamp(a)) NULL ON UPDATE CURRENT_TIMESTAMP
+) ENGINE=InnoDB
+insert into t1 values ('2008-12-31',default);
+select * from t1;
+a	b
+2008-12-31 00:00:00	2008-12-31 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# TIMESTAMPADD()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual timestamp as (timestampadd(minute,1,a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL timestamp AS (timestampadd(minute,1,a)) NULL ON UPDATE CURRENT_TIMESTAMP
+) ENGINE=InnoDB
+insert into t1 values ('2003-01-02',default);
+select * from t1;
+a	b
+2003-01-02 00:00:00	2003-01-02 00:01:00
+drop table t1;
+set sql_warnings = 0;
+# TIMESTAMPDIFF()
+set sql_warnings = 1;
+create table t1 (a timestamp, b timestamp, c virtual int as (timestampdiff(MONTH, a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
+  `b` timestamp NOT NULL,
+  `c` VIRTUAL int AS (timestampdiff(MONTH, a,b))
+) ENGINE=InnoDB
+insert into t1 values ('2003-02-01','2003-05-01',default);
+select * from t1;
+a	b	c
+2003-02-01 00:00:00	2003-05-01 00:00:00	3
+drop table t1;
+set sql_warnings = 0;
+# TO_DAYS()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (to_days(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (to_days(a))
+) ENGINE=InnoDB
+insert into t1 values ('2007-10-07',default);
+select * from t1;
+a	b
+2007-10-07 00:00:00	733321
+drop table t1;
+set sql_warnings = 0;
+# WEEK()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (week(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (week(a))
+) ENGINE=InnoDB
+insert into t1 values ('2008-09-01',default);
+select * from t1;
+a	b
+2008-09-01 00:00:00	35
+drop table t1;
+set sql_warnings = 0;
+# WEEKDAY()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (weekday(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (weekday(a))
+) ENGINE=InnoDB
+insert into t1 values ('2008-09-01',default);
+select * from t1;
+a	b
+2008-09-01 00:00:00	0
+drop table t1;
+set sql_warnings = 0;
+# WEEKOFYEAR()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (weekofyear(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (weekofyear(a))
+) ENGINE=InnoDB
+insert into t1 values ('2008-09-01',default);
+select * from t1;
+a	b
+2008-09-01 00:00:00	36
+drop table t1;
+set sql_warnings = 0;
+# YEAR()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (year(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (year(a))
+) ENGINE=InnoDB
+insert into t1 values ('2008-09-01',default);
+select * from t1;
+a	b
+2008-09-01 00:00:00	2008
+drop table t1;
+set sql_warnings = 0;
+# YEARWEEK()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (yearweek(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (yearweek(a))
+) ENGINE=InnoDB
+insert into t1 values ('2008-09-01',default);
+select * from t1;
+a	b
+2008-09-01 00:00:00	200835
+drop table t1;
+set sql_warnings = 0;
+#
+# FULL TEXT SEARCH FUNCTIONS
+#
+# None.
+#
+# CAST FUNCTIONS AND OPERATORS
+#
+# CAST()
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (cast(a as unsigned)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (cast(a as unsigned))
+) ENGINE=InnoDB
+insert into t1 values (1,default);
+insert into t1 values (-1,default);
+Warnings:
+Warning	1264	Out of range value for column 'b' at row 1
+select * from t1;
+a	b
+1	1
+-1	2147483647
+drop table t1;
+set sql_warnings = 0;
+# Convert()
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (convert(a,unsigned)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (convert(a,unsigned))
+) ENGINE=InnoDB
+insert into t1 values (1,default);
+insert into t1 values (-1,default);
+Warnings:
+Warning	1264	Out of range value for column 'b' at row 1
+select * from t1;
+a	b
+1	1
+-1	2147483647
+drop table t1;
+set sql_warnings = 0;
+#
+# OTHER FUNCTIONS
+#
+# BIT_COUNT()
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (bit_count(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (bit_count(a))
+) ENGINE=InnoDB
+insert into t1 values (5,default);
+select * from t1;
+a	b
+5	2
+drop table t1;
+set sql_warnings = 0;
+# COERCIBILITY()
+set sql_warnings = 1;
+create table t1 (a varchar(1024), b virtual int as (coercibility(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(1024),
+  `b` VIRTUAL int AS (coercibility(a))
+) ENGINE=InnoDB
+insert into t1 values ('abc',default);
+select * from t1;
+a	b
+abc	2
+drop table t1;
+set sql_warnings = 0;
+# COLLATION()
+set sql_warnings = 1;
+create table t1 (a varchar(1024), b virtual varchar(1024) as (collation(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(1024),
+  `b` VIRTUAL varchar(1024) AS (collation(a))
+) ENGINE=InnoDB
+insert into t1 values ('abc',default);
+select * from t1;
+a	b
+abc	utf8_general_ci
+drop table t1;
+set sql_warnings = 0;
+# DEFAULT()
+set sql_warnings = 1;
+create table t1 (a varchar(1024) default 'aaa', b virtual varchar(1024) as (ifnull(a,default(a))));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(1024),
+  `b` VIRTUAL varchar(1024) AS (ifnull(a,default(a)))
+) ENGINE=InnoDB
+insert into t1 values ('any value',default);
+select * from t1;
+a	b
+any value	any value
+drop table t1;
+set sql_warnings = 0;
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;

=== added file 'tests/suite/vcol/r/vcol_supported_sql_funcs_myisam.result'
--- tests/suite/vcol/r/vcol_supported_sql_funcs_myisam.result	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/r/vcol_supported_sql_funcs_myisam.result	2008-09-19 11:49:17 +0000
@@ -0,0 +1,2583 @@
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;
+SET @@session.storage_engine = 'MyISAM';
+#
+# NUMERIC FUNCTIONS
+#
+# ABS()
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (abs(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (abs(a))
+) ENGINE=MyISAM
+insert into t1 values (-1, default);
+select * from t1;
+a	b
+-1	1
+drop table t1;
+set sql_warnings = 0;
+# ACOS()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (acos(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (acos(a))
+) ENGINE=MyISAM
+insert into t1 values (1, default);
+insert into t1 values (1.0001,default);
+insert into t1 values (0,default);
+select * from t1;
+a	b
+1	0
+1.0001	NULL
+0	1.5707963267948966
+drop table t1;
+set sql_warnings = 0;
+# ASIN()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (asin(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (asin(a))
+) ENGINE=MyISAM
+insert into t1 values (0.2, default);
+insert into t1 values (1.0001,default);
+select * from t1;
+a	b
+0.2	0.20135792079033082
+1.0001	NULL
+drop table t1;
+set sql_warnings = 0;
+#ATAN
+set sql_warnings = 1;
+create table t1 (a double, b double, c virtual double as (atan(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` double,
+  `c` VIRTUAL double AS (atan(a,b))
+) ENGINE=MyISAM
+insert into t1 values (-2,2,default);
+insert into t1 values (PI(),0,default);
+select * from t1;
+a	b	c
+-2	2	-0.7853981633974483
+3.141592653589793	0	1.5707963267948966
+drop table t1;
+set sql_warnings = 0;
+set sql_warnings = 1;
+create table t1 (a double, c virtual double as (atan(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `c` VIRTUAL double AS (atan(a))
+) ENGINE=MyISAM
+insert into t1 values (-2,default);
+insert into t1 values (PI(),default);
+select * from t1;
+a	c
+-2	-1.1071487177940904
+3.141592653589793	1.2626272556789118
+drop table t1;
+set sql_warnings = 0;
+# ATAN2
+set sql_warnings = 1;
+create table t1 (a double, b double, c virtual double as (atan2(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` double,
+  `c` VIRTUAL double AS (atan2(a,b))
+) ENGINE=MyISAM
+insert into t1 values (-2,2,default);
+insert into t1 values (PI(),0,default);
+select * from t1;
+a	b	c
+-2	2	-0.7853981633974483
+3.141592653589793	0	1.5707963267948966
+drop table t1;
+set sql_warnings = 0;
+# CEIL()
+set sql_warnings = 1;
+create table t1 (a double, b virtual int as (ceil(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL int AS (ceil(a))
+) ENGINE=MyISAM
+insert into t1 values (1.23,default);
+insert into t1 values (-1.23,default);
+select * from t1;
+a	b
+1.23	2
+-1.23	-1
+drop table t1;
+set sql_warnings = 0;
+# CONV()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b int, c int, d virtual varchar(10) as (conv(a,b,c)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` int,
+  `c` int,
+  `d` VIRTUAL varchar(10) AS (conv(a,b,c))
+) ENGINE=MyISAM
+insert into t1 values ('a',16,2,default);
+insert into t1 values ('6e',18,8,default);
+insert into t1 values (-17,10,-18,default);
+insert into t1 values (10+'10'+'10'+0xa,10,10,default);
+select * from t1;
+a	b	c	d
+a	16	2	1010
+6e	18	8	172
+-17	10	-18	-H
+40	10	10	40
+drop table t1;
+set sql_warnings = 0;
+# COS()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (cos(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (cos(a))
+) ENGINE=MyISAM
+insert into t1 values (PI(),default);
+select * from t1;
+a	b
+3.141592653589793	-1
+drop table t1;
+set sql_warnings = 0;
+# COT()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (cot(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (cot(a))
+) ENGINE=MyISAM
+insert into t1 values (12,default);
+insert into t1 values (0,default);
+Warnings:
+Error	1365	Division by 0
+select * from t1;
+a	b
+12	-1.5726734063976893
+0	NULL
+Warnings:
+Error	1365	Division by 0
+drop table t1;
+set sql_warnings = 0;
+# DEGREES()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (degrees(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (degrees(a))
+) ENGINE=MyISAM
+insert into t1 values (PI(),default);
+insert into t1 values (PI()/2,default);
+select * from t1;
+a	b
+3.141592653589793	180
+1.5707963267948966	90
+drop table t1;
+set sql_warnings = 0;
+# /
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (a/2));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (a/2)
+) ENGINE=MyISAM
+insert into t1 values (2,default);
+select * from t1;
+a	b
+2	1
+drop table t1;
+set sql_warnings = 0;
+# EXP()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (exp(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (exp(a))
+) ENGINE=MyISAM
+insert into t1 values (2,default);
+insert into t1 values (-2,default);
+insert into t1 values (0,default);
+select * from t1;
+a	b
+2	7.38905609893065
+-2	0.1353352832366127
+0	1
+drop table t1;
+set sql_warnings = 0;
+# FLOOR()
+set sql_warnings = 1;
+create table t1 (a double, b virtual int as (floor(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL int AS (floor(a))
+) ENGINE=MyISAM
+insert into t1 values (1.23,default);
+insert into t1 values (-1.23,default);
+select * from t1;
+a	b
+1.23	1
+-1.23	-2
+drop table t1;
+set sql_warnings = 0;
+# LN()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (ln(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (ln(a))
+) ENGINE=MyISAM
+insert into t1 values (2,default);
+insert into t1 values (-2,default);
+Warnings:
+Error	1365	Division by 0
+select * from t1;
+a	b
+2	0.6931471805599453
+-2	NULL
+Warnings:
+Error	1365	Division by 0
+drop table t1;
+set sql_warnings = 0;
+# LOG()
+set sql_warnings = 1;
+create table t1 (a double, b double, c virtual double as (log(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` double,
+  `c` VIRTUAL double AS (log(a,b))
+) ENGINE=MyISAM
+insert into t1 values (2,65536,default);
+insert into t1 values (10,100,default);
+insert into t1 values (1,100,default);
+Warnings:
+Error	1365	Division by 0
+select * from t1;
+a	b	c
+2	65536	16
+10	100	2
+1	100	NULL
+Warnings:
+Error	1365	Division by 0
+drop table t1;
+set sql_warnings = 0;
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (log(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (log(a))
+) ENGINE=MyISAM
+insert into t1 values (2,default);
+insert into t1 values (-2,default);
+Warnings:
+Error	1365	Division by 0
+select * from t1;
+a	b
+2	0.6931471805599453
+-2	NULL
+Warnings:
+Error	1365	Division by 0
+drop table t1;
+set sql_warnings = 0;
+# LOG2()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (log2(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (log2(a))
+) ENGINE=MyISAM
+insert into t1 values (65536,default);
+insert into t1 values (-100,default);
+Warnings:
+Error	1365	Division by 0
+select * from t1;
+a	b
+65536	16
+-100	NULL
+Warnings:
+Error	1365	Division by 0
+drop table t1;
+set sql_warnings = 0;
+# LOG10()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (log10(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (log10(a))
+) ENGINE=MyISAM
+insert into t1 values (2,default);
+insert into t1 values (100,default);
+insert into t1 values (-100,default);
+Warnings:
+Error	1365	Division by 0
+select * from t1;
+a	b
+2	0.3010299956639812
+100	2
+-100	NULL
+Warnings:
+Error	1365	Division by 0
+drop table t1;
+set sql_warnings = 0;
+# -
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (a-1));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (a-1)
+) ENGINE=MyISAM
+insert into t1 values (2,default);
+select * from t1;
+a	b
+2	1
+drop table t1;
+set sql_warnings = 0;
+# MOD()
+set sql_warnings = 1;
+create table t1 (a double, b virtual int as (mod(a,10)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL int AS (mod(a,10))
+) ENGINE=MyISAM
+insert into t1 values (1,default);
+insert into t1 values (11,default);
+select * from t1;
+a	b
+1	1
+11	1
+drop table t1;
+set sql_warnings = 0;
+# %
+set sql_warnings = 1;
+create table t1 (a double, b virtual int as (a % 10));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL int AS (a % 10)
+) ENGINE=MyISAM
+insert into t1 values (1,default);
+insert into t1 values (11,default);
+select * from t1;
+a	b
+1	1
+11	1
+drop table t1;
+set sql_warnings = 0;
+# OCT()
+set sql_warnings = 1;
+create table t1 (a double, b virtual varchar(10) as (oct(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL varchar(10) AS (oct(a))
+) ENGINE=MyISAM
+insert into t1 values (12,default);
+select * from t1;
+a	b
+12	14
+drop table t1;
+set sql_warnings = 0;
+# PI()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (PI()*a*a));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (PI()*a*a)
+) ENGINE=MyISAM
+insert into t1 values (1,default);
+select * from t1;
+a	b
+1	3.141592653589793
+drop table t1;
+set sql_warnings = 0;
+# +
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (a+1));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a+1)
+) ENGINE=MyISAM
+insert into t1 values (1,default);
+select * from t1;
+a	b
+1	2
+drop table t1;
+set sql_warnings = 0;
+# POW, POWER
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (pow(a,2)), c virtual int as (power(a,2)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (pow(a,2)),
+  `c` VIRTUAL int AS (power(a,2))
+) ENGINE=MyISAM
+insert into t1 values (1,default,default);
+insert into t1 values (2,default,default);
+select * from t1;
+a	b	c
+1	1	1
+2	4	4
+drop table t1;
+set sql_warnings = 0;
+# RADIANS()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (radians(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (radians(a))
+) ENGINE=MyISAM
+insert into t1 values (90,default);
+select * from t1;
+a	b
+90	1.5707963267948966
+drop table t1;
+set sql_warnings = 0;
+# ROUND()
+set sql_warnings = 1;
+create table t1 (a double, b virtual int as (round(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL int AS (round(a))
+) ENGINE=MyISAM
+insert into t1 values (-1.23,default);
+insert into t1 values (-1.58,default);
+insert into t1 values (1.58,default);
+select * from t1;
+a	b
+-1.23	-1
+-1.58	-2
+1.58	2
+drop table t1;
+set sql_warnings = 0;
+set sql_warnings = 1;
+create table t1 (a double, b double, c virtual int as (round(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` double,
+  `c` VIRTUAL int AS (round(a,b))
+) ENGINE=MyISAM
+insert into t1 values (1.298,1,default);
+insert into t1 values (1.298,0,default);
+insert into t1 values (23.298,-1,default);
+select * from t1;
+a	b	c
+1.298	1	1
+1.298	0	1
+23.298	-1	20
+drop table t1;
+set sql_warnings = 0;
+# SIGN()
+set sql_warnings = 1;
+create table t1 (a double, b virtual int as (sign(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL int AS (sign(a))
+) ENGINE=MyISAM
+insert into t1 values (-32,default);
+insert into t1 values (0,default);
+insert into t1 values (234,default);
+select * from t1;
+a	b
+-32	-1
+0	0
+234	1
+drop table t1;
+set sql_warnings = 0;
+# SIN()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (sin(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (sin(a))
+) ENGINE=MyISAM
+insert into t1 values (PI(),default);
+Warnings:
+Warning	1292	Incorrect datetime value: '3.141592653589793'
+select * from t1;
+a	b
+3.141592653589793	NULL
+Warnings:
+Warning	1292	Incorrect datetime value: '3.141592653589793'
+drop table t1;
+set sql_warnings = 0;
+# SQRT()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (sqrt(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (sqrt(a))
+) ENGINE=MyISAM
+insert into t1 values (4,default);
+insert into t1 values (20,default);
+insert into t1 values (-16,default);
+select * from t1;
+a	b
+4	2
+20	4.47213595499958
+-16	NULL
+drop table t1;
+set sql_warnings = 0;
+# TAN()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (tan(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (tan(a))
+) ENGINE=MyISAM
+insert into t1 values (PI(),default);
+insert into t1 values (PI()+1,default);
+select * from t1;
+a	b
+3.141592653589793	-1.2246063538223773e-16
+4.141592653589793	1.5574077246549018
+drop table t1;
+set sql_warnings = 0;
+# *
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (a*3));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (a*3)
+) ENGINE=MyISAM
+insert into t1 values (0,default);
+insert into t1 values (1,default);
+insert into t1 values (2,default);
+select * from t1;
+a	b
+0	0
+1	3
+2	6
+drop table t1;
+set sql_warnings = 0;
+# TRUNCATE()
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (truncate(a,4)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (truncate(a,4))
+) ENGINE=MyISAM
+insert into t1 values (1.223,default);
+insert into t1 values (1.999,default);
+insert into t1 values (1.999,default);
+insert into t1 values (122,default);
+select * from t1;
+a	b
+1.223	1.223
+1.999	1.999
+1.999	1.999
+122	122
+drop table t1;
+set sql_warnings = 0;
+# Unary -
+set sql_warnings = 1;
+create table t1 (a double, b virtual double as (-a));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL double AS (-a)
+) ENGINE=MyISAM
+insert into t1 values (1,default);
+insert into t1 values (-1,default);
+select * from t1;
+a	b
+1	-1
+-1	1
+drop table t1;
+set sql_warnings = 0;
+#
+# STRING FUNCTIONS
+#
+# ASCII()
+set sql_warnings = 1;
+create table t1 (a char(2), b virtual int as (ascii(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(2),
+  `b` VIRTUAL int AS (ascii(a))
+) ENGINE=MyISAM
+insert into t1 values ('2',default);
+insert into t1 values (2,default);
+insert into t1 values ('dx',default);
+select * from t1;
+a	b
+2	50
+2	50
+dx	100
+drop table t1;
+set sql_warnings = 0;
+# BIN()
+set sql_warnings = 1;
+create table t1 (a int, b virtual varchar(10) as (bin(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL varchar(10) AS (bin(a))
+) ENGINE=MyISAM
+insert into t1 values (12,default);
+select * from t1;
+a	b
+12	1100
+drop table t1;
+set sql_warnings = 0;
+# BIT_LENGTH()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual int as (bit_length(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL int AS (bit_length(a))
+) ENGINE=MyISAM
+insert into t1 values ('text',default);
+select * from t1;
+a	b
+text	32
+drop table t1;
+set sql_warnings = 0;
+# CHAR_LENGTH()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual int as (char_length(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL int AS (char_length(a))
+) ENGINE=MyISAM
+insert into t1 values ('text',default);
+select * from t1;
+a	b
+text	4
+drop table t1;
+set sql_warnings = 0;
+# CHAR()
+set sql_warnings = 1;
+create table t1 (a int, b int, c virtual varbinary(10) as (char(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` int,
+  `c` VIRTUAL varbinary(10) AS (char(a,b))
+) ENGINE=MyISAM
+insert into t1 values (77,121,default);
+select * from t1;
+a	b	c
+77	121	My
+drop table t1;
+set sql_warnings = 0;
+# CHARACTER_LENGTH()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual int as (character_length(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL int AS (character_length(a))
+) ENGINE=MyISAM
+insert into t1 values ('text',default);
+select * from t1;
+a	b
+text	4
+drop table t1;
+set sql_warnings = 0;
+# CONCAT_WS()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual varchar(20) as (concat_ws(',',a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL varchar(20) AS (concat_ws(',',a,b))
+) ENGINE=MyISAM
+insert into t1 values ('value1','value2',default);
+select * from t1;
+a	b	c
+value1	value2	value1,value2
+drop table t1;
+set sql_warnings = 0;
+# CONCAT()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual varchar(20) as (concat(a,',',b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL varchar(20) AS (concat(a,',',b))
+) ENGINE=MyISAM
+insert into t1 values ('value1','value2',default);
+select * from t1;
+a	b	c
+value1	value2	value1,value2
+drop table t1;
+set sql_warnings = 0;
+# ELT()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c int, d virtual varchar(10) as (elt(c,a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` int,
+  `d` VIRTUAL varchar(10) AS (elt(c,a,b))
+) ENGINE=MyISAM
+insert into t1 values ('value1','value2',1,default);
+insert into t1 values ('value1','value2',2,default);
+select * from t1;
+a	b	c	d
+value1	value2	1	value1
+value1	value2	2	value2
+drop table t1;
+set sql_warnings = 0;
+# EXPORT_SET()
+set sql_warnings = 1;
+create table t1 (a int, b virtual varchar(10) as (export_set(a,'1','0','',10)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL varchar(10) AS (export_set(a,'1','0','',10))
+) ENGINE=MyISAM
+insert into t1 values (6,default);
+select * from t1;
+a	b
+6	0110000000
+drop table t1;
+set sql_warnings = 0;
+# FIELD()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual int as (field('aa',a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL int AS (field('aa',a,b))
+) ENGINE=MyISAM
+insert into t1 values ('aa','bb',default);
+insert into t1 values ('bb','aa',default);
+select * from t1;
+a	b	c
+aa	bb	1
+bb	aa	2
+drop table t1;
+set sql_warnings = 0;
+# FIND_IN_SET()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual int as (find_in_set(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL int AS (find_in_set(a,b))
+) ENGINE=MyISAM
+insert into t1 values ('aa','aa,bb,cc',default);
+insert into t1 values ('aa','bb,aa,cc',default);
+select * from t1;
+a	b	c
+aa	aa,bb,cc	1
+aa	bb,aa,cc	2
+drop table t1;
+set sql_warnings = 0;
+# FORMAT()
+set sql_warnings = 1;
+create table t1 (a double, b virtual varchar(20) as (format(a,2)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL varchar(20) AS (format(a,2))
+) ENGINE=MyISAM
+insert into t1 values (12332.123456,default);
+select * from t1;
+a	b
+12332.123456	12,332.12
+drop table t1;
+set sql_warnings = 0;
+# HEX()
+set sql_warnings = 1;
+create table t1 (a double, b virtual varchar(10) as (hex(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` double,
+  `b` VIRTUAL varchar(10) AS (hex(a))
+) ENGINE=MyISAM
+insert into t1 values (17,default);
+select * from t1;
+a	b
+17	11
+drop table t1;
+set sql_warnings = 0;
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (hex(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (hex(a))
+) ENGINE=MyISAM
+insert into t1 values ('abc',default);
+select * from t1;
+a	b
+abc	616263
+drop table t1;
+set sql_warnings = 0;
+# INSERT()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual varchar(20) as (insert(a,length(a),length(b),b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL varchar(20) AS (insert(a,length(a),length(b),b))
+) ENGINE=MyISAM
+insert into t1 values ('start,','end',default);
+select * from t1;
+a	b	c
+start,	end	startend
+drop table t1;
+set sql_warnings = 0;
+# INSTR()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual int as (instr(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL int AS (instr(a,b))
+) ENGINE=MyISAM
+insert into t1 values ('foobarbar,','bar',default);
+insert into t1 values ('xbar,','foobar',default);
+select * from t1;
+a	b	c
+foobarbar,	bar	4
+xbar,	foobar	0
+drop table t1;
+set sql_warnings = 0;
+# LCASE()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (lcase(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (lcase(a))
+) ENGINE=MyISAM
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+MySQL	mysql
+drop table t1;
+set sql_warnings = 0;
+# LEFT()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(5) as (left(a,5)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(5) AS (left(a,5))
+) ENGINE=MyISAM
+insert into t1 values ('foobarbar',default);
+select * from t1;
+a	b
+foobarbar	fooba
+drop table t1;
+set sql_warnings = 0;
+# LENGTH()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual int as (length(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL int AS (length(a))
+) ENGINE=MyISAM
+insert into t1 values ('text',default);
+select * from t1;
+a	b
+text	4
+drop table t1;
+set sql_warnings = 0;
+# LIKE
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual bool as (a like 'H%o'));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL tinyint(1) AS (a like 'H%o')
+) ENGINE=MyISAM
+insert into t1 values ('Hello',default);
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+Hello	1
+MySQL	0
+drop table t1;
+set sql_warnings = 0;
+# LOCATE()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (locate('bar',a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (locate('bar',a))
+) ENGINE=MyISAM
+insert into t1 values ('foobarbar',default);
+select * from t1;
+a	b
+foobarbar	4
+drop table t1;
+set sql_warnings = 0;
+# LOWER()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (lower(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (lower(a))
+) ENGINE=MyISAM
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+MySQL	mysql
+drop table t1;
+set sql_warnings = 0;
+# LPAD()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (lpad(a,4,' ')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (lpad(a,4,' '))
+) ENGINE=MyISAM
+insert into t1 values ('MySQL',default);
+insert into t1 values ('M',default);
+select * from t1;
+a	b
+MySQL	MySQ
+M	   M
+drop table t1;
+set sql_warnings = 0;
+# LTRIM()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (ltrim(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (ltrim(a))
+) ENGINE=MyISAM
+insert into t1 values ('  MySQL',default);
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+  MySQL	MySQL
+MySQL	MySQL
+drop table t1;
+set sql_warnings = 0;
+# MAKE_SET()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c int, d virtual varchar(30) as (make_set(c,a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` int,
+  `d` VIRTUAL varchar(30) AS (make_set(c,a,b))
+) ENGINE=MyISAM
+insert into t1 values ('a','b',1,default);
+insert into t1 values ('a','b',3,default);
+select * from t1;
+a	b	c	d
+a	b	1	a
+a	b	3	a,b
+drop table t1;
+set sql_warnings = 0;
+# MID()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (mid(a,1,2)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (mid(a,1,2))
+) ENGINE=MyISAM
+insert into t1 values ('foobarbar',default);
+select * from t1;
+a	b
+foobarbar	fo
+drop table t1;
+set sql_warnings = 0;
+# NOT LIKE
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual bool as (a not like 'H%o'));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL tinyint(1) AS (a not like 'H%o')
+) ENGINE=MyISAM
+insert into t1 values ('Hello',default);
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+Hello	0
+MySQL	1
+drop table t1;
+set sql_warnings = 0;
+# OCTET_LENGTH()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual int as (octet_length(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL int AS (octet_length(a))
+) ENGINE=MyISAM
+insert into t1 values ('text',default);
+select * from t1;
+a	b
+text	4
+drop table t1;
+set sql_warnings = 0;
+# ORD()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual int as (ord(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL int AS (ord(a))
+) ENGINE=MyISAM
+insert into t1 values ('2',default);
+select * from t1;
+a	b
+2	50
+drop table t1;
+set sql_warnings = 0;
+# POSITION()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (position('bar' in a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (position('bar' in a))
+) ENGINE=MyISAM
+insert into t1 values ('foobarbar',default);
+select * from t1;
+a	b
+foobarbar	4
+drop table t1;
+set sql_warnings = 0;
+# QUOTE()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (quote(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (quote(a))
+) ENGINE=MyISAM
+insert into t1 values ('Don\'t',default);
+select * from t1;
+a	b
+Don't	'Don\'t'
+drop table t1;
+set sql_warnings = 0;
+# REPEAT()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(30) as (repeat(a,3)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(30) AS (repeat(a,3))
+) ENGINE=MyISAM
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+MySQL	MySQLMySQLMySQL
+drop table t1;
+set sql_warnings = 0;
+# REPLACE()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(30) as (replace(a,'aa','bb')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(30) AS (replace(a,'aa','bb'))
+) ENGINE=MyISAM
+insert into t1 values ('maa',default);
+select * from t1;
+a	b
+maa	mbb
+drop table t1;
+set sql_warnings = 0;
+# REVERSE()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(30) as (reverse(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(30) AS (reverse(a))
+) ENGINE=MyISAM
+insert into t1 values ('maa',default);
+select * from t1;
+a	b
+maa	aam
+drop table t1;
+set sql_warnings = 0;
+# RIGHT()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (right(a,4)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (right(a,4))
+) ENGINE=MyISAM
+insert into t1 values ('foobarbar',default);
+select * from t1;
+a	b
+foobarbar	rbar
+drop table t1;
+set sql_warnings = 0;
+# RPAD()
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (rpad(a,4,'??')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (rpad(a,4,'??'))
+) ENGINE=MyISAM
+insert into t1 values ('He',default);
+select * from t1;
+a	b
+He	He??
+drop table t1;
+set sql_warnings = 0;
+# RTRIM();
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (rtrim(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (rtrim(a))
+) ENGINE=MyISAM
+insert into t1 values ('Hello  ',default);
+select * from t1;
+a	b
+Hello  	Hello
+drop table t1;
+set sql_warnings = 0;
+# SPACE()
+set sql_warnings = 1;
+create table t1 (a varchar(5), b virtual varchar(10) as (concat(a,space(5))));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(5),
+  `b` VIRTUAL varchar(10) AS (concat(a,space(5)))
+) ENGINE=MyISAM
+insert into t1 values ('Hello', default);
+select * from t1;
+a	b
+Hello	Hello     
+drop table t1;
+set sql_warnings = 0;
+# STRCMP()
+set sql_warnings = 1;
+create table t1 (a varchar(9), b varchar(9), c virtual tinyint as (strcmp(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(9),
+  `b` varchar(9),
+  `c` VIRTUAL tinyint(4) AS (strcmp(a,b))
+) ENGINE=MyISAM
+insert into t1 values ('Hello','Hello', default);
+insert into t1 values ('Hello','Hello1', default);
+select * from t1;
+a	b	c
+Hello	Hello	0
+Hello	Hello1	-1
+drop table t1;
+set sql_warnings = 0;
+# SUBSTR()
+set sql_warnings = 1;
+create table t1 (a varchar(5), b virtual varchar(10) as (substr(a,2)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(5),
+  `b` VIRTUAL varchar(10) AS (substr(a,2))
+) ENGINE=MyISAM
+insert into t1 values ('Hello',default);
+select * from t1;
+a	b
+Hello	ello
+drop table t1;
+set sql_warnings = 0;
+# SUBSTRING_INDEX()
+set sql_warnings = 1;
+create table t1 (a varchar(15), b virtual varchar(10) as (substring_index(a,'.',2)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(15),
+  `b` VIRTUAL varchar(10) AS (substring_index(a,'.',2))
+) ENGINE=MyISAM
+insert into t1 values ('www.mysql.com',default);
+select * from t1;
+a	b
+www.mysql.com	www.mysql
+drop table t1;
+set sql_warnings = 0;
+# SUBSTRING()
+set sql_warnings = 1;
+create table t1 (a varchar(5), b virtual varchar(10) as (substring(a from 2 for 2)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(5),
+  `b` VIRTUAL varchar(10) AS (substring(a from 2 for 2))
+) ENGINE=MyISAM
+insert into t1 values ('Hello',default);
+select * from t1;
+a	b
+Hello	el
+drop table t1;
+set sql_warnings = 0;
+# TRIM()
+set sql_warnings = 1;
+create table t1 (a varchar(15), b virtual varchar(10) as (trim(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(15),
+  `b` VIRTUAL varchar(10) AS (trim(a))
+) ENGINE=MyISAM
+insert into t1 values (' aa ',default);
+select * from t1;
+a	b
+ aa 	aa
+drop table t1;
+set sql_warnings = 0;
+# UCASE()
+set sql_warnings = 1;
+create table t1 (a varchar(5), b virtual varchar(10) as (ucase(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(5),
+  `b` VIRTUAL varchar(10) AS (ucase(a))
+) ENGINE=MyISAM
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+MySQL	MYSQL
+drop table t1;
+set sql_warnings = 0;
+# UNHEX()
+set sql_warnings = 1;
+create table t1 (a varchar(15), b virtual varchar(10) as (unhex(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(15),
+  `b` VIRTUAL varchar(10) AS (unhex(a))
+) ENGINE=MyISAM
+insert into t1 values ('4D7953514C',default);
+select * from t1;
+a	b
+4D7953514C	MySQL
+drop table t1;
+set sql_warnings = 0;
+# UPPER()
+set sql_warnings = 1;
+create table t1 (a varchar(5), b virtual varchar(10) as (upper(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(5),
+  `b` VIRTUAL varchar(10) AS (upper(a))
+) ENGINE=MyISAM
+insert into t1 values ('MySQL',default);
+select * from t1;
+a	b
+MySQL	MYSQL
+drop table t1;
+set sql_warnings = 0;
+#
+# CONTROL FLOW FUNCTIONS
+#
+# CASE
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(16) as (case a when NULL then 'asd' when 'b' then 'B' else a end));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(16) AS (case a when NULL then 'asd' when 'b' then 'B' else a end)
+) ENGINE=MyISAM
+insert into t1 values (NULL,default);
+insert into t1 values ('b',default);
+insert into t1 values ('c',default);
+select * from t1;
+a	b
+NULL	NULL
+b	B
+c	c
+drop table t1;
+set sql_warnings = 0;
+# IF
+set sql_warnings = 1;
+create table t1 (a int, b int, c virtual int as (if(a=1,a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` int,
+  `c` VIRTUAL int AS (if(a=1,a,b))
+) ENGINE=MyISAM
+insert into t1 values (1,2,default);
+insert into t1 values (3,4,default);
+select * from t1;
+a	b	c
+1	2	1
+3	4	4
+drop table t1;
+set sql_warnings = 0;
+# IFNULL
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual varchar(10) as (ifnull(a,'DEFAULT')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL varchar(10) AS (ifnull(a,'DEFAULT'))
+) ENGINE=MyISAM
+insert into t1 values (NULL,'adf',default);
+insert into t1 values ('a','adf',default);
+select * from t1;
+a	b	c
+NULL	adf	DEFAULT
+a	adf	a
+drop table t1;
+set sql_warnings = 0;
+# NULLIF
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varchar(10) as (nullif(a,'DEFAULT')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varchar(10) AS (nullif(a,'DEFAULT'))
+) ENGINE=MyISAM
+insert into t1 values ('DEFAULT',default);
+insert into t1 values ('a',default);
+select * from t1;
+a	b
+DEFAULT	NULL
+a	a
+drop table t1;
+set sql_warnings = 0;
+#
+# OPERATORS
+#
+# AND
+set sql_warnings = 1;
+create table t1 (a int, b virtual bool as (a>0 and a<2));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL tinyint(1) AS (a>0 and a<2)
+) ENGINE=MyISAM
+insert into t1 values (-1,default);
+insert into t1 values (1,default);
+select * from t1;
+a	b
+-1	0
+1	1
+drop table t1;
+set sql_warnings = 0;
+# BETWEEN ... AND ... 
+set sql_warnings = 1;
+create table t1 (a int, b virtual bool as (a between 0 and 2));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL tinyint(1) AS (a between 0 and 2)
+) ENGINE=MyISAM
+insert into t1 values (-1,default);
+insert into t1 values (1,default);
+select * from t1;
+a	b
+-1	0
+1	1
+drop table t1;
+set sql_warnings = 0;
+# BINARY
+set sql_warnings = 1;
+create table t1 (a varchar(10), b virtual varbinary(10) as (binary a));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` VIRTUAL varbinary(10) AS (binary a)
+) ENGINE=MyISAM
+insert into t1 values ('11',default);
+insert into t1 values (1,default);
+select * from t1;
+a	b
+11	11
+1	1
+drop table t1;
+set sql_warnings = 0;
+# DIV
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (a div 5));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a div 5)
+) ENGINE=MyISAM
+insert into t1 values (1,default);
+insert into t1 values (7,default);
+select * from t1;
+a	b
+1	0
+7	1
+drop table t1;
+set sql_warnings = 0;
+# <=>
+set sql_warnings = 1;
+create table t1 (a int, b int, c virtual bool as (a <=> b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` int,
+  `c` VIRTUAL tinyint(1) AS (a <=> b)
+) ENGINE=MyISAM
+insert into t1 values (1,1,default);
+insert into t1 values (NULL,NULL,default);
+insert into t1 values (1,NULL,default);
+select * from t1;
+a	b	c
+1	1	1
+NULL	NULL	1
+1	NULL	0
+drop table t1;
+set sql_warnings = 0;
+# =
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual bool as (a=b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL tinyint(1) AS (a=b)
+) ENGINE=MyISAM
+insert into t1 values ('a','b',default);
+insert into t1 values ('a','a',default);
+select * from t1;
+a	b	c
+a	b	0
+a	a	1
+drop table t1;
+set sql_warnings = 0;
+# >=
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual bool as (a >= b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL tinyint(1) AS (a >= b)
+) ENGINE=MyISAM
+insert into t1 values ('a','b',default);
+insert into t1 values ('a','a',default);
+select * from t1;
+a	b	c
+a	b	0
+a	a	1
+drop table t1;
+set sql_warnings = 0;
+# >
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual bool as (a > b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL tinyint(1) AS (a > b)
+) ENGINE=MyISAM
+insert into t1 values ('a','b',default);
+insert into t1 values ('a','a',default);
+select * from t1;
+a	b	c
+a	b	0
+a	a	0
+drop table t1;
+set sql_warnings = 0;
+# IS NOT NULL
+set sql_warnings = 1;
+create table t1 (a int, b virtual bool as (a is not null));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL tinyint(1) AS (a is not null)
+) ENGINE=MyISAM
+insert into t1 values (1,default);
+insert into t1 values (NULL,default);
+select * from t1;
+a	b
+1	1
+NULL	0
+drop table t1;
+set sql_warnings = 0;
+# IS NULL
+set sql_warnings = 1;
+create table t1 (a int, b virtual bool as (a is null));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL tinyint(1) AS (a is null)
+) ENGINE=MyISAM
+insert into t1 values (1,default);
+insert into t1 values (NULL,default);
+select * from t1;
+a	b
+1	0
+NULL	1
+drop table t1;
+set sql_warnings = 0;
+# <=
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual bool as (a <= b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL tinyint(1) AS (a <= b)
+) ENGINE=MyISAM
+insert into t1 values ('b','a',default);
+insert into t1 values ('b','b',default);
+insert into t1 values ('b','c',default);
+select * from t1;
+a	b	c
+b	a	0
+b	b	1
+b	c	1
+drop table t1;
+set sql_warnings = 0;
+# <
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual bool as (a < b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL tinyint(1) AS (a < b)
+) ENGINE=MyISAM
+insert into t1 values ('b','a',default);
+insert into t1 values ('b','b',default);
+insert into t1 values ('b','c',default);
+select * from t1;
+a	b	c
+b	a	0
+b	b	0
+b	c	1
+drop table t1;
+set sql_warnings = 0;
+# NOT BETWEEN ... AND ...
+set sql_warnings = 1;
+create table t1 (a int, b virtual bool as (a not between 0 and 2));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL tinyint(1) AS (a not between 0 and 2)
+) ENGINE=MyISAM
+insert into t1 values (-1,default);
+insert into t1 values (1,default);
+select * from t1;
+a	b
+-1	1
+1	0
+drop table t1;
+set sql_warnings = 0;
+# <>
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual bool as (a <> b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL tinyint(1) AS (a <> b)
+) ENGINE=MyISAM
+insert into t1 values ('b','a',default);
+insert into t1 values ('b','b',default);
+insert into t1 values ('b','c',default);
+select * from t1;
+a	b	c
+b	a	1
+b	b	0
+b	c	1
+drop table t1;
+set sql_warnings = 0;
+# !=
+set sql_warnings = 1;
+create table t1 (a varchar(10), b varchar(10), c virtual bool as (a != b));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10),
+  `b` varchar(10),
+  `c` VIRTUAL tinyint(1) AS (a != b)
+) ENGINE=MyISAM
+insert into t1 values ('b','a',default);
+insert into t1 values ('b','b',default);
+insert into t1 values ('b','c',default);
+select * from t1;
+a	b	c
+b	a	1
+b	b	0
+b	c	1
+drop table t1;
+set sql_warnings = 0;
+# OR
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (a>5 or a<3));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a>5 or a<3)
+) ENGINE=MyISAM
+insert into t1 values (1,default);
+insert into t1 values (4,default);
+select * from t1;
+a	b
+1	1
+4	0
+drop table t1;
+set sql_warnings = 0;
+# XOR
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (a xor 5));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (a xor 5)
+) ENGINE=MyISAM
+insert into t1 values (0,default);
+insert into t1 values (1,default);
+insert into t1 values (2,default);
+select * from t1;
+a	b
+0	1
+1	0
+2	0
+drop table t1;
+set sql_warnings = 0;
+#
+# DATE AND TIME FUNCTIONS
+#
+# ADDDATE()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (adddate(a,interval 1 month)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (adddate(a,interval 1 month))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	2008-09-30 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# ADDTIME()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (addtime(a,'02:00:00')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (addtime(a,'02:00:00'))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	2008-08-31 02:00:00
+drop table t1;
+set sql_warnings = 0;
+# DATE_ADD()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (date_add(a,interval 1 month)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (date_add(a,interval 1 month))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	2008-09-30 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# DATE_FORMAT()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual varchar(64) as (date_format(a,'%W %M %D')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL varchar(64) AS (date_format(a,'%W %M %D'))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	Sunday August 31st
+drop table t1;
+set sql_warnings = 0;
+# DATE_SUB()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (date_sub(a,interval 1 month)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (date_sub(a,interval 1 month))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	2008-07-31 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# DATE()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (date(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (date(a))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31 02:00:00',default);
+select * from t1;
+a	b
+2008-08-31 02:00:00	2008-08-31 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# DATEDIFF()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (datediff(a,'2000-01-01')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (datediff(a,'2000-01-01'))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	3165
+drop table t1;
+set sql_warnings = 0;
+# DAY()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (day(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (day(a))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	31
+drop table t1;
+set sql_warnings = 0;
+# DAYNAME()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual varchar(10) as (dayname(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL varchar(10) AS (dayname(a))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	Sunday
+drop table t1;
+set sql_warnings = 0;
+# DAYOFMONTH()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (dayofmonth(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (dayofmonth(a))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	31
+drop table t1;
+set sql_warnings = 0;
+# DAYOFWEEK()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (dayofweek(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (dayofweek(a))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	1
+drop table t1;
+set sql_warnings = 0;
+# DAYOFYEAR()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (dayofyear(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (dayofyear(a))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	244
+drop table t1;
+set sql_warnings = 0;
+# EXTRACT
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (extract(year from a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (extract(year from a))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	2008
+drop table t1;
+set sql_warnings = 0;
+# FROM_DAYS()
+set sql_warnings = 1;
+create table t1 (a int, b virtual datetime as (from_days(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL datetime AS (from_days(a))
+) ENGINE=MyISAM
+insert into t1 values (730669,default);
+select * from t1;
+a	b
+730669	2000-07-03 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# FROM_UNIXTIME()
+set sql_warnings = 1;
+create table t1 (a int, b virtual datetime as (from_unixtime(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL datetime AS (from_unixtime(a))
+) ENGINE=MyISAM
+insert into t1 values (1196440219,default);
+select * from t1;
+a	b
+1196440219	2007-11-30 19:30:19
+drop table t1;
+set sql_warnings = 0;
+# GET_FORMAT()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual varchar(32) as (date_format(a,get_format(DATE,'EUR'))));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL varchar(32) AS (date_format(a,get_format(DATE,'EUR')))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	31.08.2008
+drop table t1;
+set sql_warnings = 0;
+# HOUR()
+set sql_warnings = 1;
+create table t1 (a time, b virtual int as (hour(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` time,
+  `b` VIRTUAL int AS (hour(a))
+) ENGINE=MyISAM
+insert into t1 values ('10:05:03',default);
+select * from t1;
+a	b
+10:05:03	10
+drop table t1;
+set sql_warnings = 0;
+# LAST_DAY()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (last_day(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (last_day(a))
+) ENGINE=MyISAM
+insert into t1 values ('2003-02-05',default);
+select * from t1;
+a	b
+2003-02-05 00:00:00	2003-02-28 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# MAKEDATE()
+set sql_warnings = 1;
+create table t1 (a int, b virtual datetime as (makedate(a,1)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL datetime AS (makedate(a,1))
+) ENGINE=MyISAM
+insert into t1 values (2001,default);
+select * from t1;
+a	b
+2001	2001-01-01 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# MAKETIME()
+set sql_warnings = 1;
+create table t1 (a int, b virtual time as (maketime(a,1,3)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL time AS (maketime(a,1,3))
+) ENGINE=MyISAM
+insert into t1 values (12,default);
+select * from t1;
+a	b
+12	12:01:03
+drop table t1;
+set sql_warnings = 0;
+# MICROSECOND()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (microsecond(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (microsecond(a))
+) ENGINE=MyISAM
+insert into t1 values ('2009-12-31 12:00:00.123456',default);
+insert into t1 values ('2009-12-31 23:59:59.000010',default);
+select * from t1;
+a	b
+2009-12-31 12:00:00	0
+2009-12-31 23:59:59	0
+drop table t1;
+set sql_warnings = 0;
+# MINUTE()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (minute(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (minute(a))
+) ENGINE=MyISAM
+insert into t1 values ('2009-12-31 23:59:59.000010',default);
+select * from t1;
+a	b
+2009-12-31 23:59:59	59
+drop table t1;
+set sql_warnings = 0;
+# MONTH()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (month(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (month(a))
+) ENGINE=MyISAM
+insert into t1 values ('2009-12-31 23:59:59.000010',default);
+select * from t1;
+a	b
+2009-12-31 23:59:59	12
+drop table t1;
+set sql_warnings = 0;
+# MONTHNAME()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual varchar(16) as (monthname(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL varchar(16) AS (monthname(a))
+) ENGINE=MyISAM
+insert into t1 values ('2009-12-31 23:59:59.000010',default);
+select * from t1;
+a	b
+2009-12-31 23:59:59	December
+drop table t1;
+set sql_warnings = 0;
+# PERIOD_ADD()
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (period_add(a,2)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (period_add(a,2))
+) ENGINE=MyISAM
+insert into t1 values (200801,default);
+select * from t1;
+a	b
+200801	200803
+drop table t1;
+set sql_warnings = 0;
+# PERIOD_DIFF()
+set sql_warnings = 1;
+create table t1 (a int, b int, c virtual int as (period_diff(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` int,
+  `c` VIRTUAL int AS (period_diff(a,b))
+) ENGINE=MyISAM
+insert into t1 values (200802,200703,default);
+select * from t1;
+a	b	c
+200802	200703	11
+drop table t1;
+set sql_warnings = 0;
+# QUARTER()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (quarter(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (quarter(a))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	3
+drop table t1;
+set sql_warnings = 0;
+# SEC_TO_TIME()
+set sql_warnings = 1;
+create table t1 (a int, b virtual time as (sec_to_time(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL time AS (sec_to_time(a))
+) ENGINE=MyISAM
+insert into t1 values (2378,default);
+select * from t1;
+a	b
+2378	00:39:38
+drop table t1;
+set sql_warnings = 0;
+# SECOND()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (second(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (second(a))
+) ENGINE=MyISAM
+insert into t1 values ('10:05:03',default);
+select * from t1;
+a	b
+2010-05-03 00:00:00	0
+drop table t1;
+set sql_warnings = 0;
+# STR_TO_DATE()
+set sql_warnings = 1;
+create table t1 (a varchar(64), b virtual datetime as (str_to_date(a,'%m/%d/%Y')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(64),
+  `b` VIRTUAL datetime AS (str_to_date(a,'%m/%d/%Y'))
+) ENGINE=MyISAM
+insert into t1 values ('04/30/2004',default);
+select * from t1;
+a	b
+04/30/2004	2004-04-30 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# SUBDATE()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (subdate(a,interval 1 month)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (subdate(a,interval 1 month))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	2008-07-31 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# SUBTIME()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual datetime as (subtime(a,'02:00:00')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL datetime AS (subtime(a,'02:00:00'))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31',default);
+select * from t1;
+a	b
+2008-08-31 00:00:00	2008-08-30 22:00:00
+drop table t1;
+set sql_warnings = 0;
+# TIME_FORMAT()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual varchar(32) as (time_format(a,'%r')));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL varchar(32) AS (time_format(a,'%r'))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31 02:03:04',default);
+select * from t1;
+a	b
+2008-08-31 02:03:04	02:03:04 AM
+drop table t1;
+set sql_warnings = 0;
+# TIME_TO_SEC()
+set sql_warnings = 1;
+create table t1 (a time, b virtual int as (time_to_sec(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` time,
+  `b` VIRTUAL int AS (time_to_sec(a))
+) ENGINE=MyISAM
+insert into t1 values ('22:23:00',default);
+select * from t1;
+a	b
+22:23:00	80580
+drop table t1;
+set sql_warnings = 0;
+# TIME()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual time as (time(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL time AS (time(a))
+) ENGINE=MyISAM
+insert into t1 values ('2008-08-31 02:03:04',default);
+select * from t1;
+a	b
+2008-08-31 02:03:04	02:03:04
+drop table t1;
+set sql_warnings = 0;
+# TIMEDIFF()
+set sql_warnings = 1;
+create table t1 (a datetime, b datetime, c virtual int as (timediff(a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` datetime,
+  `c` VIRTUAL int AS (timediff(a,b))
+) ENGINE=MyISAM
+insert into t1 values ('2008-12-31 23:59:59.000001','2008-12-30 01:01:01.000002',default);
+Warnings:
+Warning	1265	Data truncated for column 'c' at row 1
+select * from t1;
+a	b	c
+2008-12-31 23:59:59	2008-12-30 01:01:01	46
+drop table t1;
+set sql_warnings = 0;
+# TIMESTAMP()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual timestamp as (timestamp(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL timestamp AS (timestamp(a)) NULL ON UPDATE CURRENT_TIMESTAMP
+) ENGINE=MyISAM
+insert into t1 values ('2008-12-31',default);
+select * from t1;
+a	b
+2008-12-31 00:00:00	2008-12-31 00:00:00
+drop table t1;
+set sql_warnings = 0;
+# TIMESTAMPADD()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual timestamp as (timestampadd(minute,1,a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL timestamp AS (timestampadd(minute,1,a)) NULL ON UPDATE CURRENT_TIMESTAMP
+) ENGINE=MyISAM
+insert into t1 values ('2003-01-02',default);
+select * from t1;
+a	b
+2003-01-02 00:00:00	2003-01-02 00:01:00
+drop table t1;
+set sql_warnings = 0;
+# TIMESTAMPDIFF()
+set sql_warnings = 1;
+create table t1 (a timestamp, b timestamp, c virtual int as (timestampdiff(MONTH, a,b)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
+  `b` timestamp NOT NULL,
+  `c` VIRTUAL int AS (timestampdiff(MONTH, a,b))
+) ENGINE=MyISAM
+insert into t1 values ('2003-02-01','2003-05-01',default);
+select * from t1;
+a	b	c
+2003-02-01 00:00:00	2003-05-01 00:00:00	3
+drop table t1;
+set sql_warnings = 0;
+# TO_DAYS()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (to_days(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (to_days(a))
+) ENGINE=MyISAM
+insert into t1 values ('2007-10-07',default);
+select * from t1;
+a	b
+2007-10-07 00:00:00	733321
+drop table t1;
+set sql_warnings = 0;
+# WEEK()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (week(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (week(a))
+) ENGINE=MyISAM
+insert into t1 values ('2008-09-01',default);
+select * from t1;
+a	b
+2008-09-01 00:00:00	35
+drop table t1;
+set sql_warnings = 0;
+# WEEKDAY()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (weekday(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (weekday(a))
+) ENGINE=MyISAM
+insert into t1 values ('2008-09-01',default);
+select * from t1;
+a	b
+2008-09-01 00:00:00	0
+drop table t1;
+set sql_warnings = 0;
+# WEEKOFYEAR()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (weekofyear(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (weekofyear(a))
+) ENGINE=MyISAM
+insert into t1 values ('2008-09-01',default);
+select * from t1;
+a	b
+2008-09-01 00:00:00	36
+drop table t1;
+set sql_warnings = 0;
+# YEAR()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (year(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (year(a))
+) ENGINE=MyISAM
+insert into t1 values ('2008-09-01',default);
+select * from t1;
+a	b
+2008-09-01 00:00:00	2008
+drop table t1;
+set sql_warnings = 0;
+# YEARWEEK()
+set sql_warnings = 1;
+create table t1 (a datetime, b virtual int as (yearweek(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` datetime,
+  `b` VIRTUAL int AS (yearweek(a))
+) ENGINE=MyISAM
+insert into t1 values ('2008-09-01',default);
+select * from t1;
+a	b
+2008-09-01 00:00:00	200835
+drop table t1;
+set sql_warnings = 0;
+#
+# FULL TEXT SEARCH FUNCTIONS
+#
+# None.
+#
+# CAST FUNCTIONS AND OPERATORS
+#
+# CAST()
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (cast(a as unsigned)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (cast(a as unsigned))
+) ENGINE=MyISAM
+insert into t1 values (1,default);
+insert into t1 values (-1,default);
+Warnings:
+Warning	1264	Out of range value for column 'b' at row 1
+select * from t1;
+a	b
+1	1
+-1	2147483647
+drop table t1;
+set sql_warnings = 0;
+# Convert()
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (convert(a,unsigned)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (convert(a,unsigned))
+) ENGINE=MyISAM
+insert into t1 values (1,default);
+insert into t1 values (-1,default);
+Warnings:
+Warning	1264	Out of range value for column 'b' at row 1
+select * from t1;
+a	b
+1	1
+-1	2147483647
+drop table t1;
+set sql_warnings = 0;
+#
+# OTHER FUNCTIONS
+#
+# BIT_COUNT()
+set sql_warnings = 1;
+create table t1 (a int, b virtual int as (bit_count(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` int,
+  `b` VIRTUAL int AS (bit_count(a))
+) ENGINE=MyISAM
+insert into t1 values (5,default);
+select * from t1;
+a	b
+5	2
+drop table t1;
+set sql_warnings = 0;
+# COERCIBILITY()
+set sql_warnings = 1;
+create table t1 (a varchar(1024), b virtual int as (coercibility(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(1024),
+  `b` VIRTUAL int AS (coercibility(a))
+) ENGINE=MyISAM
+insert into t1 values ('abc',default);
+select * from t1;
+a	b
+abc	2
+drop table t1;
+set sql_warnings = 0;
+# COLLATION()
+set sql_warnings = 1;
+create table t1 (a varchar(1024), b virtual varchar(1024) as (collation(a)));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(1024),
+  `b` VIRTUAL varchar(1024) AS (collation(a))
+) ENGINE=MyISAM
+insert into t1 values ('abc',default);
+select * from t1;
+a	b
+abc	utf8_general_ci
+drop table t1;
+set sql_warnings = 0;
+# DEFAULT()
+set sql_warnings = 1;
+create table t1 (a varchar(1024) default 'aaa', b virtual varchar(1024) as (ifnull(a,default(a))));
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(1024),
+  `b` VIRTUAL varchar(1024) AS (ifnull(a,default(a)))
+) ENGINE=MyISAM
+insert into t1 values ('any value',default);
+select * from t1;
+a	b
+any value	any value
+drop table t1;
+set sql_warnings = 0;
+DROP TABLE IF EXISTS t1,t2,t3;
+set sql_warnings = 0;

=== added directory 'tests/suite/vcol/t'
=== added file 'tests/suite/vcol/t/disabled.def'
--- tests/suite/vcol/t/disabled.def	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/disabled.def	2008-09-19 16:05:21 +0000
@@ -0,0 +1,4 @@
+vcol_csv                    : when altering a table outparam->file is 0x0 in procedure open_table_from_share
+vcol_archive                : Lost connection to server when altering a table by adding a new (even non-virtual) column
+rpl_vcol                    : Sync with master not working
+vcol_blackhole              : Temporarily disabled instead of building Drizzle with blackhole support and creating r/vcol_blackhole.result

=== added file 'tests/suite/vcol/t/rpl_vcol.test'
--- tests/suite/vcol/t/rpl_vcol.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/rpl_vcol.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,69 @@
+################################################################################
+# t/vcol_rpl.test                                                              #
+#                                                                              #
+# Purpose:                                                                     #
+#   Test replication of tables with virtual columns.                           #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-04                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+--source include/have_innodb.inc
+SET @@session.storage_engine = 'InnoDB';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+--source include/master-slave.inc
+
+connection master;
+create table t1 (a int, b virtual int as (a+1));
+show create table t1;
+insert into t1 values (1,default);
+insert into t1 values (2,default);
+select * from t1;
+save_master_pos;
+
+connection slave;
+sync_with_master;
+select * from t1;
+
+connection master;
+drop table t1;
+save_master_pos;
+
+connection slave;
+sync_with_master;
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_archive.test'
--- tests/suite/vcol/t/vcol_archive.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_archive.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,49 @@
+################################################################################
+# t/vcol_archive.test                                                          #
+#                                                                              #
+# Purpose:                                                                     #
+#        ARCHIVE branch                                                        #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-02                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+--source include/have_archive.inc
+SET @@session.storage_engine = 'archive';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+--source suite/vcol/inc/vcol_unsupported_storage_engines.inc
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_blackhole.test'
--- tests/suite/vcol/t/vcol_blackhole.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_blackhole.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,49 @@
+################################################################################
+# t/vcol_blackhole.test                                                        #
+#                                                                              #
+# Purpose:                                                                     #
+#        BLACKHOLE branch                                                      #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-02                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+--source include/have_blackhole.inc
+SET @@session.storage_engine = 'blackhole';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+--source suite/vcol/inc/vcol_unsupported_storage_engines.inc
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_blocked_sql_funcs_innodb.test'
--- tests/suite/vcol/t/vcol_blocked_sql_funcs_innodb.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_blocked_sql_funcs_innodb.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,52 @@
+################################################################################
+# t/vcol_supported_sql_funcs.test                                              #
+#                                                                              #
+# Purpose:                                                                     #
+#  Test SQL functions not allowed for virtual columns                          #
+#        InnoDB branch                                                         #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-08-31                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+--source include/have_innodb.inc
+eval SET @@session.storage_engine = 'InnoDB';
+
+let $skip_full_text_checks = 1;
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+--source suite/vcol/inc/vcol_blocked_sql_funcs_main.inc
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_blocked_sql_funcs_myisam.test'
--- tests/suite/vcol/t/vcol_blocked_sql_funcs_myisam.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_blocked_sql_funcs_myisam.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,49 @@
+################################################################################
+# t/vcol_supported_sql_funcs.test                                              #
+#                                                                              #
+# Purpose:                                                                     #
+#  Test SQL functions not allowed for virtual columns                          #
+#        MyISAM branch                                                         #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-08-31                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+eval SET @@session.storage_engine = 'MyISAM';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+--source suite/vcol/inc/vcol_blocked_sql_funcs_main.inc
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_column_def_options_innodb.test'
--- tests/suite/vcol/t/vcol_column_def_options_innodb.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_column_def_options_innodb.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,51 @@
+################################################################################
+# t/vcol_column_def_options_innodb.test                                        #
+#                                                                              #
+# Purpose:                                                                     #
+#  Testing different optional parameters of virtual columns.                   #
+#                                                                              #
+#        InnoDB branch                                                         #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-02                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+--source include/have_innodb.inc
+eval SET @@session.storage_engine = 'InnoDB';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+--source suite/vcol/inc/vcol_column_def_options.inc
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_column_def_options_myisam.test'
--- tests/suite/vcol/t/vcol_column_def_options_myisam.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_column_def_options_myisam.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,50 @@
+################################################################################
+# t/vcol_column_def_options_myisam.test                                        #
+#                                                                              #
+# Purpose:                                                                     #
+#  Testing different optional parameters of virtual columns.                   #
+#                                                                              #
+#        MyISAM branch                                                         #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-02                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+eval SET @@session.storage_engine = 'MyISAM';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+--source suite/vcol/inc/vcol_column_def_options.inc
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_csv.test'
--- tests/suite/vcol/t/vcol_csv.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_csv.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,54 @@
+################################################################################
+# t/vcol_csv.test                                                              #
+#                                                                              #
+# Purpose:                                                                     #
+#        CSV branch                                                            #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-02                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+--source include/have_csv.inc
+SET @@session.storage_engine = 'CSV';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+--error ER_UNSUPPORTED_ACTION_ON_VIRTUAL_COLUMN
+create table t1 (a int, b virtual int as (a+1));
+create table t1 (a int not null);
+--error 1178
+alter table t1 add column b virtual int as (a+1);
+drop table t1;
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_ins_upd_innodb.test'
--- tests/suite/vcol/t/vcol_ins_upd_innodb.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_ins_upd_innodb.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,51 @@
+################################################################################
+# t/vcol_ins_upd_innodb.test                                                   #
+#                                                                              #
+# Purpose:                                                                     #
+#  Testing DDL operations such as INSERT, UPDATE, REPLACE and DELETE.          #
+#                                                                              #
+#        InnoDB branch                                                         #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-04                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+--source include/have_innodb.inc
+eval SET @@session.storage_engine = 'InnoDB';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+--source suite/vcol/inc/vcol_ins_upd.inc
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_ins_upd_myisam.test'
--- tests/suite/vcol/t/vcol_ins_upd_myisam.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_ins_upd_myisam.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,50 @@
+################################################################################
+# t/vcol_ins_upd_myisam.test                                                   #
+#                                                                              #
+# Purpose:                                                                     #
+#  Testing DDL operations such as INSERT, UPDATE, REPLACE and DELETE.          #
+#                                                                              #
+#        MyISAM branch                                                         #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-04                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+eval SET @@session.storage_engine = 'MyISAM';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+--source suite/vcol/inc/vcol_ins_upd.inc
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_keys_innodb.test'
--- tests/suite/vcol/t/vcol_keys_innodb.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_keys_innodb.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,52 @@
+################################################################################
+# t/vcol_keys_innodb.test                                                      #
+#                                                                              #
+# Purpose:                                                                     #
+#  Testing keys, indexes defined upon virtual columns.                         # 
+#                                                                              #
+#        InnoDB branch                                                         #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-04                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+--source include/have_innodb.inc
+eval SET @@session.storage_engine = 'InnoDB';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+let $skip_spatial_index_check = 1;
+--source suite/vcol/inc/vcol_keys.inc
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_keys_myisam.test'
--- tests/suite/vcol/t/vcol_keys_myisam.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_keys_myisam.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,50 @@
+################################################################################
+# t/vcol_keys_myisam.test                                                      #
+#                                                                              #
+# Purpose:                                                                     #
+#  Testing keys, indexes defined upon virtual columns.                         # 
+#                                                                              #
+#        MyISAM branch                                                         #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-04                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+eval SET @@session.storage_engine = 'MyISAM';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+--source suite/vcol/inc/vcol_keys.inc
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_memory.test'
--- tests/suite/vcol/t/vcol_memory.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_memory.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,48 @@
+################################################################################
+# t/vcol_memory.test                                                           #
+#                                                                              #
+# Purpose:                                                                     #
+#        MEMORY branch                                                         #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-02                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+SET @@session.storage_engine = 'memory';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+--source suite/vcol/inc/vcol_unsupported_storage_engines.inc
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_non_stored_columns_innodb.test'
--- tests/suite/vcol/t/vcol_non_stored_columns_innodb.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_non_stored_columns_innodb.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,53 @@
+################################################################################
+# t/vcol_non_stored_columns_innodb.test                                        #
+#                                                                              #
+# Purpose:                                                                     #
+#  Ensure that MySQL behaviour is consistent irrelevant of                     #
+#    - the place of a non-stored column among other columns,                   #
+#    - the total number of non-stored fields.                                  #
+#                                                                              #
+#        InnoDB branch                                                         #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-04                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+--source include/have_innodb.inc
+eval SET @@session.storage_engine = 'InnoDB';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+--source suite/vcol/inc/vcol_non_stored_columns.inc
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_non_stored_columns_myisam.test'
--- tests/suite/vcol/t/vcol_non_stored_columns_myisam.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_non_stored_columns_myisam.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,52 @@
+################################################################################
+# t/vcol_non_stored_columns_myisam.test                                        #
+#                                                                              #
+# Purpose:                                                                     #
+#  Ensure that MySQL behaviour is consistent irrelevant of                     #
+#    - the place of a non-stored column among other columns,                   #
+#    - the total number of non-stored fields.                                  #
+#                                                                              #
+#        MyISAM branch                                                         #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-04                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+eval SET @@session.storage_engine = 'MyISAM';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+--source suite/vcol/inc/vcol_non_stored_columns.inc
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_select_innodb.test'
--- tests/suite/vcol/t/vcol_select_innodb.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_select_innodb.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,51 @@
+################################################################################
+# t/vcol_select_innodb.test                                                    #
+#                                                                              #
+# Purpose:                                                                     #
+#  Testing different SELECTs.                                                  #
+#                                                                              #
+#        InnoDB branch                                                         #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-18                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+--source include/have_innodb.inc
+eval SET @@session.storage_engine = 'InnoDB';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+--source suite/vcol/inc/vcol_select.inc
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_select_myisam.test'
--- tests/suite/vcol/t/vcol_select_myisam.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_select_myisam.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,50 @@
+################################################################################
+# t/vcol_select.test                                                           #
+#                                                                              #
+# Purpose:                                                                     #
+#  Testing different SELECTs.                                                  #
+#                                                                              #
+#        MyISAM branch                                                         #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-09-18                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+eval SET @@session.storage_engine = 'MyISAM';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+--source suite/vcol/inc/vcol_select.inc
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_supported_sql_funcs_innodb.test'
--- tests/suite/vcol/t/vcol_supported_sql_funcs_innodb.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_supported_sql_funcs_innodb.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,50 @@
+################################################################################
+# t/vcol_supported_sql_funcs.test                                              #
+#                                                                              #
+# Purpose:                                                                     #
+#  Test SQL functions allowed for virtual columns                              #
+#        InnoDB branch                                                         #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-08-31                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+--source include/have_innodb.inc
+SET @@session.storage_engine = 'InnoDB';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+--source suite/vcol/inc/vcol_supported_sql_funcs_main.inc
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

=== added file 'tests/suite/vcol/t/vcol_supported_sql_funcs_myisam.test'
--- tests/suite/vcol/t/vcol_supported_sql_funcs_myisam.test	1970-01-01 00:00:00 +0000
+++ tests/suite/vcol/t/vcol_supported_sql_funcs_myisam.test	2008-09-19 11:49:17 +0000
@@ -0,0 +1,49 @@
+################################################################################
+# t/vcol_supported_sql_funcs.test                                              #
+#                                                                              #
+# Purpose:                                                                     #
+#  Test SQL functions allowed for virtual columns                              #
+#        MyISAM branch                                                         #
+#                                                                              #
+#------------------------------------------------------------------------------#
+# Original Author: Andrey Zhakov                                               #
+# Original Date: 2008-08-31                                                    #
+# Change Author:                                                               #
+# Change Date:                                                                 #
+# Change:                                                                      #
+################################################################################
+
+#
+# NOTE: PLEASE DO NOT ADD NOT MYISAM SPECIFIC TESTCASES HERE !
+#       TESTCASES WHICH MUST BE APPLIED TO ALL STORAGE ENGINES MUST BE ADDED IN
+#       THE SOURCED FILES ONLY.
+#
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc
+
+#------------------------------------------------------------------------------#
+# General not engine specific settings and requirements
+--source suite/vcol/inc/vcol_init_vars.pre
+
+#------------------------------------------------------------------------------#
+# Engine specific settings and requirements
+
+##### Storage engine to be tested
+# Set the session storage engine
+eval SET @@session.storage_engine = 'MyISAM';
+
+##### Workarounds for known open engine specific bugs
+#     none
+
+#------------------------------------------------------------------------------#
+# Execute the tests to be applied to all storage engines
+--source suite/vcol/inc/vcol_supported_sql_funcs_main.inc
+
+#------------------------------------------------------------------------------#
+# Execute storage engine specific tests
+
+#------------------------------------------------------------------------------#
+# Cleanup
+--source suite/vcol/inc/vcol_cleanup.inc

